 /*********************************************************************************/
/*                                                                               */
/*                      FREE-DCC-2008-PC : Ulysse Train System                   */
/*                                                                               */
/*     Logiciel de pilotage de reseau ferroviaire pour la carte free-dcc-2008    */
/*                                                                               */
/*********************************************************************************/
/*                                                                               */
/*  Historique:                                                                  */
/*                                                                               */
/*  15 fevrier 2011 : nouveau script                                             */
/*  deb/fin    2010 : regulateurs                                                */
/*                  : gere 4 cartes                                              */
/*                  : nouveaus itineraires                                       */
/*                  : bal                                                        */
/*                  : amelioration des graphismes                                */
/*  14 mars    2010 : Utilisation des buffers rs232 pour plus de rapidite en USB */
/*  13 mai     2009 : Ajout out/led/cli pour seq/depl                            */
/*                  : Horloge de modelisme                                       */
/*  12 mai     2009 : Ajout in_old pour la tdv                                   */
/*  22 avril   2009 : Lancement des deplacements a partir du TCO                 */
/*                  : reservation des aiguillages TCO / ITION-OFF / SEQ          */
/*  20 avril   2009 : Affichage panneau des deplacements                         */
/*  17 avril   2009 : Ajout IO / EXE / ITI et txt dans le TCO                    */
/*  15 avril   2009 : nettoyage + ameliorations                                  */
/*  14 avril   2009 : AUTO ok                                                    */
/*  13 avril   2009 : TDV ok                                                     */
/*  12 avril   2009 : TCO ok                                                     */
/*  11 avril   2009 : Ulysse Delmas-Begue: debut du projet                       */
/*                    (recuperation de train5) UTS                               */
/*                    implementation d'un TCO                                    */
/*                                                                               */
/*********************************************************************************/
/*                                                                               */
/*  Notes:                                                                       */
/*                                                                               */
/*  Ce programme Windows qui gere:                                               */
/*   - TCO                                                                       */
/*   - TDV                                                                       */
/*   - AUTO (deplacements)                                                       */
/*  est complementaire du programme DOS qui gere                                 */
/*   - TEST / DEBUG de la carte                                                  */
/*   - CONFIGURATION DE LA CENTRALE                                              */
/*   - PROGRAMMATION DES CV                                                      */
/*                                                                               */
/*********************************************************************************/
/*                                                                               */
/*  TBD:                                                                         */
/*   D TCO: rajouter I/O                                                         */
/*   D TCO: rajouter ITI                                                         */
/*   D TCO: rajouter ITI ON/OFF                                                  */
/*   D TCO: rajouter GO                                                          */
/*   D TCO: rajouter EXE/SOUND                                                   */
/*   - TCO: rajouter copier/coller                                               */
/*   - TCO: rajouter saisie chaine (au moins la correction)                      */
/*   - TCO: rajouter rendu                                                       */
/*   D TCO: rajouter lancement des deplacements                                  */
/*                                                                               */
/*   D rajouter deplacements                                                     */
/*   D chargement script des depalcements                                        */
/*   D affichage etat des deplacements                                           */
/*   - porter a 16 canaux (avec choix ds fichier)                                */
/*   - reflechir multi sequenceur                                                */
/*   D rajouter acces aux sorties / led / cli                                    */
/*   - rajouter attente positionnement des aiguillages                           */
/*   D rajouter reservation des aiguillages                                      */
/*   D rajouter choix du port serie                                              */
/*   N rajouter support multi/cartes -> non retenu (pr l'instant)                */
/*   N rajouter rs232 -> soft DOS                                                */
/*   N rajouter config carte --> soft DOS                                        */
/*   - ajouter zone de message + horloge de modelisme                            */
/*                                                                               */
/*   D menage                                                                    */
/*                                                                               */
/*   N integrer DOS -> soft DOS                                                  */
/*                                                                               */
/*  TBD reseau:                                                                  */
/*   D inverser R detection coulisse                                             */
/*   D voir PB aig depot                                                         */
/*   - (etudier) ajouter aig remisage lac                                        */
/*   - (etudier) ajouter aig(s) coulisse                                         */
/*   - voir detection depot 63000 feux eteints                                   */
/*   - ajouter detection heurtoire coulisse                                      */
/*   - goulottes electriques                                                     */
/*   - montage/demontage simple                                                  */
/*   D ajouter eclairage                                                         */
/*   D ajouter signalisation                                                     */
/*   - ajouter TCO                                                               */
/*   - montage/demontage simple                                                  */
/*   D decor                                                                     */
/*                                                                               */
/*   TBD soft                                                                    */
/*   - regu (selection centrale + protection non utilisee + auto)                */
/*   - aff (det, iti)                                                            */
/*   - script (bal, bcl)                                                         */
/*   - 4 cartes rs232                                                            */
/*                                                                               */
/*********************************************************************************/
/*                                                                               */
/*  Liste Des Sections:                                                          */
/*                                                                               */
/*   - LIAISON SERIE                                                             */
/*   - FACILITIES                                                                */
/*   - TDV                                                                       */
/*   - BMP                                                                       */
/*   - TCO                                                                       */
/*   - DEPLACEMENTS AUTOMATIQUES                                                 */
/*   - CONFIG GENERAL                                                            */
/*   - WINDOWS                                                                   */
/*                                                                               */
/*********************************************************************************/

#define TITRE      "FREE-DCC-2008/2010-PC-TCO - v0.3 Dev 21dec2010"
#define STR_ABOUT  "FREE-DCC-2008/2010-PC-TCO - v0.3 Dev 21dec2010\n\nUlysse Delmas-Begue\n\nulysse.delmas@laposte.net\n\nhttp://www.chez.com/udelmas"
#define STR_NO_CONFIG_FILE "Le fichier de configuration est introuvable \n\n UTS a besoin d'un fichier de configuration\n config.txt dans le meme repertoire que l'executable\n\n(si vous voulez juste deboguer la carte alors creez un fichier vide)\n\nFin de UTS"
#define STR_FDCC_MSGBOX_TITLE "FREE-DCC-2008/2010-PC-TCO"

#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "main.h"

HINSTANCE ghinstance;
HWND hwnd;               /* This is the handle for our window */ 
HDC hdc;
HFONT la_fonte;
HFONT cells_font;
int x_mouse,y_mouse,touche,touche_char,touche_no,x_mouse_move,y_mouse_move;
int nb_0_99=0;

#define STR_SAME 0==


#define DEBUG_PAINT        0
#define DEBUG_TOTAL_PAINT  1
#define DEBUG_MOUSE        2
#define DEBUG_KEY          3
#define DEBUG_MOUSE_RIGHT  4
#define DEBUG_TICK         5
#define DEBUG_MOUSE_UP     6
#define DEBUG_MOUSE_RIGHT_UP 7

#define MD_SCREEN_TCO0      0
#define MD_SCREEN_TCO1      1
#define MD_SCREEN_TCO2      2
#define MD_SCREEN_TCO3      3
#define MD_SCREEN_TCO4      4
#define MD_SCREEN_TCO5      5
#define MD_SCREEN_TCO6      6
#define MD_SCREEN_TCO7      7
#define MD_SCREEN_HORO      8
#define MD_SCREEN_SERIAL    9
#define MD_SCREEN_AIG      10
#define MD_SCREEN_ITI      11
#define MD_SCREEN_SELECTIF 12
#define MD_SCREEN_AUTO     13
#define MD_SCREEN_TRAIN    14
#define MD_SCREEN_CANTON   15
#define MD_SCREEN_VIB      16
#define MD_SCREEN_SPARE0   17
#define MD_SCREEN_SPARE1   18
#define MD_SCREEN_SPARE2   19
#define MD_SCREEN_SPARE3   20
#define MD_SCREEN_END      20
char* TabSzScreenMode[]= { "tco0", "tco1", "tco2", "tco3", "tco4", "tco5", "tco6", "tco7",
                          "horloge", "rs232", "aig", "iti", "selectif", "depl", "regu", "cantons", "vib",
                          "spare1", "spare2", "spare3", "spare4" };

int screen_mode=MD_SCREEN_TCO0;
int screen_zoom=0; //0=normal 1=zoom/2

int horo_j=0,horo_j_dep=0;    //global    //0-6    //por depart: 7=week 8=weekend
int horo_h=5,horo_h_dep=5;    //global    //0-23
int horo_m=0,horo_m_dep=0;    //global    //0-59
int horo_tic_on=1;            //global
int horo_blocked=0;           //global
int horo_tic_min=40;          //global   //10s
int horo_tic_dec=0;           //global


/* variables de debug */
int rs_tic_cpt=0,tc,tcstart,tcstartcstart,tp10s,rs_tic_cpt_start,timettrx=0,rs_err=0,rs_debug=0;


#define BAL_CANT_NB 32
int bal_cant[BAL_CANT_NB][6];
#define BAL_CANT_TR  0   //0=pas de train
#define BAL_CANT_VIT_TYPE 1
#define BAL_CANT_VIT_TYPE_ZERO 0
#define BAL_CANT_VIT_TYPE_RAL  1
#define BAL_CANT_VIT_TYPE_MAX  2
#define BAL_CANT_VIT      2
#define BAL_CANT_OLD      3
#define BAL_CANT_VER_MANU 4  //verouillage (ie: train en manuel)
#define BAL_CANT_PRE_RES  5

int disp_bal=1;
int disp_grid=1;

void get_bal(char* sz, int* bal, int* tr, int* vit, int* vit_type, int* old, int* res, int* pre_res)
{
    char* pt;
    int no_bal;

    *bal=99; *tr=0; *vit=0; *vit_type=BAL_CANT_VIT_TYPE_ZERO;
    pt=strstr(sz,"bal:");
    if(pt==NULL) return;
    no_bal=atoi(pt+4);
    if(no_bal<0 ||no_bal>=BAL_CANT_NB) return;

    *bal=no_bal;
    *tr=bal_cant[no_bal][BAL_CANT_TR];
    *vit=bal_cant[no_bal][BAL_CANT_VIT];
    *vit_type=bal_cant[no_bal][BAL_CANT_VIT_TYPE];
    *old=bal_cant[no_bal][BAL_CANT_OLD];
    *res=bal_cant[no_bal][BAL_CANT_VER_MANU];
    *pre_res=bal_cant[no_bal][BAL_CANT_PRE_RES];
}

void bal_init(void)
{
    int i;

    for(i=0;i<BAL_CANT_NB;i++)
    {
        bal_cant[i][BAL_CANT_TR ]=0;
        bal_cant[i][BAL_CANT_VIT]=0;
        bal_cant[i][BAL_CANT_VIT_TYPE]=BAL_CANT_VIT_TYPE_ZERO;
        bal_cant[i][BAL_CANT_OLD]=0;
        bal_cant[i][BAL_CANT_VER_MANU]=0;
        bal_cant[i][BAL_CANT_PRE_RES]=0;
    }
}

void set_clr_bal_res(char* sz)
{
    int bal,tr,nul,res,pre_res;

    get_bal(sz, &bal, &tr, &nul, &nul, &nul, &res, &pre_res);
    if(bal==99) return;

    if(res)
       bal_cant[bal][BAL_CANT_VER_MANU]=0;
    else
       if(tr==0 && res==0) bal_cant[bal][BAL_CANT_VER_MANU]=1;
}

// 32 real aigs + 8 virt + lib
#define ITI_TAB_NB          100
#define ITI_TAB_NB_AIG       40
#define ITI_TAB_IND_LIB      40   //pos=DA -1=TP -2=direct
#define ITI_TAB_IND_STATE    41
#define ITI_TAB_IND_CMD_ON   42
#define ITI_TAB_IND_CMD_OFF  43
#define ITI_TAB_IND_CMD_CHG  44
#define ITI_TAB_IND_OK       45
#define ITI_TAB_IND_LED      46
#define ITI_TAB_SIZE         47
int iti_tab[ITI_TAB_NB][ITI_TAB_SIZE];
#define ITI_TAB_NO_AIG -1
#define ITI_TAB_DIR_AIG 0
#define ITI_TAB_DEV_AIG 1
#define ITI_TAB_OFF     0
#define ITI_TAB_ATT_RES 1
#define ITI_TAB_ATT_AIG 2
#define ITI_TAB_ON      3

/*****************************************************************************/
/* LIAISON SERIE                                                             */
/*****************************************************************************/

/*------------------------------------------------------------------------------
NAME  : cSerial

DESCR : class cSerial: Permet de communiquer avec la carte.

NOTES :
------------------------------------------------------------------------------*/
class cSerial
{
    public:

    DCB     dcb;          // description de la liaison serie
    HANDLE  hCom;         // handler sur la liaison derie
    COMSTAT Status;       // pour voir si rx ok

         cSerial(void);                // constructeur (ne fait rien)
    int  init(char* name,int baud);    // ouvre le port et l'initialise
    int  close(void);                  // ferme le port
    int  read(int* data);              // effectue une lecture securisee sue la rs232
    int  blocking_read_timeout_100ms(int* data); // effectue une lecture securisee sue la rs232 (attend la date pendant 100ms max)
    int  readbuff(int nb, int data[]); // lit un tableau
    int  write(int data);              // effectue une ecriture
    int  writebuff(int nb, int data[]); // envoie un tableau sur la liaison
    void dtr(int state);               // permet de mettre un etat sur la ligne DTR
    void rts(int state);               // permet de mettre un etat sur la ligne RTS
    int cSerial::waitrxnb(int nb, int timeout);  // attend de recevoir le nombre specifie d'octet (ou sort si timeout)
};


/*------------------------------------------------------------------------------
NAME  : cSerial::cSerial
DESCR : constructeur de la classe serial.
        (ne fait rien)
ARG   : void
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
cSerial::cSerial(void)
{
}


/*------------------------------------------------------------------------------
NAME  : init
DESCR : ouvre le port serie et l'initialise
ARG   : char* name: nom du port serie (COM1,COM2...)
        int   vitesse: (9600,19200...)
RETURN: 1 OK or 0 ERROR
NOTES : l'OS ferme automatiquement les ports lorsque l'application se ermine
------------------------------------------------------------------------------*/
int cSerial::init(char* name, int baud)
{
    hCom=CreateFile(name,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
    if(hCom==INVALID_HANDLE_VALUE) { printf("Impossible d'ouvrir le port serie (CreateFile)");   return 0; }
    if(!GetCommState(hCom,&dcb))   { printf("Impossible d'ouvrir le port serie (GetCommState)"); return 0; }
    if(     baud==1200)  dcb.BaudRate = CBR_1200;
    else if(baud==2400)  dcb.BaudRate = CBR_2400;
    else if(baud==4800)  dcb.BaudRate = CBR_4800;
    else if(baud==9600)  dcb.BaudRate = CBR_9600;
    else if(baud==19200) dcb.BaudRate = CBR_19200;
    else                           { printf("La vitesse specifiee n'est pas suportee");          return 0; }
    dcb.ByteSize = 8;
    dcb.Parity   = NOPARITY;
  //dcb.StopBits = ONESTOPBIT;
    dcb.StopBits = TWOSTOPBITS;
    if(!SetCommState(hCom,&dcb))   { printf("Impossible d'ouvrir le port serie (SetCommState)"); return 0;}
    return 1;
}


/*------------------------------------------------------------------------------
NAME  : close
DESCR : ferme le port serie
ARG   : void
RETURN: 1 OK
NOTES : l'OS ferme automatiquement les ports lorsque l'application se termine
------------------------------------------------------------------------------*/
int cSerial::close(void)
{
    //fclose(hCom); //pose PB de compilation si on le decommente: comprendre pourquoi
    if (CloseHandle(hCom) == 0) return 0;
    return 1;
}


/*------------------------------------------------------------------------------
NAME  : cSerial::read
DESCR : effectue une lecture securise d'un octet sur la rs232
ARG   : int* data pointeur sur la donnee lue
RETURN: 1 ok or 0 nothing
NOTES : none
------------------------------------------------------------------------------*/
int cSerial::read(int* data)
{
    *data=0;
    DWORD num;
    DWORD buf[1];
    DWORD No_Error;

    ClearCommError(hCom,&No_Error,&Status);
    if(Status.cbInQue==0) return 0;
    ReadFile(hCom,buf,1,&num,NULL);
    *data=(int)(buf[0]&0xff);
    return 1;
}

/*------------------------------------------------------------------------------
NAME  : cSerial::readbuff
DESCR : lit un tableau
ARG   : nombre max de lectue
RETURN: nombre delecture
NOTES : none
------------------------------------------------------------------------------*/
int cSerial::readbuff(int nb, int data[])
{
    int i,in;
    DWORD num;
    unsigned char buf[256]; //DWORD
    DWORD No_Error;

    ClearCommError(hCom,&No_Error,&Status);
    in=Status.cbInQue; //printf("\nnb=%d",in);
    if(in==0) return 0;
    if(in<nb) nb=in;

    ReadFile(hCom,buf,nb,&num,NULL);

    for(i=0;i<num;i++) data[i]=(int)(buf[i]&0xff);

    return num;
}



/*------------------------------------------------------------------------------
NAME  : cSerial::waitrxnb
DESCR : attend de recevoir le nombre specifie d'octet (ou sort si timeout)
ARG   : nombre d'octets attendu / timeout ms
RETURN: nombre delecture
NOTES : none
------------------------------------------------------------------------------*/
int cSerial::waitrxnb(int nb, int timeout)
{
    int i,in;
    DWORD No_Error;

    timettrx=0;
    if(timeout<10) timeout=10;
   // timeout=timeout/10;
    for(i=0;i<timeout;i++)
    {
        ClearCommError(hCom,&No_Error,&Status);
        in=Status.cbInQue; //printf("\nnb=%d",in);
        if(in>=nb) break;
        //Sleep(10); timettrx+=10;
        Sleep(1); timettrx+=1;
    }
    return in;
}


/*------------------------------------------------------------------------------
NAME  : cSerial::blocking_read_timeout_100ms
DESCR : effectue une lecture securise d'un octet sur la rs232 (attend la date pendant 100ms max)
ARG   : int* data pointeur sur la donnee lue
RETURN: 1 ok or 0 nothing
NOTES : non utilisee
------------------------------------------------------------------------------*/
int cSerial::blocking_read_timeout_100ms(int* data)
{
    *data=0;
    DWORD num;
    DWORD buf[1];
    DWORD No_Error;
    int i;

    i=0;
    do
    {
        ClearCommError(hCom,&No_Error,&Status);
        if(Status.cbInQue==0) {Sleep(1); i++; if(i==100) return 0;}
    }
    while(Status.cbInQue==0);

    ReadFile(hCom,buf,1,&num,NULL);
    *data=(int)buf[0];
    *data=(*data)&0xff;
    return 1;
}

/*------------------------------------------------------------------------------
NAME  : cSerial::write
DESCR : ecrit 1 octet
ARG   : void
RETURN: 1 ok
NOTES : none
------------------------------------------------------------------------------*/
int cSerial::write(int data)
{
    DWORD num;
    DWORD buf[1];

    buf[0]=(DWORD)(data&0xff);
    WriteFile(hCom,buf,1,&num,NULL);
    return 1;
}


/*------------------------------------------------------------------------------
NAME  : cSerial::write
DESCR : ecrit un tableau
ARG   : void
RETURN: nombre d'ecritz
NOTES : none
------------------------------------------------------------------------------*/
int cSerial::writebuff(int nb, int data[])
{
    DWORD num;
    unsigned char buf[256]; //DWORD
    int i;

    for(i=0;i<nb;i++) buf[i]=(unsigned char)(data[i]&0xff);
    WriteFile(hCom,buf,(DWORD)nb,&num,NULL);
    return num;
}


/*------------------------------------------------------------------------------
NAME  : cSerial::dtr
DESCR : permet de mettre un etat sur la ligne DTR
ARG   : int state: etat de la ligne DTR: 0 pour -12V et 1 pour +12V
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
void cSerial::dtr(int state)
{
    if(state==0) EscapeCommFunction(hCom,CLRDTR);
    else         EscapeCommFunction(hCom,SETDTR);
}


/*------------------------------------------------------------------------------
NAME  : cSerial::rts
DESCR : ermet de mettre un etat sur la ligne RTS
ARG   : int state: etat de la ligne RTS: 0 pour -12V et 1 pour +12V
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
void cSerial::rts(int state)
{
    if(state==0) EscapeCommFunction(hCom,CLRRTS);
    else         EscapeCommFunction(hCom,SETRTS);
}



FILE* p_err;
void debug_file_open(char* szFilename)
{
    p_err=fopen(szFilename,"wt");
}

void debug_file_close(void)
{
    fclose(p_err);
}

/*****************************************************************************/
/* UTILISATION LIAISON SERIE                                                 */
/*****************************************************************************/

cSerial   serial0;
cSerial   serial1;
cSerial   serial2;
cSerial   serial3;
char sz_com0[100]="\\\\.\\COM0";
char sz_com1[100]="\\\\.\\COM0";
char sz_com2[100]="\\\\.\\COM0";
char sz_com3[100]="\\\\.\\COM0";
int rs232_initialized[4]={0,0,0,0};

int rs232_adr[]={0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0  };
int rs232_cmd[]={0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60 }; // 01DVVVVV D=1=av D=0=arr V0.V4.V3.V2.V1
int rs232_fct[]={0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90 }; // 100.FL.F4.F3.F2.F1
int rs232_led[4][8]={{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0}};
int rs232_cli[4][8]={{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0}};
int rs232_aig[4][4]={{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
int rs232_out[4][4]={{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};

int rs232_in[4][16];
int rs232_pos[4][8];
int rs232_mouse[4][16];
int rs232_can[4][5];

int var_aigcmd[4][32];
int var_out[4][32];
int var_led[4][64];
int var_cli[4][64];

int var_in[4][128];
int var_in_old[4][128];
int var_pos0[4][32];
int var_pos1[4][32];


int ivar_res[4][40]; // 0-pas de res / 1TXXYY / 2DDDDD / 3IIIII

int var_var[100];

void var_2_rs232(int board)
{
    int i;

    for(i=0;i<4;i++) rs232_aig[board][i]=0;
    for(i=0;i<32;i++) if(var_aigcmd[board][i]) rs232_aig[board][i/8]|=(1<<(i%8));

    for(i=0;i<4;i++) rs232_out[board][i]=0;
    for(i=0;i<32;i++) if(var_out[board][i]) rs232_out[board][i/8]|=(1<<(i%8));

    for(i=0;i<8;i++) rs232_led[board][i]=0;
    for(i=0;i<64;i++) if(var_led[board][i]) rs232_led[board][i/8]|=(1<<(i%8));

    for(i=0;i<8;i++) rs232_cli[board][i]=0;
    for(i=0;i<64;i++) if(var_cli[board][i]) rs232_cli[board][i/8]|=(1<<(i%8));
}

void rs232_2_var(int board)
{
    static int first=1;
    int i,j;

    for(i=0;i<128;i++)
    {
        var_in_old[board][i]=var_in[board][i];
        var_in[board][i]=0;
        if(rs232_in[board][i/8]&(1<<(i%8))) var_in[board][i]=1;
        if(first) var_in_old[board][i]=var_in[board][i];
    }
    first=0;

    for(j=0;j<4;j++) for(i=0;i<32;i++)
    {
        var_pos0[board][i]=0;
        if(rs232_pos[board][i/8]&(1<<(i%8))) var_pos0[board][i]=1;
        var_pos1[board][i]=0;
        if(rs232_pos[board][4+(i/8)]&(1<<(i%8))) var_pos1[board][i]=1;
    }
}

int var_in2[4][128];

void rs232_2_var_loop(int board)
{
    static int first=1;
    int i;

    for(i=0;i<128;i++)
    {
        var_in_old[board][i]=var_in[board][i];
        var_in[board][i]=var_in2[board][i];
        if(first) var_in_old[board][i]=var_in[board][i];
    }
    first=0;

    for(i=0;i<32;i++)
    {
        var_pos0[board][i]=0; if(var_aigcmd[board][i]==0) var_pos0[board][i]=1;
        var_pos1[board][i]=0; if(var_aigcmd[board][i]==1) var_pos1[board][i]=1;
    }
}

void rs232_init(void)
{
    int i,j,data;
    char szTemp[1000];

    for(i=0;i<4;i++) rs232_initialized[i]=0;

    serial0.init(sz_com0,19200);
    for(i=0;i<10;i++) { serial0.write(0);    Sleep(10); } //sync
    for(i=0;i<2 ;i++) { serial0.read(&data); Sleep(10); } //vide le buffer
    serial0.write(1); Sleep(10); serial0.read(&data);
    if(data==0x83) rs232_initialized[0]=1;

    serial1.init(sz_com1,19200);
    for(i=0;i<10;i++) { serial1.write(0);    Sleep(10); }
    for(i=0;i<2 ;i++) { serial1.read(&data); Sleep(10); }
    serial1.write(1); Sleep(10); serial1.read(&data);
    if(data==0x83) rs232_initialized[1]=1;

    serial2.init(sz_com2,19200);
    for(i=0;i<10;i++) { serial2.write(0);    Sleep(10); }
    for(i=0;i<2 ;i++) { serial2.read(&data); Sleep(10); }
    serial2.write(1); Sleep(10); serial2.read(&data);
    if(data==0x83) rs232_initialized[2]=1;

    serial3.init(sz_com3,19200);
    for(i=0;i<10;i++) { serial3.write(0);    Sleep(10); }
    for(i=0;i<2 ;i++) { serial3.read(&data); Sleep(10); }
    serial3.write(1); Sleep(10); serial3.read(&data);
    if(data==0x83) rs232_initialized[3]=1;

    for(i=0;i<100;i++) var_var[i]=0;
    for(j=0;j<4;j++) for(i=0;i<40 ;i++) ivar_res[j][i]=0;

    if(rs232_initialized[0]==0 && rs232_initialized[1]==0 && rs232_initialized[2]==0 && rs232_initialized[3]==0)
    {
        MessageBox(NULL,"Probleme de communication (Aucune carte detectee)\n\nFonctionnement en mode deconnecte",STR_FDCC_MSGBOX_TITLE,MB_OK|MB_ICONERROR);
    }
    else
    {
        sprintf(szTemp,"Etat d detection des cartes:\n\n- carte 0 = %d\n- carte 1 = %d\n- carte 2 = %d\n- carte 3 = %d\n\n(1=carte detectee/0=carte non detectee)"
            ,rs232_initialized[0],rs232_initialized[1],rs232_initialized[2], rs232_initialized[3]);
        MessageBox(NULL,szTemp ,STR_FDCC_MSGBOX_TITLE,MB_OK|MB_ICONINFORMATION);
    }
}

//ancien transfer plus utilise
#ifdef DIS
void rs232_txrx_masse_(void)
{
    int i,data;
    static int cpt=0;

    serial.write(9); Sleep(10); //transfert de masse

    // PC->UC: ADR(16)+CMD(16)+FCT(16)+LED(8)+CLI(8)+AIG(4)+OUT(4)
    // UC->PC: IN_MEM(8)+AIG_POS(8)+MOUSE_W(16)+can%8_pour_le_reste

    for(i=0;i<72;i++)
    {
        if(i>=0  && i<=15) data=rs232_adr[i-0 ];
        if(i>=16 && i<=31) data=rs232_cmd[i-16];
        if(i>=32 && i<=47) data=rs232_fct[i-32];
        if(i>=48 && i<=55) data=rs232_led[i-48];
        if(i>=56 && i<=63) data=rs232_cli[i-56];
        if(i>=64 && i<=67) data=rs232_aig[i-64];
        if(i>=68 && i<=71) data=rs232_out[i-68];

        serial.write(data); Sleep(2);
    }
    Sleep(10);
    for(i=0;i<72;i++)
    {
        serial.read(&data);

        if(i>=0  && i<=7 ) rs232_in[i-0]=data;
        if(i>=8  && i<=15) rs232_pos[i-8]=data;
        if(i>=16 && i<=31) rs232_mouse[i-16]=data; //plus utilise
        if(i>=32 && i<=36) rs232_can[i-32];        //plus utilise
    }
}
#endif //DIS

// nouveau transfer de masse en mode buffer plus adapte pour l'USB
int rs232_txrx_masse(int board)
{
    int i,data,tx,rx;
    static int cpt=0;

    int buff_tx[100];
    int buff_rx[100];

    char szDebug[100];

    //transfert de masse
    if(board==0) serial0.write(9);
    if(board==1) serial1.write(9);
    if(board==2) serial2.write(9);
    if(board==3) serial3.write(9); //transfert de masse

    // PC->UC: ADR(16)+CMD(16)+FCT(16)+LED(8)+CLI(8)+AIG(4)+OUT(4)
    // UC->PC: IN_MEM(8)+AIG_POS(8)+MOUSE_W(16)+can%8_pour_le_reste

    buff_rx[72]=0;
    for(i=0;i<72;i++)
    {
        if(i>=0 && i<=15)  buff_tx[i]=rs232_adr[i-0];
        if(i>=16 && i<=31) buff_tx[i]=rs232_cmd[i-16];
        if(i>=32 && i<=47) buff_tx[i]=rs232_fct[i-32];
        if(i>=48 && i<=55) buff_tx[i]=rs232_led[board][i-48];
        if(i>=56 && i<=63) buff_tx[i]=rs232_cli[board][i-56];
        if(i>=64 && i<=67) buff_tx[i]=rs232_aig[board][i-64];
        if(i>=68 && i<=71) buff_tx[i]=rs232_out[board][i-68];
    }
    buff_tx[72]=1; //pr voir si la carte repond tj 0x83 en fin de transfer
    if(board==0) { tx=serial0.writebuff(73,buff_tx); serial0.waitrxnb(73,5000); rx=serial0.readbuff(73,buff_rx); }
    if(board==1) { tx=serial1.writebuff(73,buff_tx); serial1.waitrxnb(73,5000); rx=serial1.readbuff(73,buff_rx); }
    if(board==2) { tx=serial2.writebuff(73,buff_tx); serial2.waitrxnb(73,5000); rx=serial2.readbuff(73,buff_rx); }
    if(board==3) { tx=serial3.writebuff(73,buff_tx); serial3.waitrxnb(73,5000); rx=serial3.readbuff(73,buff_rx); }
    for(i=0;i<72;i++)
    {
        if(i>=0  && i<=7 ) rs232_in[board][i-0]=buff_rx[i];
        if(i>=8  && i<=15) rs232_pos[board][i-8]=buff_rx[i];
        if(i>=16 && i<=31) rs232_mouse[board][i-16]=buff_rx[i]; //plus utilise
        if(i>=32 && i<=36) rs232_can[board][i-32]=buff_rx[i];   //plus utilise
        if(i>=40 && i<=47) rs232_in[board][i-40+8]=buff_rx[i];
    }
    ////sprintf(szDebug,"Error diff 73 tx=%d rx=%d",tx,rx);
    ////if(tx!=73 || rx!=73) MessageBox(NULL,szDebug,"Debug",MB_OK);
    return buff_rx[72];
}

void rs232_tic(void)
{
    int data,j;
    char sz[100];

    for(j=0;j<4;j++)
    {
        var_2_rs232(j);

        if(rs232_initialized[j])
        {
            data=rs232_txrx_masse(j);
            if(data!=0x83)
            {
                char szTemp[1000];

                rs232_initialized[j]=0;
                sprintf(sz,"Probleme de communication avec la carte %d\n\nFonctionnement en mode deconnecte pour cette carte",j);
                MessageBox(NULL,sz,STR_FDCC_MSGBOX_TITLE,MB_OK|MB_ICONERROR);
            }
            rs232_2_var(j);
        }
        else rs232_2_var_loop(j);
    }

    //int i;
    //for(i=0;i<8;i++) fprintf(p_err,"\nrs232_in%d=0x%x",i,rs232_in[i]);
    //for(i=0;i<64;i++) fprintf(p_err,"\nin%d=0x%x",i,var_in[i]);
}

void reset_rs232_adr_cmd_fct(void)
{
    int i;
    for(i=0;i<16;i++)
    {
        rs232_adr[i]=0;
        rs232_cmd[i]=0x60;
        rs232_fct[i]=0x90;
    }
}

/*****************************************************************************/
/* FIN LIAISON SERIE                                                         */
/*****************************************************************************/





/*****************************************************************************/
/* FACILITIES                                                                */
/*****************************************************************************/
char gszErr[1024];

void log(char* sz)
{
    FILE* pf;
    static int start=1;

    if(start) pf=fopen("log.txt","wt");  // erase file before first log
    else      pf=fopen("log.txt","at");  // apend text to next log
    if(pf) { fprintf(pf,sz); fclose(pf); }
    start=0;
}
// ex: sprintf(gszErr,"g=%d c=%d canton.num_train=%d selected_train=%d",g,c,canton.num_train[c/100][c%100],selected_train); log(gszErr);



char szdebug[200];
//sprintf(szerror," ");
//MessageBox(NULL,szdebug,"Error",MB_OK|MB_ICONERROR);
//sprintf(szdebug,"s_led_d=%d s_led_cli=%d s_led_phase=%d sel=%d",serial_led_debug[0],serial_led_cli_debug[0],serial_led_phase_debug[0],serial_led_debug_select[0]);
//TextOut(hdc,10,550,szdebug,strlen(szdebug));

int moins_char_normal=1;   // 1: - est un caractere normal (comme 0)  0: - est un separateur (comme +)

int get_line(FILE* pf, char ch_tab[][100], int* ch_nb)
{
    int i;
    char c;
    char ch[100];
    int ch_ind;
    int ch_ok;

    *ch_nb=0; ch_ind=0; ch_ok=0;

    for(i=0;i<50;i++) ch_tab[i][0]='\0';

    do
    {
        /* 1. read char */
        if(fscanf(pf,"%c",&c)==EOF) return 0;

        /* 2. normal char */
        if( (c>='a' && c<='z') || (c>='A' && c<='Z') || (c>='0' && c<='9') || c=='_' || (c=='-' && moins_char_normal) )
        {
            ch_tab[*ch_nb][ch_ind]=c;
            ch_ind++;
            ch_ok=1;
        }

        /* 3. control char */
        else
        {
            /* 3.1 normal character before */
            if(ch_ok)
            {
                ch_tab[*ch_nb][ch_ind]='\0';
                *ch_nb=(*ch_nb)+1;
                ch_ind=0;
                ch_ok=0;
            }

            /* 3.2 add printable control char */
            if(c!=' ' && c!='\t' && c!='\n')
            {
                ch_tab[*ch_nb][0]=c;
                ch_tab[*ch_nb][1]='\0';
                *ch_nb=(*ch_nb)+1;
                ch_ind=0;
                ch_ok=0;
            }
        }

    }
    while(c!='\n' && c!=';');

    if( (*ch_nb)==1 && ch_tab[0][0]==']') return 0;
    return 1;
}

void EasyTextOut(int x, int y, char* sz)
{
    TextOut(hdc,x,y,sz,strlen(sz));
}

void EasyLine(int x1, int y1, int x2, int y2)
{
    MoveToEx(hdc,x1,y1,NULL); LineTo(hdc,x2,y2);
}

void EasyLine(HDC hdc_,int x1, int y1, int x2, int y2)
{
    MoveToEx(hdc_,x1,y1,NULL); LineTo(hdc_,x2,y2);
}

void EasyRect(HDC hdc_, int x1, int y1, int x2, int y2)
{
    EasyLine(hdc_,x1,y1,x2,y1);
    EasyLine(hdc_,x1,y2,x2,y2);
    EasyLine(hdc_,x1,y1,x1,y2);
    EasyLine(hdc_,x2,y1,x2,y2);
}

void EasyRecFill(HDC hdc_, int x1, int y1, int x2, int y2)
{
    Rectangle(hdc_,x1,y1,x2,y1);
}


void init_fonte_pen_brush(void)
{
    la_fonte=CreateFont(15,10,0,0,400,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_MODERN,"Courier");
    cells_font=CreateFont(10,10,0,0,400,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_MODERN,"Courier New");
}

unsigned long tic_cpt=0;

/*****************************************************************************/
/* FIN FACILITIES                                                            */
/*****************************************************************************/





/*****************************************************************************/
/* TDV                                                                       */
/*****************************************************************************/

/* ex:
[tdv]
op var
op var op var ...
op:
l / ln  : chargement acc
o / on  : acc = acc ou var
a / an  : acc = acc et var
x / xn  : acc = acc ou exclusif var
= / =s / =c : affectation: var=acc / (si acc=1) var=1 / (si acc=0) var=0
var:
i0-63 : entrees
y0-63 : anciennes entrees
o0-31 : sorties
l0-63 : led
c0-63 : clignotement
a0-31 : aig cmd
d0-31 : aig pos 0 (direct)
e0-31 : aig pos 1 (evitement)
r0-31 : aig res
v0-99 : variable
*/

char szTdv[10000];
int nextTdv=0;
int tdv_err=0;

class cTdv
{
    public:

         cTdv(void);
    int init(char szFilename[]);
    void save_conf();
    void tick(void);
};

cTdv::cTdv(void)
{

}

int cTdv::init(char szFilename[])
{
    FILE* pf;
    char c;
    int comment,in,in_str;
    char sz[1000];

    /* 1. Reset */
    nextTdv=0;
    tdv_err=0;

    /* 2. Chargement */

    pf=fopen(szFilename,"rt");
    if(pf==NULL) return -1;

    in=comment=in_str=0;

    while( fscanf(pf,"%c",&c)!=EOF)
    {
        if(c=='#') comment=1;
        if(c=='\n' ||c=='\r') comment=0;
        if(comment) continue;

        if(c=='[')
        {
            fscanf(pf,"%s",sz);
            if(!stricmp(sz,"tdv]")) in=1; else in=0;
        }
        if(in==0) continue;

        if( (c>='a' && c<='z') || (c>='A' && c<='Z') || (c>='0' && c<='9') || c=='_' || c=='=' )
        {
            in_str=1; szTdv[nextTdv]=c; szTdv[nextTdv+1]='\0'; nextTdv++;
        }
        else
        {
            if(in_str) {in_str=0; szTdv[nextTdv]=' '; szTdv[nextTdv+1]='\0'; nextTdv++; }
        }
    }

    fclose(pf);

/**/    fprintf(p_err,"\nnextTdv=%d szTdv=%s",nextTdv,szTdv);
}

void cTdv::save_conf(void)
{
    fprintf(p_err,"\nnextTdv=%d szTdv=%s",nextTdv,szTdv);
}

int get_var_str(char* sz)
{
    char* pt;
    int board, num, inv, val;

    val=-1;
    pt=sz; inv=0;
    inv=0; if(sz[0]=='!') { inv=1; pt++; }
    num=0; if(pt[0]!='\0') num=atoi(&pt[1]); if(num<0) return -1;
    board=num/1000; if(board>=4) return -1;
    num=num%1000;

    if(pt[0]=='i') if(num<128) val=var_in[board][num];
    if(pt[0]=='y') if(num<128) val=var_in_old[board][num];
    if(pt[0]=='d') if(num<32)  val=var_pos0[board][num];
    if(pt[0]=='e') if(num<32)  val=var_pos1[board][num];
    if(pt[0]=='v') if(num<100) val=var_var[num];

    if(pt[0]=='t') if(num<ITI_TAB_NB) val=iti_tab[num][ITI_TAB_IND_OK];

    if(pt[0]=='b') if(num<BAL_CANT_NB) { if(bal_cant[num][BAL_CANT_TR]) val=1; else val=0; }

    if(pt[0]=='a') if(num<32) val=var_aigcmd[board][num];
    if(pt[0]=='o') if(num<32) val=var_out[board][num];
    if(pt[0]=='l') if(num<64) val=var_led[board][num];
    if(pt[0]=='c') if(num<64) val=var_cli[board][num];

    if(val==-1) return -1;
    return val^inv;
}

int set_var_str(char* sz, int val)
{
    char* pt;
    int board, num;
    pt=sz;

    num=0; if(pt[0]!='\0') num=atoi(&pt[1]); if(num<0) return -1;
    board=num/1000; if(board>=4) return -1;
    num=num%1000;

    if(pt[0]=='v') if(num<100)var_var[num]=val;
    if(pt[0]=='a') if(num<32) if(ivar_res[board][num]==0) var_aigcmd[board][num]=val;
    if(pt[0]=='o') if(num<32) var_out[board][num]=val;
    if(pt[0]=='l') if(num<64) var_led[board][num]=val;
    if(pt[0]=='c') if(num<64) var_cli[board][num]=val;

    if(pt[0]=='s') if(num<ITI_TAB_NB) iti_tab[num][ITI_TAB_IND_CMD_ON ]=val;
    if(pt[0]=='z') if(num<ITI_TAB_NB) iti_tab[num][ITI_TAB_IND_CMD_OFF]=val;
    if(pt[0]=='x') if(num<ITI_TAB_NB) iti_tab[num][ITI_TAB_IND_CMD_CHG]=val;

    return 0;
}

void cTdv::tick(void)
{
    int i,acc,val,ok;
    char szOrdre[10];
    char szVar[10];
    char szTemp[1000];

    acc=0;
    i=0;

    ////fprintf(p_err,"\ntoc, tdv_err=%d",tdv_err);

    if(tdv_err) return;

    while(i<nextTdv)
    {
        sscanf(&szTdv[i]," %s",szOrdre); i+=strlen(szOrdre)+1;
        sscanf(&szTdv[i]," %s",szVar);   i+=strlen(szVar)+1;

        ////fprintf(p_err,"\nOrdre=%s Var=%s",szOrdre,szVar);

        val=get_var_str(szVar);
        if(val==-1) { sprintf(szTemp,"Erreur TDV Unknown var %s (ordre=%s)",szVar,szOrdre);
                      MessageBox(NULL,szTemp,STR_FDCC_MSGBOX_TITLE,MB_OK); tdv_err=1; break; }

        ok=0;
        if(!stricmp(szOrdre,"l" )) { ok=1; acc=val; }
        if(!stricmp(szOrdre,"ln")) { ok=1; acc=1-val; }
        if(!stricmp(szOrdre,"a" )) { ok=1; acc=acc&val; }
        if(!stricmp(szOrdre,"an")) { ok=1; acc=acc&(1-val); }
        if(!stricmp(szOrdre,"o" )) { ok=1; acc=acc|val; }
        if(!stricmp(szOrdre,"on")) { ok=1; acc=acc|(1-val); }
        if(!stricmp(szOrdre,"x" )) { ok=1; acc=acc^val; }
        if(!stricmp(szOrdre,"xn")) { ok=1; acc=acc^(1-val); }
        if(!stricmp(szOrdre,"=" )) { ok=1; set_var_str(szVar,acc); }
        if(!stricmp(szOrdre,"=s")) { ok=1; if(acc) set_var_str(szVar,1); }
        if(!stricmp(szOrdre,"=c")) { ok=1; if(acc) set_var_str(szVar,0); }

        ////fprintf(p_err,"\nOrdre=%s Var=%s Val=%d Acc=%d",szOrdre,szVar,val,acc);
    }
}


/*****************************************************************************/
/* FIN TDV                                                                   */
/*****************************************************************************/





/*****************************************************************************/
/* BMP                                                                       */
/*****************************************************************************/


HDC       bmp_hdc_mem;
HDC       bmp_hdc_fond_0;
HDC       bmp_hdc_fond_1;
HDC       bmp_hdc_fond_2;
HDC       bmp_hdc_fond_3;
HFONT     bmp_fonte;
HBRUSH    bmp_pinceau_noir;
HBRUSH    bmp_pinceau_bleu;
HBRUSH    bmp_pinceau_vert;
HBRUSH    bmp_pinceau_cyan;
HBRUSH    bmp_pinceau_rouge;
HBRUSH    bmp_pinceau_violet;
HBRUSH    bmp_pinceau_jaune;
HBRUSH    bmp_pinceau_blanc;
HBRUSH    bmp_pinceau_gris;
HBRUSH    bmp_pinceau_grisfonce;
HBRUSH    bmp_pinceau_rose;
HBRUSH    bmp_pinceau_orange;
HBRUSH    bmp_pinceau_marron;
HBRUSH    bmp_pinceau_kaki;
HBRUSH    bmp_pinceau_bordeau;
HBRUSH    bmp_pinceau_grisvert;
HBRUSH    bmp_pinceau_vertfonce;
HPEN      bmp_stylo_noirepais;
HPEN      bmp_stylo_rougeepais;
HPEN      bmp_stylo_bleuepais;
HPEN      bmp_stylo_noir;
HPEN      bmp_stylo_bleu;
HPEN      bmp_stylo_vert;
HPEN      bmp_stylo_cyan;
HPEN      bmp_stylo_rouge;
HPEN      bmp_stylo_violet;
HPEN      bmp_stylo_jaune;
HPEN      bmp_stylo_blanc;
HPEN      bmp_stylo_gris;
HPEN      bmp_stylo_grisfonce;
HPEN      bmp_stylo_rose;
HPEN      bmp_stylo_orange;
HPEN      bmp_stylo_marron;
HPEN      bmp_stylo_kaki;
HPEN      bmp_stylo_bordeau;
HPEN      bmp_stylo_grisvert;
HPEN      bmp_stylo_vertfonce;

/*
int       bmp_cli=0;
int       bmp_rgb_color[9][3]={ {  0,  0,  0}, {  0,  0,255}, {  0,255,  0},
                                {  0,255,255}, {255,  0,  0}, {255,  0,255},
                                {255,255,  0}, {255,255,255}, {192,192,192} };
unsigned long  bmp_rgb[9]={ RGB(  0,  0,  0), RGB(  0,  0,255), RGB(  0,255,  0),
                            RGB(  0,255,255), RGB(255,  0,  0), RGB(255,  0,255),
                            RGB(255,255,  0), RGB(255,255,255), RGB(192,192,192) };
*/

#define BMP_TAB_TYPE_NB        50
#define BMP_TAB_TYPE_IND_NB    11
#define BMP_TAB_TYPE_IND_TYPE   0
#define BMP_TAB_TYPE_IND_DX     1
#define BMP_TAB_TYPE_IND_DY     2
#define BMP_TAB_TYPE_IND_X0     3
#define BMP_TAB_TYPE_IND_Y0     4
#define BMP_TAB_TYPE_IND_X1     5
#define BMP_TAB_TYPE_IND_Y1     6
#define BMP_TAB_TYPE_IND_X2     7
#define BMP_TAB_TYPE_IND_Y2     8
#define BMP_TAB_TYPE_IND_X3     9
#define BMP_TAB_TYPE_IND_Y3    10
#define BMP_TAB_TYPE_IND_C0     3
#define BMP_TAB_TYPE_IND_C1     4
#define BMP_TAB_TYPE_IND_C2     5
#define BMP_TAB_TYPE_IND_C3     6
#define BMP_TAB_TYPE_IND_DIGIT  7
#define BMP_TAB_TYPE_IND_FORMAT 8
#define BMP_TAB_TYPE_IND_MIN    7
#define BMP_TAB_TYPE_IND_MAX    8
#define BMP_TAB_TYPE_IND_DX2    9
#define BMP_TAB_TYPE_IND_DY2   10
#define BMP_TAB_TYPE_IND_HORI   6


#define BMP_CST_COLOR_NOIR        0
#define BMP_CST_COLOR_BLEU        1
#define BMP_CST_COLOR_VERT        2
#define BMP_CST_COLOR_CYAN        3
#define BMP_CST_COLOR_ROUGE       4
#define BMP_CST_COLOR_VIOLET      5
#define BMP_CST_COLOR_JAUNE       6
#define BMP_CST_COLOR_BLANC       7
#define BMP_CST_COLOR_GRIS        8
#define BMP_CST_COLOR_ROSE        9
#define BMP_CST_COLOR_ORANGE     10
#define BMP_CST_COLOR_MARRON     11
#define BMP_CST_COLOR_KAKI       12
#define BMP_CST_COLOR_BORDEAU    13
#define BMP_CST_COLOR_GRISVERT   14
#define BMP_CST_COLOR_VERTFONCE  15
#define BMP_CST_COLOR_NOIREPAIS  16
#define BMP_CST_COLOR_ROUGEEPAIS 17
#define BMP_CST_COLOR_GRISFONCE  18
#define BMP_CST_COLOR_BLEUEPAIS  19

void bmp_move(int x, int y, int xo, int yo, int l, int h)
{
    SelectObject(hdc,bmp_pinceau_blanc);
    BitBlt(hdc,x,y,l,h,bmp_hdc_mem,xo,yo,MERGECOPY);
}

void bmp_select_brush(int no_color)
{
     switch(no_color)
     {
         case BMP_CST_COLOR_NOIR     : SelectObject(hdc,bmp_pinceau_noir     ); break;
         case BMP_CST_COLOR_BLEU     : SelectObject(hdc,bmp_pinceau_bleu     ); break;
         case BMP_CST_COLOR_VERT     : SelectObject(hdc,bmp_pinceau_vert     ); break;
         case BMP_CST_COLOR_CYAN     : SelectObject(hdc,bmp_pinceau_cyan     ); break;
         case BMP_CST_COLOR_ROUGE    : SelectObject(hdc,bmp_pinceau_rouge    ); break;
         case BMP_CST_COLOR_VIOLET   : SelectObject(hdc,bmp_pinceau_violet   ); break;
         case BMP_CST_COLOR_JAUNE    : SelectObject(hdc,bmp_pinceau_jaune    ); break;
         case BMP_CST_COLOR_GRIS     : SelectObject(hdc,bmp_pinceau_gris     ); break;
         case BMP_CST_COLOR_GRISFONCE: SelectObject(hdc,bmp_pinceau_grisfonce); break;
         case BMP_CST_COLOR_BLANC    : SelectObject(hdc,bmp_pinceau_blanc    ); break;
         case BMP_CST_COLOR_ROSE     : SelectObject(hdc,bmp_pinceau_rose     ); break;
         case BMP_CST_COLOR_ORANGE   : SelectObject(hdc,bmp_pinceau_orange   ); break;
         case BMP_CST_COLOR_MARRON   : SelectObject(hdc,bmp_pinceau_marron   ); break;
         case BMP_CST_COLOR_KAKI     : SelectObject(hdc,bmp_pinceau_kaki     ); break;
         case BMP_CST_COLOR_BORDEAU  : SelectObject(hdc,bmp_pinceau_orange   ); break;
         case BMP_CST_COLOR_GRISVERT : SelectObject(hdc,bmp_pinceau_grisvert ); break;
         case BMP_CST_COLOR_VERTFONCE: SelectObject(hdc,bmp_pinceau_vertfonce); break;
         default:                      SelectObject(hdc,bmp_pinceau_blanc    ); break;
     }
}

void bmp_select_pen(int no_color)
{
     switch(no_color)
     {
         case BMP_CST_COLOR_BLEU     : SelectObject(hdc,bmp_stylo_bleu     ); break;
         case BMP_CST_COLOR_VERT     : SelectObject(hdc,bmp_stylo_vert     ); break;
         case BMP_CST_COLOR_CYAN     : SelectObject(hdc,bmp_stylo_cyan     ); break;
         case BMP_CST_COLOR_ROUGE    : SelectObject(hdc,bmp_stylo_rouge    ); break;
         case BMP_CST_COLOR_VIOLET   : SelectObject(hdc,bmp_stylo_violet   ); break;
         case BMP_CST_COLOR_JAUNE    : SelectObject(hdc,bmp_stylo_jaune    ); break;
         case BMP_CST_COLOR_BLANC    : SelectObject(hdc,bmp_stylo_blanc    ); break;
         case BMP_CST_COLOR_GRIS     : SelectObject(hdc,bmp_stylo_gris     ); break;
         case BMP_CST_COLOR_GRISFONCE: SelectObject(hdc,bmp_stylo_grisfonce); break;
         case BMP_CST_COLOR_NOIR     : SelectObject(hdc,bmp_stylo_noir     ); break;
         case BMP_CST_COLOR_ROSE     : SelectObject(hdc,bmp_stylo_rose     ); break;
         case BMP_CST_COLOR_ORANGE   : SelectObject(hdc,bmp_stylo_orange   ); break;
         case BMP_CST_COLOR_MARRON   : SelectObject(hdc,bmp_stylo_marron   ); break;
         case BMP_CST_COLOR_KAKI     : SelectObject(hdc,bmp_stylo_kaki     ); break;
         case BMP_CST_COLOR_BORDEAU  : SelectObject(hdc,bmp_stylo_orange   ); break;
         case BMP_CST_COLOR_GRISVERT : SelectObject(hdc,bmp_stylo_grisvert ); break;
         case BMP_CST_COLOR_VERTFONCE: SelectObject(hdc,bmp_stylo_vertfonce); break;
         case BMP_CST_COLOR_NOIREPAIS: SelectObject(hdc,bmp_stylo_noirepais); break;
         case BMP_CST_COLOR_ROUGEEPAIS:SelectObject(hdc,bmp_stylo_rougeepais);break;
         case BMP_CST_COLOR_BLEUEPAIS: SelectObject(hdc,bmp_stylo_bleuepais); break;
         default:                      SelectObject(hdc,bmp_stylo_noir     ); break;
     }
}

void bmp_select_pen_brush(int no_color)
{
    bmp_select_pen(no_color);
    bmp_select_brush(no_color);
}

void bmp_select_brush(HDC hdc_,int no_color)
{
     switch(no_color)
     {
         case BMP_CST_COLOR_NOIR     : SelectObject(hdc_,bmp_pinceau_noir     ); break;
         case BMP_CST_COLOR_BLEU     : SelectObject(hdc_,bmp_pinceau_bleu     ); break;
         case BMP_CST_COLOR_VERT     : SelectObject(hdc_,bmp_pinceau_vert     ); break;
         case BMP_CST_COLOR_CYAN     : SelectObject(hdc_,bmp_pinceau_cyan     ); break;
         case BMP_CST_COLOR_ROUGE    : SelectObject(hdc_,bmp_pinceau_rouge    ); break;
         case BMP_CST_COLOR_VIOLET   : SelectObject(hdc_,bmp_pinceau_violet   ); break;
         case BMP_CST_COLOR_JAUNE    : SelectObject(hdc_,bmp_pinceau_jaune    ); break;
         case BMP_CST_COLOR_GRIS     : SelectObject(hdc_,bmp_pinceau_gris     ); break;
         case BMP_CST_COLOR_GRISFONCE: SelectObject(hdc_,bmp_pinceau_grisfonce); break;
         case BMP_CST_COLOR_BLANC    : SelectObject(hdc_,bmp_pinceau_blanc    ); break;
         case BMP_CST_COLOR_ROSE     : SelectObject(hdc_,bmp_pinceau_rose     ); break;
         case BMP_CST_COLOR_ORANGE   : SelectObject(hdc_,bmp_pinceau_orange   ); break;
         case BMP_CST_COLOR_MARRON   : SelectObject(hdc_,bmp_pinceau_marron   ); break;
         case BMP_CST_COLOR_KAKI     : SelectObject(hdc_,bmp_pinceau_kaki     ); break;
         case BMP_CST_COLOR_BORDEAU  : SelectObject(hdc_,bmp_pinceau_orange   ); break;
         case BMP_CST_COLOR_GRISVERT : SelectObject(hdc_,bmp_pinceau_grisvert ); break;
         case BMP_CST_COLOR_VERTFONCE: SelectObject(hdc_,bmp_pinceau_vertfonce); break;
         default:                      SelectObject(hdc_,bmp_pinceau_blanc    ); break;
     }
}

void bmp_select_pen(HDC hdc_,int no_color)
{
     switch(no_color)
     {
         case BMP_CST_COLOR_BLEU     : SelectObject(hdc_,bmp_stylo_bleu     ); break;
         case BMP_CST_COLOR_VERT     : SelectObject(hdc_,bmp_stylo_vert     ); break;
         case BMP_CST_COLOR_CYAN     : SelectObject(hdc_,bmp_stylo_cyan     ); break;
         case BMP_CST_COLOR_ROUGE    : SelectObject(hdc_,bmp_stylo_rouge    ); break;
         case BMP_CST_COLOR_VIOLET   : SelectObject(hdc_,bmp_stylo_violet   ); break;
         case BMP_CST_COLOR_JAUNE    : SelectObject(hdc_,bmp_stylo_jaune    ); break;
         case BMP_CST_COLOR_BLANC    : SelectObject(hdc_,bmp_stylo_blanc    ); break;
         case BMP_CST_COLOR_GRIS     : SelectObject(hdc_,bmp_stylo_gris     ); break;
         case BMP_CST_COLOR_GRISFONCE: SelectObject(hdc_,bmp_stylo_grisfonce); break;
         case BMP_CST_COLOR_NOIR     : SelectObject(hdc_,bmp_stylo_noir     ); break;
         case BMP_CST_COLOR_ROSE     : SelectObject(hdc_,bmp_stylo_rose     ); break;
         case BMP_CST_COLOR_ORANGE   : SelectObject(hdc_,bmp_stylo_orange   ); break;
         case BMP_CST_COLOR_MARRON   : SelectObject(hdc_,bmp_stylo_marron   ); break;
         case BMP_CST_COLOR_KAKI     : SelectObject(hdc_,bmp_stylo_kaki     ); break;
         case BMP_CST_COLOR_BORDEAU  : SelectObject(hdc_,bmp_stylo_orange   ); break;
         case BMP_CST_COLOR_GRISVERT : SelectObject(hdc_,bmp_stylo_grisvert ); break;
         case BMP_CST_COLOR_VERTFONCE: SelectObject(hdc_,bmp_stylo_vertfonce); break;
         case BMP_CST_COLOR_NOIREPAIS: SelectObject(hdc_,bmp_stylo_noirepais); break;
         case BMP_CST_COLOR_ROUGEEPAIS:SelectObject(hdc_,bmp_stylo_rougeepais);break;
         case BMP_CST_COLOR_BLEUEPAIS: SelectObject(hdc_,bmp_stylo_bleuepais); break;
         default:                      SelectObject(hdc_,bmp_stylo_noir     ); break;
     }
}

void bmp_select_pen_brush(HDC hdc_,int no_color)
{
    bmp_select_pen(hdc_,no_color);
    bmp_select_brush(hdc_,no_color);
}

void bmp_SetTextColor(HDC hdc_,int no_color)
{
     switch(no_color)
     {
         case BMP_CST_COLOR_BLEU     : SetTextColor(hdc_,RGB(  0,128,255)); break;
         case BMP_CST_COLOR_VERT     : SetTextColor(hdc_,RGB(  0,255,  0)); break;
         case BMP_CST_COLOR_CYAN     : SetTextColor(hdc_,RGB(  0,255,255)); break;
         case BMP_CST_COLOR_ROUGE    : SetTextColor(hdc_,RGB(255,  0,  0)); break;
         case BMP_CST_COLOR_VIOLET   : SetTextColor(hdc_,RGB(255,  0,255)); break;
         case BMP_CST_COLOR_JAUNE    : SetTextColor(hdc_,RGB(255,255,  0)); break;
         case BMP_CST_COLOR_BLANC    : SetTextColor(hdc_,RGB(255,255,255)); break;
         case BMP_CST_COLOR_GRIS     : SetTextColor(hdc_,RGB(192,192,192)); break;
         case BMP_CST_COLOR_GRISFONCE: SetTextColor(hdc_,RGB(128,128,128)); break;
         case BMP_CST_COLOR_NOIR     : SetTextColor(hdc_,RGB(  0,  0,  0)); break;
         case BMP_CST_COLOR_ROSE     : SetTextColor(hdc_,RGB(128,128,255)); break;
         case BMP_CST_COLOR_ORANGE   : SetTextColor(hdc_,RGB(255,128,  0)); break;
         case BMP_CST_COLOR_MARRON   : SetTextColor(hdc_,RGB(128, 64,  0)); break;
         case BMP_CST_COLOR_KAKI     : SetTextColor(hdc_,RGB(128,128,  0)); break;
         case BMP_CST_COLOR_BORDEAU  : SetTextColor(hdc_,RGB(128,  0, 64)); break;
         case BMP_CST_COLOR_GRISVERT : SetTextColor(hdc_,RGB( 64,128,128)); break;
         case BMP_CST_COLOR_VERTFONCE: SetTextColor(hdc_,RGB(  0,128,  0)); break;
         default:                      SetTextColor(hdc_,RGB(  0,  0,  0)); break;
     }
}

void bmp_SetTextColor(int no_color)
{
    bmp_SetTextColor(hdc,no_color);
}

void font_pinceau_stylo_init(void)
{
    bmp_fonte=CreateFont(15,10,0,0,400,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_MODERN,"Courier");

    bmp_pinceau_noir      = CreateSolidBrush(RGB(  0,  0,  0));
    bmp_pinceau_bleu      = CreateSolidBrush(RGB(  0,128,255));
    bmp_pinceau_vert      = CreateSolidBrush(RGB(  0,255,  0));
    bmp_pinceau_cyan      = CreateSolidBrush(RGB(  0,255,255));
    bmp_pinceau_rouge     = CreateSolidBrush(RGB(255,  0,  0));
    bmp_pinceau_violet    = CreateSolidBrush(RGB(255,  0,255));
    bmp_pinceau_jaune     = CreateSolidBrush(RGB(255,255,  0));
    bmp_pinceau_blanc     = CreateSolidBrush(RGB(255,255,255));
    bmp_pinceau_gris      = CreateSolidBrush(RGB(192,192,192));
    bmp_pinceau_grisfonce = CreateSolidBrush(RGB(128,128,128));
    bmp_pinceau_rose      = CreateSolidBrush(RGB(128,128,255));
    bmp_pinceau_orange    = CreateSolidBrush(RGB(255,128,  0));
    bmp_pinceau_marron    = CreateSolidBrush(RGB(128, 64,  0));
    bmp_pinceau_kaki      = CreateSolidBrush(RGB(128,128,  0));
    bmp_pinceau_bordeau   = CreateSolidBrush(RGB(128,  0, 64));
    bmp_pinceau_grisvert  = CreateSolidBrush(RGB( 64,128,128));
    bmp_pinceau_vertfonce = CreateSolidBrush(RGB(  0,128,  0));

    bmp_stylo_bleuepais   = CreatePen(PS_SOLID,4,RGB(  0,255,0  ));
    bmp_stylo_rougeepais  = CreatePen(PS_SOLID,4,RGB(255,0  ,0  ));
    bmp_stylo_noirepais   = CreatePen(PS_SOLID,4,RGB(0  ,0  ,0  ));
    bmp_stylo_noir        = CreatePen(PS_SOLID,1,RGB(0  ,0  ,0  ));
    bmp_stylo_bleu        = CreatePen(PS_SOLID,1,RGB(  0,128,255));
    bmp_stylo_vert        = CreatePen(PS_SOLID,1,RGB(  0,255,  0));
    bmp_stylo_cyan        = CreatePen(PS_SOLID,1,RGB(  0,255,255));
    bmp_stylo_rouge       = CreatePen(PS_SOLID,1,RGB(255,  0,  0));
    bmp_stylo_violet      = CreatePen(PS_SOLID,1,RGB(255,  0,255));
    bmp_stylo_jaune       = CreatePen(PS_SOLID,1,RGB(255,255,  0));
    bmp_stylo_blanc       = CreatePen(PS_SOLID,1,RGB(255,255,255));
    bmp_stylo_gris        = CreatePen(PS_SOLID,1,RGB(192,192,192));
    bmp_stylo_grisfonce   = CreatePen(PS_SOLID,1,RGB(128,128,128));
    bmp_stylo_rose        = CreatePen(PS_SOLID,1,RGB(255,128,255));
    bmp_stylo_orange      = CreatePen(PS_SOLID,1,RGB(255,128,  0));
    bmp_stylo_marron      = CreatePen(PS_SOLID,1,RGB(128, 64,  0));
    bmp_stylo_kaki        = CreatePen(PS_SOLID,1,RGB(128,128,  0));
    bmp_stylo_bordeau     = CreatePen(PS_SOLID,1,RGB(128,  0, 64));
    bmp_stylo_grisvert    = CreatePen(PS_SOLID,1,RGB( 64,128,128));
    bmp_stylo_vertfonce   = CreatePen(PS_SOLID,1,RGB(  0,128,  0));
}

void bmp_fond_default(void)
{
    SelectObject(hdc,bmp_pinceau_blanc);
    SelectObject(hdc,bmp_stylo_blanc);
    Rectangle(hdc,0,0,1600,1200);
    //SelectObject(hdc,bmp_pinceau_blanc);  Rectangle(hdc,200,0,1600,1200);
}

/*****************************************************************************/
/* END BMP                                                                   */
/*****************************************************************************/





/*****************************************************************************/
/* ITI                                                                       */
/*****************************************************************************/

/* declare en haut
// 32 real aigs + 8 virt + lib
#define ITI_TAB_NB          100
#define ITI_TAB_NB_AIG       40
#define ITI_TAB_IND_LIB      40   //pos=DA -1=TP -2=direct
#define ITI_TAB_IND_STATE    41
#define ITI_TAB_IND_CMD_ON   42
#define ITI_TAB_IND_CMD_OFF  43
#define ITI_TAB_IND_CMD_CHG  44
#define ITI_TAB_IND_OK       45
#define ITI_TAB_IND_LED      46
#define ITI_TAB_SIZE         47
int iti_tab[ITI_TAB_NB][ITI_TAB_SIZE];
#define ITI_TAB_NO_AIG -1
#define ITI_TAB_DIR_AIG 0
#define ITI_TAB_DEV_AIG 1
#define ITI_TAB_OFF     0
#define ITI_TAB_ATT_RES 1
#define ITI_TAB_ATT_AIG 2
#define ITI_TAB_ON      3
*/

int iti_init(char* szFilename)
{
    FILE* pf;
    int i,j;
    char szLine[1000];
    char* ptr;
    char c;

    // 1. init iti_tab array
    for(i=0;i<ITI_TAB_NB;i++)
    {
        for(j=0;j<ITI_TAB_NB_AIG;j++) iti_tab[i][j]=ITI_TAB_NO_AIG;
        iti_tab[i][ITI_TAB_IND_LIB]=-2;
        iti_tab[i][ITI_TAB_IND_CMD_ON]=0;
        iti_tab[i][ITI_TAB_IND_CMD_OFF]=0;
        iti_tab[i][ITI_TAB_IND_CMD_CHG]=0;
        iti_tab[i][ITI_TAB_IND_OK]=0;
        iti_tab[i][ITI_TAB_IND_LED]=0;
        iti_tab[i][ITI_TAB_IND_STATE]=ITI_TAB_OFF;
    }

    // 2. load file

    pf=fopen(szFilename,"rt");
    if(pf==NULL) return -1;

    i=0;
    while( fgets( szLine, 100, pf ) != NULL)
    {
        if(strnicmp(szLine,"iti",3)!=0) continue;  //also for #, space ...
        i=atoi(szLine+3);

        j=0;
        if((ptr=strstr(szLine,"\"")))
        {
            ptr++;
            while(c=*ptr++)
            {
                if(c=='\"') break;
                if(c=='-')  { iti_tab[i][j]=ITI_TAB_DIR_AIG; j++; }
                if(c=='/')  { iti_tab[i][j]=ITI_TAB_DEV_AIG; j++; }
                if(c=='.')  { iti_tab[i][j]=ITI_TAB_NO_AIG ; j++; }
                if(c=='a' || c=='A') { j=atoi(ptr++); }
                if(j>=ITI_TAB_NB_AIG) break;
            }
        }

        if(ptr=strstr(szLine,"lib:")) iti_tab[i][ITI_TAB_IND_LIB]=atoi(ptr+4);
    }

    fclose(pf);

    // 3. verification

    pf=fopen("iti_config_verif.txt","wt");
    if(pf==NULL) return -2;

    for(i=0;i<ITI_TAB_NB;i++)
    {
        fprintf(pf,"iti%02d:\"",i);
        for(j=0;j<ITI_TAB_NB_AIG;j++)
        {
            if(iti_tab[i][j]==ITI_TAB_NO_AIG ) fprintf(pf,".");;
            if(iti_tab[i][j]==ITI_TAB_DIR_AIG) fprintf(pf,"-");;
            if(iti_tab[i][j]==ITI_TAB_DEV_AIG) fprintf(pf,"/");;
        }
        fprintf(pf,"\" lib:%d\n",iti_tab[i][ITI_TAB_IND_LIB]);
    }

    fclose(pf);
}

int iti_can_res(int no_iti)
{
    int i;

    for(i=0;i<ITI_TAB_NB_AIG;i++) if((iti_tab[no_iti][i]==ITI_TAB_DIR_AIG)||(iti_tab[no_iti][i]==ITI_TAB_DEV_AIG)) if(ivar_res[i/1000][i%1000]!=0) return 0;
    return 1;
}

int iti_res(int no_iti)
{
    int i;

    if(iti_can_res(no_iti)==0) return 0;
    for(i=0;i<ITI_TAB_NB_AIG;i++) if((iti_tab[no_iti][i]==ITI_TAB_DIR_AIG)||(iti_tab[no_iti][i]==ITI_TAB_DEV_AIG)) ivar_res[i/1000][i%1000]=300000+no_iti;
    return 1;
}

void iti_unres(int no_iti)
{
    int i;

    for(i=0;i<ITI_TAB_NB_AIG;i++) if(ivar_res[i/1000][i%1000]==(300000+no_iti)) ivar_res[i/1000][i%1000]=0;
}

void iti_set_aig(int no_iti)
{
    int i;

    for(i=0;i<ITI_TAB_NB_AIG;i++) if((i/1000)<4) if((i%1000)<32)
    {
        if(iti_tab[no_iti][i]==ITI_TAB_DIR_AIG) var_aigcmd[i/1000][i%1000]=0;
        if(iti_tab[no_iti][i]==ITI_TAB_DEV_AIG) var_aigcmd[i/1000][i%1000]=1;
    }
}

int iti_is_ok(int no_iti)
{
    int i;

    for(i=0;i<ITI_TAB_NB_AIG;i++) if((i/1000)<4) if((i%1000)<32)
    {
        if(iti_tab[no_iti][i]==ITI_TAB_DIR_AIG) if(var_pos0[i/1000][i%1000]==0) return 0;
        if(iti_tab[no_iti][i]==ITI_TAB_DEV_AIG) if(var_pos1[i/1000][i%1000]==0) return 0;
    }
    return 1;
}

int tco_cpt=0;

int iti_type(char* sz)
{
    char* pt;
    int num;

    pt=strstr(sz,"iti:"); if(pt==NULL) return 0;
    num=atoi(pt+4);
    if(num<0 || num>=100) return 0;

    if(iti_tab[num][ITI_TAB_IND_LIB]==-2) return 0;  //direct
    if(iti_tab[num][ITI_TAB_IND_LIB]==-1) return 1;  //TP
    return 2;                                        //DA
}

int iti_led(char* sz)
{
    char* pt;
    int num;

    pt=strstr(sz,"iti:"); if(pt==NULL) return 0;
    num=atoi(pt+4);
    if(num<0 || num>=100) return 0;

    return(iti_tab[num][ITI_TAB_IND_LED]);
}

void iti_set_sz(char* sz)
{
    char* pt;
    int num;

    pt=strstr(sz,"iti:"); if(pt==NULL) return;
    num=atoi(pt+4);
    if(num<0 || num>=100) return;

    iti_tab[num][ITI_TAB_IND_CMD_ON]=1;
}

void iti_clr_sz(char* sz)
{
    char* pt;
    int num;

    pt=strstr(sz,"iti:"); if(pt==NULL) return;
    num=atoi(pt+4);
    if(num<0 || num>=100) return;

    iti_tab[num][ITI_TAB_IND_CMD_OFF]=1;
}

int iti_tic(void)
{
    int i,set,clr;

    for(i=0;i<ITI_TAB_NB;i++)
    {
        if(iti_tab[i][ITI_TAB_IND_LIB]==-2) //direct
        {
            if(iti_tab[i][ITI_TAB_IND_CMD_ON])
            {
                if(iti_can_res(i)) iti_set_aig(i);
               iti_tab[i][ITI_TAB_IND_CMD_ON]=iti_tab[i][ITI_TAB_IND_CMD_OFF]=iti_tab[i][ITI_TAB_IND_CMD_CHG]=0;
            }

            iti_tab[i][ITI_TAB_IND_OK]=iti_tab[i][ITI_TAB_IND_LED]=iti_is_ok(i);
        }

        if(iti_tab[i][ITI_TAB_IND_LIB]==-1 || iti_tab[i][ITI_TAB_IND_LIB]>=0) //on/off || DA
        {
            set=clr=0;
            if(iti_tab[i][ITI_TAB_IND_CMD_ON]) set=1;
            if(iti_tab[i][ITI_TAB_IND_CMD_CHG]) if(iti_tab[i][ITI_TAB_IND_STATE]==ITI_TAB_OFF) set=1;
            if(iti_tab[i][ITI_TAB_IND_CMD_OFF]) clr=1;
            if(iti_tab[i][ITI_TAB_IND_CMD_CHG]) if(iti_tab[i][ITI_TAB_IND_STATE]!=ITI_TAB_OFF) clr=1;
            if(clr) set=0;
            iti_tab[i][ITI_TAB_IND_CMD_ON]=iti_tab[i][ITI_TAB_IND_CMD_OFF]=iti_tab[i][ITI_TAB_IND_CMD_CHG]=0;

            if(set) if(iti_tab[i][ITI_TAB_IND_STATE]!=ITI_TAB_OFF) set=0;
          //if(clr) if(iti_tab[i][ITI_TAB_IND_STATE]!=ITI_TAB_ON ) clr=0;
            if(clr) if(iti_tab[i][ITI_TAB_IND_STATE]==ITI_TAB_OFF ) clr=0;

            if(set) { iti_tab[i][ITI_TAB_IND_STATE]=ITI_TAB_ATT_RES;           }
            if(clr) { iti_tab[i][ITI_TAB_IND_STATE]=ITI_TAB_OFF; iti_unres(i); }

            if(iti_tab[i][ITI_TAB_IND_STATE]==ITI_TAB_ATT_RES) if(iti_can_res(i))
            { iti_res(i); iti_set_aig(i); iti_tab[i][ITI_TAB_IND_STATE]=ITI_TAB_ATT_AIG; }

            if(iti_tab[i][ITI_TAB_IND_STATE]==ITI_TAB_ATT_AIG) if(iti_is_ok(i))
            { iti_res(i); iti_set_aig(i); iti_tab[i][ITI_TAB_IND_STATE]=ITI_TAB_ON; }

            if(iti_tab[i][ITI_TAB_IND_STATE]==ITI_TAB_ON) if(iti_tab[i][ITI_TAB_IND_LIB]>=0)
            {
                 if( var_in[ iti_tab[i][ITI_TAB_IND_LIB]/1000 ][ iti_tab[i][ITI_TAB_IND_LIB]%1000 ] )
                 { iti_tab[i][ITI_TAB_IND_STATE]=ITI_TAB_OFF; iti_unres(i); }
            }

            iti_tab[i][ITI_TAB_IND_OK]=0;
            if(iti_tab[i][ITI_TAB_IND_STATE]==ITI_TAB_ON) iti_tab[i][ITI_TAB_IND_OK]=1;
            iti_tab[i][ITI_TAB_IND_LED]=0;
            if(iti_tab[i][ITI_TAB_IND_STATE]==ITI_TAB_ON) iti_tab[i][ITI_TAB_IND_LED]=1;
            if(iti_tab[i][ITI_TAB_IND_STATE]==ITI_TAB_ATT_RES || iti_tab[i][ITI_TAB_IND_STATE]==ITI_TAB_ATT_AIG) if(tco_cpt&2) iti_tab[i][ITI_TAB_IND_LED]=1;
        }
    }
}

/*****************************************************************************/
/* END ITI                                                                   */
/*****************************************************************************/





/*****************************************************************************/
/* TCO                                                                       */
/*****************************************************************************/

void simu_draw(void);

#define TCO_SZ_SIZE 100000
char tco_sz[TCO_SZ_SIZE];
int tco_sz_free;
#define TCO_NB 10
#define TCO_NB_X 100
#define TCO_NB_Y 100
#define TCO_IND_TYPE 0
#define TCO_IND_SZ   1
int tco[TCO_NB][TCO_NB_X][TCO_NB_Y][2];
#define TCO_TYPE_FREE  0
#define TCO_TYPE_H     1
#define TCO_TYPE_V     2
#define TCO_TYPE_NE    3
#define TCO_TYPE_NO    4
#define TCO_TYPE_SE    5
#define TCO_TYPE_SO    6
#define TCO_TYPE_HV    7
#define TCO_TYPE_HD    8
#define TCO_TYPE_VV    9
#define TCO_TYPE_VD   10
#define TCO_TYPE_ANE  11
#define TCO_TYPE_ANO  12
#define TCO_TYPE_ASE  13
#define TCO_TYPE_ASO  14
#define TCO_TYPE_VOY  15
#define TCO_TYPE_INT  16
#define TCO_TYPE_BP   17
#define TCO_TYPE_GO   18
#define TCO_TYPE_ITI  19
#define TCO_TYPE_HFG  20
#define TCO_TYPE_SND  21
#define TCO_TYPE_EXE  22
#define TCO_TYPE_DPL  23
#define TCO_TYPE_VANE 24
#define TCO_TYPE_VANO 25
#define TCO_TYPE_VASE 26
#define TCO_TYPE_VASO 27
#define TCO_TYPE_BAL  28
#define TCO_TYPE_BALV 29
#define TCO_TYPE_HP   30
#define TCO_TYPE_VP   31
#define TCO_TYPE_HFD  32

int tco_current=0;
int hdc_mem_tco_initialized=0;
HDC hdc_mem_tco;
int tco_reg=0;
int tco_edit=0;
int tco_edit_pos=0; //bas
int tco_x0=0;
int tco_y0=0;
int tco_disp_horo=1;

char aszTrain[100][10];
int  vManTrain[100];

int tr_init(char* szFilename)
{
    FILE* pf;
    char sz[20];
    int i,v;

    for(i=0;i<100;i++) { aszTrain[i][0]='\0'; vManTrain[i]=10; }

    pf=fopen(szFilename,"rt");
    if(pf==NULL) return -1;

    while(fscanf(pf," %d %s %d",&i,sz,&v)==3)
    {
        strcpy(aszTrain[i],sz);
        vManTrain[i]=v;
    }

    fclose(pf);

    for(i=0;i<100;i++) fprintf(p_err, "\n%d %s %d",i,aszTrain[i],vManTrain[i]);

    return  0;
}

int tco_init(char* szFilename)
{
    FILE* pf;
    //FILE* pd;
    char sz[1000];
    char c;
    int t,i,j,x,y,in,comment,type,txt_ind;
    char sz_type[10];
    char sz_txt[100];

    //pd=fopen("verif.txt","wt");
    //if(pd==NULL) return -1;

    /* 1. Reset */
    for(t=0;t<TCO_NB;t++) for(y=0;y<TCO_NB_Y;y++) for(x=0;x<TCO_NB_X;x++)
    {
        tco[t][x][y][TCO_IND_TYPE]=TCO_TYPE_FREE;
        tco[t][x][y][TCO_IND_SZ]=-1;
    }
    tco_sz[0]='\0';
    tco_sz_free=0;
    tco_current=0;

    /* 2. Chargement */

    pf=fopen(szFilename,"rt");
    if(pf==NULL) return -1;

    in=comment=t=0;

    while( fscanf(pf,"%c",&c)!=EOF)
    {
        if(c=='\n' ||c=='\r') comment=0;
        if(comment) continue;
        if(c=='#') comment=1;

        if(c=='[')
        {
            fscanf(pf,"%s",sz);
            if(!stricmp(sz,"tco]")) in=1; else in=0;
        }
        if(in==0) continue;

        if(c=='t')
        {
            fscanf(pf," %c",&c); //remove = de t = 1
            fscanf(pf," %d",&t);
        }

        if(t<0 ||t>=TCO_NB) continue;

        if(c=='c')
        {
            fscanf(pf," %c",&c); // =    remove = de c = 1,4,TYPE,"blabla"
            fscanf(pf," %d",&x); // x
            fscanf(pf," %c",&c); // ,
            fscanf(pf," %d",&y); // y
            fscanf(pf," %c",&c); // ,
            strcpy(sz_type,"");i=0;
            while(1)
            {
                fscanf(pf," %c",&c);
                if(c==',') break;
                sz_type[i]=c;
                sz_type[i+1]='\0';
                i++;
            }
            fscanf(pf," %c",&c); // " or '
            strcpy(sz_txt,"");i=0;
            while(1)
            {
                fscanf(pf,"%c",&c);
                if(c=='\'') break;
              //if(c=='\"') break;
                sz_txt[i]=c;
                sz_txt[i+1]='\0';
                i++;
            }

            //fprintf(pd,"\nt=%d x=%d y=%d",t,x,y);

            if(x>=TCO_NB_X) continue;
            if(y>=TCO_NB_Y) continue;

            type=TCO_TYPE_FREE;  //FREE n'est jamais sauve
            if(!stricmp(sz_type,"T"  )) type=TCO_TYPE_FREE;  //pr TXT
            if(!stricmp(sz_type,"H"  )) type=TCO_TYPE_H;
            if(!stricmp(sz_type,"V"  )) type=TCO_TYPE_V;
            if(!stricmp(sz_type,"NE" )) type=TCO_TYPE_NE;
            if(!stricmp(sz_type,"NO" )) type=TCO_TYPE_NO;
            if(!stricmp(sz_type,"SE" )) type=TCO_TYPE_SE;
            if(!stricmp(sz_type,"SO" )) type=TCO_TYPE_SO;
            if(!stricmp(sz_type,"HV" )) type=TCO_TYPE_HV;
            if(!stricmp(sz_type,"HD" )) type=TCO_TYPE_HD;
            if(!stricmp(sz_type,"VV" )) type=TCO_TYPE_VV;
            if(!stricmp(sz_type,"VD" )) type=TCO_TYPE_VD;
            if(!stricmp(sz_type,"ANE")) type=TCO_TYPE_ANE;
            if(!stricmp(sz_type,"ANO")) type=TCO_TYPE_ANO;
            if(!stricmp(sz_type,"ASE")) type=TCO_TYPE_ASE;
            if(!stricmp(sz_type,"ASO")) type=TCO_TYPE_ASO;
            if(!stricmp(sz_type,"VANE"))type=TCO_TYPE_VANE;
            if(!stricmp(sz_type,"VANO"))type=TCO_TYPE_VANO;
            if(!stricmp(sz_type,"VASE"))type=TCO_TYPE_VASE;
            if(!stricmp(sz_type,"VASO"))type=TCO_TYPE_VASO;
            if(!stricmp(sz_type,"VOY")) type=TCO_TYPE_VOY;
            if(!stricmp(sz_type,"INT")) type=TCO_TYPE_INT;
            if(!stricmp(sz_type,"BP" )) type=TCO_TYPE_BP;
            if(!stricmp(sz_type,"GO" )) type=TCO_TYPE_GO;
            if(!stricmp(sz_type,"ITI")) type=TCO_TYPE_ITI;
            if(!stricmp(sz_type,"HFG")) type=TCO_TYPE_HFG;
            if(!stricmp(sz_type,"HFD")) type=TCO_TYPE_HFD;
            if(!stricmp(sz_type,"SND")) type=TCO_TYPE_SND;
            if(!stricmp(sz_type,"EXE")) type=TCO_TYPE_EXE;
            if(!stricmp(sz_type,"DPL")) type=TCO_TYPE_DPL;
            if(!stricmp(sz_type,"BAL")) type=TCO_TYPE_BAL;
            if(!stricmp(sz_type,"BALV")) type=TCO_TYPE_BALV;
            if(!stricmp(sz_type,"HP" )) type=TCO_TYPE_HP;
            if(!stricmp(sz_type,"VP" )) type=TCO_TYPE_VP;

            tco[t][x][y][TCO_IND_TYPE]=type;
            tco[t][x][y][TCO_IND_SZ]=tco_sz_free;
            strcpy(&tco_sz[tco_sz_free],sz_txt);
            tco_sz_free+=strlen(sz_txt)+1;

            //fprintf(pd,"\nt=%d x=%d y=%d type=%d sz=%s",t,x,y,type,sz_txt);
            //fprintf(pd,"\nt=%d x=%d y=%d type=%d sz=%s",t,x,y,tco[t][x][y][TCO_IND_TYPE],&tco_sz[tco[t][x][y][TCO_IND_SZ]]);
        }

    }

    fclose(pf);
    //fclose(pd);
}

int tco_save(char* szFilename)
{
    /* 3. Verif */
    FILE* pd;
    char sz[1000];
    char c;
    int t,x,y,in,type,txt_ind;
    char sz_type[10];

    pd=fopen(szFilename,"wt");
    if(pd==NULL) return -1;

    fprintf(pd,"\n[tco]");
    for(t=0;t<TCO_NB;t++)
    {
        fprintf(pd,"\nt=%d",t);
        for(y=0;y<TCO_NB_Y;y++) for(x=0;x<TCO_NB_X;x++)
        {
            type=tco[t][x][y][TCO_IND_TYPE];
            txt_ind=tco[t][x][y][TCO_IND_SZ];
            if(type==TCO_TYPE_FREE && txt_ind==-1) continue;
            strcpy(sz_type,"?");
            if(type==TCO_TYPE_FREE) strcpy(sz_type,"T");
            if(type==TCO_TYPE_H   ) strcpy(sz_type,"H");
            if(type==TCO_TYPE_V   ) strcpy(sz_type,"V");
            if(type==TCO_TYPE_NE  ) strcpy(sz_type,"NE");
            if(type==TCO_TYPE_NO  ) strcpy(sz_type,"NO");
            if(type==TCO_TYPE_SE  ) strcpy(sz_type,"SE");
            if(type==TCO_TYPE_SO  ) strcpy(sz_type,"SO");
            if(type==TCO_TYPE_HV  ) strcpy(sz_type,"HV");
            if(type==TCO_TYPE_HD  ) strcpy(sz_type,"HD");
            if(type==TCO_TYPE_VV  ) strcpy(sz_type,"VV");
            if(type==TCO_TYPE_VD  ) strcpy(sz_type,"VD");
            if(type==TCO_TYPE_ANE ) strcpy(sz_type,"ANE");
            if(type==TCO_TYPE_ANO ) strcpy(sz_type,"ANO");
            if(type==TCO_TYPE_ASE ) strcpy(sz_type,"ASE");
            if(type==TCO_TYPE_ASO ) strcpy(sz_type,"ASO");
            if(type==TCO_TYPE_VANE) strcpy(sz_type,"VANE");
            if(type==TCO_TYPE_VANO) strcpy(sz_type,"VANO");
            if(type==TCO_TYPE_VASE) strcpy(sz_type,"VASE");
            if(type==TCO_TYPE_VASO) strcpy(sz_type,"VASO");
            if(type==TCO_TYPE_VOY ) strcpy(sz_type,"VOY");
            if(type==TCO_TYPE_INT ) strcpy(sz_type,"INT");
            if(type==TCO_TYPE_BP  ) strcpy(sz_type,"BP");
            if(type==TCO_TYPE_GO  ) strcpy(sz_type,"GO");
            if(type==TCO_TYPE_ITI ) strcpy(sz_type,"ITI");
            if(type==TCO_TYPE_HFD ) strcpy(sz_type,"HFD");
            if(type==TCO_TYPE_HFG ) strcpy(sz_type,"HFG");
            if(type==TCO_TYPE_SND ) strcpy(sz_type,"SND");
            if(type==TCO_TYPE_EXE ) strcpy(sz_type,"EXE");
            if(type==TCO_TYPE_DPL ) strcpy(sz_type,"DPL");
            if(type==TCO_TYPE_BAL ) strcpy(sz_type,"BAL");
            if(type==TCO_TYPE_BALV) strcpy(sz_type,"BALV");
            if(type==TCO_TYPE_HP  ) strcpy(sz_type,"HP");
            if(type==TCO_TYPE_VP  ) strcpy(sz_type,"VP");
          fprintf(pd,"\nc=%d,%d,%s,\'%s\'",x,y,sz_type,&tco_sz[txt_ind]);
        //fprintf(pd,"\nc=%d,%d,%s,\"%s\"",x,y,sz_type,&tco_sz[txt_ind]);
        }
    }

    fclose(pd);

    return 0;
}

int is_i_t(char* sz)
{
    char* pt;
    int num;
    pt=sz;

    while(*pt=='i' || *pt=='t')
    {
        num=atoi(pt+1);
        if(*pt=='i') if(num>=0 && (num/1000)<4 && (num%1000)<128 ) if(var_in[num/1000][num%1000]) return 1;
        if(*pt=='t') if(num>=0 && num<ITI_TAB_NB) if(iti_tab[num][ITI_TAB_IND_OK]) return 1;
        pt++; //'i'
        if(num>=0   && num<10   ) pt+=1;
        if(num>=10  && num<100  ) pt+=2;
        if(num>=100 && num<1000 ) pt+=3;
        if(num>=1000&& num<10000) pt+=4;
        if(*pt!=',') break;
        pt++; // ','
    }

    return 0;
}

int is_rouge_sz(char* sz)
{
    char* pt;
    int num;

    if((pt=strstr(sz,"r:" ))==NULL) return 0;
    return is_i_t(pt+2);
}

int is_jaune_sz(char* sz)
{
    char* pt;
    int num;

    if((pt=strstr(sz,"j:" ))==NULL) return 0;
    return is_i_t(pt+2);
}

int is_bleu_sz(char* sz)
{
    char* pt;
    int num;

    if((pt=strstr(sz,"gb:"))) return is_i_t(pt+3);
    if((pt=strstr(sz,"b:" ))) return is_i_t(pt+2);
    return 0;
}

int is_gros_sz(char* sz)
{
    char* pt;
    int num;

    if((pt=strstr(sz,"gb:"))) return is_i_t(pt+3);
    if((pt=strstr(sz,"g:" ))) return is_i_t(pt+2);
    return 0;
}

int is_gros_test_sz(char* sz)
{
    char* pt;
    int num;

    if(strstr(sz,"g:" )) return 1;
    if(strstr(sz,"gb:" )) return 1;
    return 0;
}

int is_res_sz(char* sz)
{
    char* pt;
    int num;

    if((pt=strstr(sz,"v:a" ))) { num=atoi(pt+3); if(ivar_res[num/1000][num%1000]) return 1; else return 0; }
    if((pt=strstr(sz,"v:!a"))) { num=atoi(pt+4); if(ivar_res[num/1000][num%1000]) return 1; else return 0; }

    return 0;
}

void tco_res_unres(int t, int x, int y, char* sz)
{
    char* pt;
    int num;
    int val;

    num=-1;
    if((pt=strstr(sz,"v:a" ))) num=atoi(pt+3);
    if((pt=strstr(sz,"v:!a"))) num=atoi(pt+4);
    if(num==-1) return;

    //val=100000+10000*t+100*x+y;
    val=100000; //UU a tester
    if(     ivar_res[num/1000][num%1000]==0  ) ivar_res[num/1000][num%1000]=val;
    else if(ivar_res[num/1000][num%1000]==val) ivar_res[num/1000][num%1000]=0  ;
}

int get_var_sz_state(char* sz)
{
    char* pt;
    //int num;

    if(pt=strstr(sz,"v:")) return get_var_str(pt+2);

    //if((pt=strstr(sz,"v:i" ))) { num=atoi(pt+3); if(var_in[num]) return 1; else return 0; }
    //if((pt=strstr(sz,"v:o" ))) { num=atoi(pt+3); if(var_out[num]) return 1; else return 0; }
    //if((pt=strstr(sz,"v:l" ))) { num=atoi(pt+3); if(var_led[num]) return 1; else return 0; }
    //if((pt=strstr(sz,"v:c" ))) { num=atoi(pt+3); if(var_cli[num]) return 1; else return 0; }
    //if((pt=strstr(sz,"v:a" ))) { num=atoi(pt+3); if(var_pos0[num]) return 0; if(var_pos1[num]) return 1; return -1; }
    //if((pt=strstr(sz,"v:!a"))) { num=atoi(pt+4); if(var_pos0[num]) return 1; if(var_pos1[num]) return 0; return -1; }
    return -1;
}

int get_var_sz_state_feu(char* sz)
{
    char* pt;
    //int num;

    if((pt=strstr(sz,"i" ))) return get_var_str(pt+1);
    if((pt=strstr(sz,"o" ))) return get_var_str(pt+1);
    if((pt=strstr(sz,"l" ))) return get_var_str(pt+1);
    if((pt=strstr(sz,"c" ))) return get_var_str(pt+1);
    if((pt=strstr(sz,"a" ))) return get_var_str(pt+1);
    if((pt=strstr(sz,"!a"))) return get_var_str(pt+1);

    //if((pt=strstr(sz,"i" ))) { num=atoi(pt+1); if(var_in[num]) return 1; else return 0; }
    //if((pt=strstr(sz,"o" ))) { num=atoi(pt+1); if(var_out[num]) return 1; else return 0; }
    //if((pt=strstr(sz,"l" ))) { num=atoi(pt+1); if(var_led[num]) { if(var_cli[num]) return 2; else return 1; } else return 0; }
    //if((pt=strstr(sz,"c" ))) { num=atoi(pt+1); if(var_cli[num]) return 1; else return 0; }
    //if((pt=strstr(sz,"a" ))) { num=atoi(pt+1); if(var_pos0[num]) return 0; if(var_pos1[num]) return 1; return -1; }
    //if((pt=strstr(sz,"!a"))) { num=atoi(pt+2); if(var_pos0[num]) return 1; if(var_pos1[num]) return 0; return -1; }
    return -1;
}

int disp_vars=1;
void aff_var(int x, int y, char* sz)
{
    if(disp_vars==0) return;

    char* pt;
    char* pd;
    int num;
    char szVar[100];

    pd=szVar; *pd='\0';
    if((pt=strstr(sz,"v:" )))
    {
        pt+=2;
        while((*pt)=='i' || (*pt)=='o' || (*pt)=='l' || (*pt)=='c' || (*pt)=='a' || (*pt)=='!' || ((*pt)>='0' && (*pt)<='9'))
        {
            *pd++=*pt++; *pd='\0';
        }
        TextOut(hdc_mem_tco,x,y,szVar,strlen(szVar));
    }
}

void change_var_sz(char* sz)
{
    char* pt;
    int num;

    if((pt=strstr(sz,"v:o"))) { num=atoi(pt+3); var_out[num/1000][num%1000]^=1; }
    if((pt=strstr(sz,"v:l"))) { num=atoi(pt+3); var_led[num/1000][num%1000]^=1; }
    if((pt=strstr(sz,"v:c"))) { num=atoi(pt+3); var_cli[num/1000][num%1000]^=1; }
    if((pt=strstr(sz,"v:a"))) { num=atoi(pt+3); if(ivar_res[num/1000][num%1000]==0) var_aigcmd[num/1000][num%1000]^=1; }
    if((pt=strstr(sz,"v:!a"))) { num=atoi(pt+4);if(ivar_res[num/1000][num%1000]==0) var_aigcmd[num/1000][num%1000]^=1; }
}

void set_var_sz(char* sz)
{
    char* pt;
    int num;

    if((pt=strstr(sz,"v:o"))) { num=atoi(pt+3); var_out[num/1000][num%1000]=1; }
    if((pt=strstr(sz,"v:l"))) { num=atoi(pt+3); var_led[num/1000][num%1000]=1; }
    if((pt=strstr(sz,"v:c"))) { num=atoi(pt+3); var_cli[num/1000][num%1000]=1; }
}

void clr_var_sz(char* sz)
{
    char* pt;
    int num;

    if((pt=strstr(sz,"v:o"))) { num=atoi(pt+3); var_out[num/1000][num%1000]=0; }
    if((pt=strstr(sz,"v:l"))) { num=atoi(pt+3); var_led[num/1000][num%1000]=0; }
    if((pt=strstr(sz,"v:c"))) { num=atoi(pt+3); var_cli[num/1000][num%1000]=0; }
}


void start_depl_sz(char* sz);

void go_tco_sz(char* sz)
{
    char c,old_c;
    char* pt;
    int t,x,y,v,n;

    t=x=y=v=n=0;
    old_c=' ';
    if((pt=strstr(sz,"go:" ))==NULL) return;
    pt+=3;
    while(c=*pt++)
    {
        if(c>='0' && c<='9')
        {
            v=10*v+c-'0';
            if(n==0) t=v;
            if(n==1) x=v;
            if(n==2) y=v;
        }
        else
        {
            if(old_c>='0' && old_c<='9')
            {
                n++; v=0;
            }
        }
        old_c=c;
    }
    tco_current=t;
    tco_x0=x;
    tco_y0=y;
}

void exe_sz(char* sz)
{
    int i,del;
    char c;
    char* pt;
    char szExe[1000];

    szExe[0]='\0';
    i=del=0;
    if((pt=strstr(sz,"exe:" ))==NULL) return;
    pt+=4;
    while(c=*pt++)
    {
        if(c=='\"')
        {
            del++;
            if(del==2)
            {
                 //sprintf(gszErr,"str=>%s<",szExe);MessageBox(NULL,gszErr,"debug",MB_OK);
                 ShellExecute(NULL,"open",szExe, NULL, NULL, SW_SHOWNA);
                break;
            }
        }
        else
        {
            if(del==1)
            {
                szExe[i]=c;
                szExe[i+1]='\0';
                i++;
            }
        }
   }
}

void tco_draw_texte(int type, int x, int y, char* sz)
{
    int i,del;
    char c;
    char* pt;
    char szExe[1000];
    int dy;

    szExe[0]='\0';
    i=del=0;
    if((pt=strstr(sz,"t:" ))==NULL) return;
    pt+=2;
    while(c=*pt++)
    {
        if(c=='\"')
        {
            del++;
            if(del==2)
            {
                dy=0;
                if(type==TCO_TYPE_HD || type==TCO_TYPE_ASE || type==TCO_TYPE_ASO) dy=-22;
                if(screen_zoom==0) TextOut(hdc_mem_tco,x+5,y+25+dy,szExe,strlen(szExe));
                if(screen_zoom==1) TextOut(hdc_mem_tco,x+2,y+5+dy,szExe,strlen(szExe));
                break;
            }
        }
        else
        {
            if(del==1)
            {
                szExe[i]=c;
                szExe[i+1]='\0';
                i++;
            }
        }
   }

    szExe[0]='\0';
    i=del=0;
    if((pt=strstr(sz,"T:" ))==NULL) return;
    pt+=2;
    while(c=*pt++)
    {
        if(c=='\"')
        {
            del++;
            if(del==2)
            {
                dy=0;
                if(screen_zoom==0) TextOut(hdc_mem_tco,x+5,y+5+dy,szExe,strlen(szExe));
                if(screen_zoom==1) TextOut(hdc_mem_tco,x+2,y+5+dy,szExe,strlen(szExe));
                break;
            }
        }
        else
        {
            if(del==1)
            {
                szExe[i]=c;
                szExe[i+1]='\0';
                i++;
            }
        }
   }
}

// draw eclise e:n,s,e,o,ne,no,se,so
void tco_draw_eclise(int x, int y, char* sz, int zoom)
{
    int x1,y1;
    char* pt;
    char c1,c2;

    if(zoom) return;
    if((pt=strstr(sz,"e:" ))==NULL) return;
    pt+=2;
    c1=*pt; c2=*(pt+1);
    if     (c1=='n' && c2=='o') { x1=0 ; y1=0 ; }
    else if(c1=='n' && c2=='e') { x1=34; y1=0 ; }
    else if(c1=='n'           ) { x1=16; y1=0 ; }
    else if(c1=='s' && c2=='o') { x1=0 ; y1=34; }
    else if(c1=='s' && c2=='e') { x1=34; y1=34; }
    else if(c1=='s'           ) { x1=16; y1=34; }
    else if(c1=='o'           ) { x1=0 ; y1=16; }
    else if(c1=='e'           ) { x1=34; y1=16; }
    else if(c1=='c'           ) { x1=16; y1=16; }
    else return;

    if(zoom) {x1=x1/2; y=y1/2;}

    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLEU);
    bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_BLEU);
    //Rectangle(hdc_mem_tco,x+x1,y+y1,x+x1+6,y+y1+6);
    Ellipse(hdc_mem_tco,x+x1,y+y1,x+x1+6,y+y1+6);
}

// draw eclise f:<x><y><r,v,j,b,w+var,p>
#define FEU_RIEN  -1
#define FEU_NOIR   0
#define FEU_ROUGE  1
#define FEU_VERT   2
#define FEU_JAUNE  3
#define FEU_BLANC  4
#define FEU_VIOLET 5
#define FEU_PIED   6
#define FEU_PIEDH  7
void tco_draw_feu(int x, int y, char* sz, int zoom)
{
    int i,j,ok,ret;
    char c;
    char* pt;
    int tab[5][5];
    char szDebug[100];

    for(i=0;i<5;i++) for(j=0;j<5;j++) tab[i][j]=FEU_RIEN; //-1=ne pas afficher

    if(zoom) return;
    if((pt=strstr(sz,"f:" ))==NULL) return;
    pt+=2;

    // 1. remplissage du tableau des couleurs
    while(1)
    {
        if((*pt)=='.' ) { pt++; continue; }
        if((*pt)==' ' ) break;
        if((*pt)=='\0') break;
        if((*pt)=='\t') break;

        i=(*pt)-'0';
        j=(*(pt+1))-'0';
        c=(*(pt+2));
        pt+=3;

        if(tab[i][j]==FEU_RIEN) tab[i][j]=FEU_NOIR;
        if(c=='n') tab[i][j]=FEU_NOIR;
        if(c=='p') tab[i][j]=FEU_PIED;
        if(c=='t') tab[i][j]=FEU_PIEDH;

        ok=0;
        if( (*pt)=='.' || (*pt)==' ' || (*pt)=='\0' || (*pt)=='\t' )
        {
            ok=1; //pas de variable -> dessin
        }
        else
        {
            ret=get_var_sz_state_feu(pt);
            if(ret==1) ok=1; //variable -> dessin suivant variable
            if(ret==2) if((tic_cpt%10)>=5) ok=1;
            while(1) { if( (*pt)=='.' || (*pt)==' ' || (*pt)=='\0' || (*pt)=='\t' ) break; pt++; }
        }

        if(ok)
        {
            if(c=='r') tab[i][j]=FEU_ROUGE;
            if(c=='v') tab[i][j]=FEU_VERT;
            if(c=='j') tab[i][j]=FEU_JAUNE;
            if(c=='b') tab[i][j]=FEU_BLANC;
            if(c=='w') tab[i][j]=FEU_VIOLET;
        }
    }

    // 2. dessin suivant le tableau
    for(i=0;i<5;i++) for(j=0;j<5;j++)
    {
        ok=0;
        if(tab[i][j]==FEU_RIEN) continue;
        if(tab[i][j]!=FEU_PIED && tab[i][j]!=FEU_PIEDH )
        { bmp_select_pen_brush(hdc_mem_tco,BMP_CST_COLOR_NOIR); Rectangle(hdc_mem_tco,x+8*i,y+8*j,x+8*i+8,y+8*j+8); }

        if(tab[i][j]==FEU_ROUGE ) { bmp_select_pen_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE ); ok=1; }
        if(tab[i][j]==FEU_VERT  ) { bmp_select_pen_brush(hdc_mem_tco,BMP_CST_COLOR_VERT  ); ok=1; }
        if(tab[i][j]==FEU_JAUNE ) { bmp_select_pen_brush(hdc_mem_tco,BMP_CST_COLOR_JAUNE ); ok=1; }
        if(tab[i][j]==FEU_BLANC ) { bmp_select_pen_brush(hdc_mem_tco,BMP_CST_COLOR_BLANC ); ok=1; }
        if(tab[i][j]==FEU_VIOLET) { bmp_select_pen_brush(hdc_mem_tco,BMP_CST_COLOR_VIOLET); ok=1; }
        if(ok) Ellipse(hdc_mem_tco,x+8*i,y+8*j,x+8*i+8,y+8*j+8);

        if(tab[i][j]==FEU_PIED ) { bmp_select_pen_brush(hdc_mem_tco,BMP_CST_COLOR_NOIR); EasyLine(hdc_mem_tco,x+8*i+4,y+8*j,x+8*i+4,y+8*j+8); }
        if(tab[i][j]==FEU_PIEDH) { bmp_select_pen_brush(hdc_mem_tco,BMP_CST_COLOR_NOIR); EasyLine(hdc_mem_tco,x+8*i,y+8*j+4,x+8*i+8,y+8*j+4); }
    }
}

int sel_gros=1;
#define RAIL_HO  0
#define RAIL_HE  1
#define RAIL_VN  2
#define RAIL_VS  3
#define RAIL_NE  4
#define RAIL_NO  5
#define RAIL_SE  6
#define RAIL_SO  7
void tco_rail(int no,int x,int y,int gros,int rouge)
{
    if(gros==-1) return;
    if(rouge==0) { if(gros==0 ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR ); if(gros==1 ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIREPAIS);  }
    if(rouge==1) { if(gros==0 ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_ROUGE); if(gros==1 ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_ROUGEEPAIS); }
    if(rouge==2) { if(gros==0 ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLEU ); if(gros==1 ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLEUEPAIS);  }

    switch(no)
    {
        case RAIL_HO: EasyLine(hdc_mem_tco,x+0 ,y+19,x+20,y+19); break;
        case RAIL_HE: EasyLine(hdc_mem_tco,x+20,y+19,x+40,y+19); break;
        case RAIL_VN: EasyLine(hdc_mem_tco,x+19,y+0 ,x+19,y+20); break;
        case RAIL_VS: EasyLine(hdc_mem_tco,x+19,y+20,x+19,y+40); break;
        case RAIL_NE: EasyLine(hdc_mem_tco,x+20,y+0 ,x+40,y+20); break;
        case RAIL_NO: EasyLine(hdc_mem_tco,x+20,y+0 ,x+0 ,y+20); break;
        case RAIL_SE: EasyLine(hdc_mem_tco,x+20,y+40,x+40,y+20); break;
        case RAIL_SO: EasyLine(hdc_mem_tco,x+20,y+40,x+0 ,y+20); break;
        default:break;
    }
    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
}

void cadenas(int x,int y)
{
    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
    bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
    Rectangle(hdc_mem_tco,x-5,y+0,x+5,y+5);
    EasyRect( hdc_mem_tco,x-3,y+0,x+2,y-5);
}
int aig_aff_repos=0; //-1;
int aig_aff_voy=1; //0;

void aff_voy_aig(int x,int y,int on)
{
    if(aig_aff_voy==0) return;
    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
    bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS); if(on) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_JAUNE);
    Rectangle(hdc_mem_tco,x,y,x+8,y+8);
}

void tco_draw_one(int x, int y, int type, int txt, int select)
{
    int i,taille,dtb,dth,rouge,gros;
    char sz[1000];
    char szTxt[10];
    int bal, bal_tr, bal_vit, bal_vit_type, bal_old, bal_res, pre_res;

    if(txt<0) strcpy(sz,""); else strcpy(sz,&tco_sz[txt]);

    SetBkMode(hdc_mem_tco,TRANSPARENT);
    SetTextColor(hdc_mem_tco,RGB(0,0,255));
    SelectObject(hdc_mem_tco,bmp_fonte);

    if(tco_edit==0                  ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLEU); //grille
    if(tco_edit==1 && (tco_cpt&4)==0) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLEU); //grille
    if(tco_edit==1 && (tco_cpt&4)   ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_ROUGE); //grille
    if(disp_grid==0)                  bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLANC); //grille
    if(tco_edit==0) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_BLANC); //fond
//    if(tco_edit==0) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRISVERT); //fond
    if(tco_edit==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_BLANC); //fond //ou ROSE
    if(select) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_JAUNE); //fonf
    Rectangle(hdc_mem_tco,x,y,x+41,y+41);

    //bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR); //voies
    rouge=0;
    if(is_bleu_sz(sz))  rouge=2;
    if(is_rouge_sz(sz)) rouge=1;
    gros=sel_gros;
    if(is_gros_test_sz(sz)) gros=is_gros_sz(sz);

    dtb=dth=0;

    switch(type)
    {
        case TCO_TYPE_H  : tco_rail(RAIL_HO,x,y,gros,rouge); tco_rail(RAIL_HE,x,y,gros,rouge); break;

        case TCO_TYPE_HFD: tco_rail(RAIL_HO,x,y,gros,rouge); tco_rail(RAIL_HE,x,y,gros,rouge);
                           //bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_VERT);
                           for(i=0;i<10;i++) EasyLine(hdc_mem_tco,x+15+i,y+19-i,x+15+i,y+19+i);
                           break;

        case TCO_TYPE_HFG: tco_rail(RAIL_HO,x,y,gros,rouge); tco_rail(RAIL_HE,x,y,gros,rouge);
                           //bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_VERT);
                           for(i=0;i<10;i++) EasyLine(hdc_mem_tco,x+25-i,y+19-i,x+25-i,y+19+i);
                           break;

        case TCO_TYPE_V  : tco_rail(RAIL_VN,x,y,gros,rouge); tco_rail(RAIL_VS,x,y,gros,rouge); break;
                                                                                  
        case TCO_TYPE_HP : tco_rail(RAIL_HO,x,y,gros,rouge); tco_rail(RAIL_HE,x,y,gros,rouge);
                           tco_rail(RAIL_VN,x,y,0,0);            tco_rail(RAIL_VS,x,y,0,0);
                            break;

        case TCO_TYPE_VP : tco_rail(RAIL_VN,x,y,gros,rouge); tco_rail(RAIL_VS,x,y,gros,rouge);
                           tco_rail(RAIL_HO,x,y,0,0);            tco_rail(RAIL_HE,x,y,0,0);
                           break;

        case TCO_TYPE_NE : tco_rail(RAIL_NE,x,y,gros,rouge); break;

        case TCO_TYPE_NO : tco_rail(RAIL_NO,x,y,gros,rouge); break;

        case TCO_TYPE_SE : tco_rail(RAIL_SE,x,y,gros,rouge); break;

        case TCO_TYPE_SO : tco_rail(RAIL_SO,x,y,gros,rouge); break;

        case TCO_TYPE_ANE: taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=gros; tco_rail(RAIL_HO,x,y,taille,rouge); tco_rail(RAIL_HE,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=gros; tco_rail(RAIL_NE,x,y,taille,rouge);
                           aff_voy_aig(x+18,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig(x+25,y+6 ,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas(x+10,y+10);
                           dtb=1; break;

        case TCO_TYPE_VANE:taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=gros; tco_rail(RAIL_VN,x,y,taille,rouge); tco_rail(RAIL_VS,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=gros; tco_rail(RAIL_NE,x,y,taille,rouge);
                           aff_voy_aig(x+18,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig(x+25,y+6 ,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas(x+10,y+10);
                           dtb=1; break;

        case TCO_TYPE_ANO: taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=gros; tco_rail(RAIL_HO,x,y,taille,rouge); tco_rail(RAIL_HE,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=gros; tco_rail(RAIL_NO,x,y,taille,rouge);
                           aff_voy_aig(x+14,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig(x+5 ,y+6 ,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas(x+30,y+10);
                           dtb=1; break;

        case TCO_TYPE_VANO:taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=gros; tco_rail(RAIL_VN,x,y,taille,rouge); tco_rail(RAIL_VS,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=gros; tco_rail(RAIL_NO,x,y,taille,rouge);
                           aff_voy_aig(x+14,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig(x+5 ,y+6 ,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas(x+30,y+10);
                           dtb=1; break;

        case TCO_TYPE_ASE: taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=gros; tco_rail(RAIL_HO,x,y,taille,rouge); tco_rail(RAIL_HE,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=gros; tco_rail(RAIL_SE,x,y,taille,rouge);
                           aff_voy_aig(x+18,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig(x+25,y+26,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas(x+10,y+30);
                           dth=1; break;

        case TCO_TYPE_VASE:taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=gros; tco_rail(RAIL_VN,x,y,taille,rouge); tco_rail(RAIL_VS,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=gros; tco_rail(RAIL_SE,x,y,taille,rouge);
                           bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           aff_voy_aig(x+18,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig(x+25,y+27,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas(x+10,y+30);
                           dtb=1; break;

        case TCO_TYPE_ASO: taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=gros; tco_rail(RAIL_HO,x,y,taille,rouge); tco_rail(RAIL_HE,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=gros; tco_rail(RAIL_SO,x,y,taille,rouge);
                           aff_voy_aig(x+18,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig(x+5 ,y+26,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas(x+30,y+30);
                           dth=1; break;

        case TCO_TYPE_VASO:taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=gros; tco_rail(RAIL_VN,x,y,taille,rouge); tco_rail(RAIL_VS,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=gros; tco_rail(RAIL_SO,x,y,taille,rouge);
                           aff_voy_aig(x+18,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig(x+5 ,y+26,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas(x+30,y+30);
                           dtb=1; break;

        case TCO_TYPE_HV : tco_rail(RAIL_HO,x,y,gros,rouge); tco_rail(RAIL_HE,x,y,gros,rouge);
                           bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
                           Rectangle(hdc_mem_tco,x+10,y+19-5,x+40-10,y+19+5);
                           dtb=1; break;

        case TCO_TYPE_HD : tco_rail(RAIL_HO,x,y,gros,rouge); tco_rail(RAIL_HE,x,y,gros,rouge);
                           bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_VERT);
                           for(i=0;i<10;i++) EasyLine(hdc_mem_tco,x+20-i,y+19+i,x+20+i,y+19+i);
                           dth=1; break;

        case TCO_TYPE_VV : tco_rail(RAIL_VN,x,y,gros,rouge); tco_rail(RAIL_VS,x,y,gros,rouge);
                           bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
                           Rectangle(hdc_mem_tco,x+19-5,y+10,x+19+5,y+40-10);
                           dtb=1; break;

        case TCO_TYPE_VD : tco_rail(RAIL_VN,x,y,gros,rouge); tco_rail(RAIL_VS,x,y,gros,rouge);
                           bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_VERT);
                           for(i=0;i<10;i++) EasyLine(hdc_mem_tco,x+20+i,y+20-i,x+20+i,y+20+i);
                           dtb=1; break;

        case TCO_TYPE_VOY: bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
                           Rectangle(hdc_mem_tco,x+10,y+19-5,x+40-10,y+19+5);
                           break;

        case TCO_TYPE_INT: bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           EasyLine(hdc_mem_tco,x+3 ,y+3 ,x+37,y+3 );
                           EasyLine(hdc_mem_tco,x+3 ,y+37,x+37,y+37);
                           EasyLine(hdc_mem_tco,x+3 ,y+3 ,x+3 ,y+37);
                           EasyLine(hdc_mem_tco,x+37,y+3 ,x+37,y+37);
                           EasyLine(hdc_mem_tco,x+3 ,y+20,x+37,y+20);
                           bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
                           Rectangle(hdc_mem_tco,x+7,y+6,x+17,y+16);
                           break;

        case TCO_TYPE_BP : bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           EasyLine(hdc_mem_tco,x+3 ,y+3 ,x+37,y+3 );
                           EasyLine(hdc_mem_tco,x+3 ,y+37,x+37,y+37);
                           EasyLine(hdc_mem_tco,x+3 ,y+3 ,x+3 ,y+37);
                           EasyLine(hdc_mem_tco,x+37,y+3 ,x+37,y+37);
                           bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
                           Rectangle(hdc_mem_tco,x+7,y+6,x+17,y+16);
                           break;

        case TCO_TYPE_GO : bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           EasyLine(hdc_mem_tco,x+5 ,y+10,x+30,y+10);
                           EasyLine(hdc_mem_tco,x+30,y+10,x+24,y+4);
                           EasyLine(hdc_mem_tco,x+30,y+10,x+24,y+16);
                           break;

        case TCO_TYPE_ITI: bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRISVERT);
                           if(iti_type(sz)==0) //direct
                           {
                               if(iti_led(sz)) { SetTextColor(hdc_mem_tco,RGB(0,0,0  )); bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_VERT); }
                               else              SetTextColor(hdc_mem_tco,RGB(0,255,0));
                           }
                           if(iti_type(sz)==1) //TP
                           {
                               if(iti_led(sz)) { SetTextColor(hdc_mem_tco,RGB(0,0,0    )); bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_JAUNE); }
                               else              SetTextColor(hdc_mem_tco,RGB(255,255,0));
                           }
                           if(iti_type(sz)==2) //DA
                           {
                               if(iti_led(sz)) { SetTextColor(hdc_mem_tco,RGB(0,0,0      )); bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_BLANC); }
                               else              SetTextColor(hdc_mem_tco,RGB(255,255,255));
                           }
                           Rectangle(hdc_mem_tco,x+3,y+3,x+37,y+37);
                           break;

        case TCO_TYPE_SND: bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           EasyLine(hdc_mem_tco,x+10,y+10,x+10,y+30);
                           EasyLine(hdc_mem_tco,x+20,y+10,x+20,y+30);
                           EasyLine(hdc_mem_tco,x+10,y+10,x+20,y+10);
                           EasyLine(hdc_mem_tco,x+10,y+30,x+20,y+30);
                           EasyLine(hdc_mem_tco,x+20,y+20,x+30,y+10);
                           EasyLine(hdc_mem_tco,x+20,y+20,x+30,y+30);
                           EasyLine(hdc_mem_tco,x+30,y+10,x+30,y+30);
                           break;

        case TCO_TYPE_EXE: bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           EasyLine(hdc_mem_tco,x+10,y+10,x+10,y+30);
                           EasyLine(hdc_mem_tco,x+10,y+10,x+30,y+20);
                           EasyLine(hdc_mem_tco,x+10,y+30,x+30,y+20);
                           break;

        case TCO_TYPE_DPL: bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           EasyRect(hdc_mem_tco,x+10,y+20,x+30,y+30);
                           EasyRect(hdc_mem_tco,x+20,y+10,x+30,y+20);
                           EasyRect(hdc_mem_tco,x+15-2,y+30-2,x+15+2,y+30+2);
                           EasyRect(hdc_mem_tco,x+25-2,y+30-2,x+25+2,y+30+2);
                           break;

        case TCO_TYPE_BALV:tco_rail(RAIL_VN,x,y,sel_gros,rouge); tco_rail(RAIL_VS,x,y,sel_gros,rouge);
                           if(disp_bal==0) break;
                           goto tco_balh;

        case TCO_TYPE_BAL: tco_rail(RAIL_HO,x,y,sel_gros,rouge); tco_rail(RAIL_HE,x,y,sel_gros,rouge);
                           if(disp_bal==0) break;
tco_balh:
                           bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           get_bal(sz, &bal, &bal_tr, &bal_vit, &bal_vit_type, &bal_old, &bal_res, &pre_res);
                           if(bal==99) break; //error
                           if(pre_res)
                           {
                               bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRISFONCE);
                               Rectangle(hdc_mem_tco,x+3,y+3,x+37,y+37);
                               sprintf(szTxt,"tr%02d",pre_res); TextOut(hdc_mem_tco,x+4,y+5,szTxt,strlen(szTxt));
                           }
                           else if(bal_tr==0)
                           {
                                bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                                Rectangle(hdc_mem_tco,x+3,y+3,x+37,y+37);
                           }
                           else
                           {
                               if(bal_vit_type==BAL_CANT_VIT_TYPE_ZERO) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
                               if(bal_vit_type==BAL_CANT_VIT_TYPE_RAL ) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_JAUNE);
                               if(bal_vit_type==BAL_CANT_VIT_TYPE_MAX ) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_VERT);
                               if(bal_old                             ) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                               Rectangle(hdc_mem_tco,x+3,y+3,x+37,y+37);
                               sprintf(szTxt,"tr%02d",bal_tr ); TextOut(hdc_mem_tco,x+4,y+5,szTxt,strlen(szTxt));
                               if(bal_vit_type==BAL_CANT_VIT_TYPE_RAL || bal_vit_type==BAL_CANT_VIT_TYPE_MAX) if(bal_old==0)
                               { sprintf(szTxt,"v=%02d",bal_vit); TextOut(hdc_mem_tco,x+4,y+24,szTxt,strlen(szTxt)); }
                           }
                           if(bal_res) cadenas(x+30,y+30);

                           break;

        default: break;
    }

    tco_draw_texte(type,x,y,sz);
    if(strstr(sz,"t:")==NULL && strstr(sz,"T:")==NULL) { if(dth) aff_var(x+5,y+3,sz); else /*if(dtb)*/ aff_var(x+5,y+26,sz); }

    tco_draw_eclise(x,y,sz,0);
    tco_draw_feu(x,y,sz,0);
    simu_draw();
}


void EasyRectZoom(HDC hdc,int x,int y,int x1,int y1,int x2,int y2)
{
    EasyRect(hdc,x+(x1-x)/2,y+(y1-y)/2,x+(x2-x)/2,y+(y2-y)/2);
}
void EasyLineZoom(HDC hdc,int x,int y,int x1,int y1,int x2,int y2)
{
    EasyLine(hdc,x+(x1-x)/2,y+(y1-y)/2,x+(x2-x)/2,y+(y2-y)/2);
}

void RectangleZoom(HDC hdc,int x,int y,int x1,int y1,int x2,int y2)
{
    Rectangle(hdc,x+(x1-x)/2,y+(y1-y)/2,x+(x2-x)/2,y+(y2-y)/2);
}

void RectangleZoom2(HDC hdc,int x,int y,int x1,int y1,int x2,int y2)
{
    Rectangle(hdc,x+x1/2,y+y1/2,x+x2/2,y+y2/2);
}

void tco_rail_zoom(int no,int x,int y,int gros,int rouge)
{
    if(gros==-1) return;
    if(rouge==0) { if(gros==0 ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR ); if(gros==1 ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIREPAIS);  }
    if(rouge==1) { if(gros==0 ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_ROUGE); if(gros==1 ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_ROUGEEPAIS); }

    switch(no)
    {
        case RAIL_HO: EasyLineZoom(hdc_mem_tco,x,y,x+0 ,y+19,x+20,y+19); break;
        case RAIL_HE: EasyLineZoom(hdc_mem_tco,x,y,x+20,y+19,x+40,y+19); break;
        case RAIL_VN: EasyLineZoom(hdc_mem_tco,x,y,x+19,y+0 ,x+19,y+20); break;
        case RAIL_VS: EasyLineZoom(hdc_mem_tco,x,y,x+19,y+20,x+19,y+40); break;
        case RAIL_NE: EasyLineZoom(hdc_mem_tco,x,y,x+20,y+0 ,x+40,y+20); break;
        case RAIL_NO: EasyLineZoom(hdc_mem_tco,x,y,x+20,y+0 ,x+0 ,y+20); break;
        case RAIL_SE: EasyLineZoom(hdc_mem_tco,x,y,x+20,y+40,x+40,y+20); break;
        case RAIL_SO: EasyLineZoom(hdc_mem_tco,x,y,x+20,y+40,x+0 ,y+20); break;
        default:break;
    }
    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
}

void cadenas_zoom(int x, int y, int x1,int y1)
{
    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
    bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
    RectangleZoom(hdc_mem_tco,x,y,x1-5,y1+0,x1+5,y1+5);
    EasyRectZoom( hdc_mem_tco,x,y,x1-3,y1+0,x1+2,y1-5);
}

void aff_voy_aig_zoom(int x,int y, int x1,int y1,int on)
{
    if(aig_aff_voy==0) return;
    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
    bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS); if(on) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_JAUNE);
    RectangleZoom(hdc_mem_tco,x,y,x1-0,y1-0,x1+8+0,y1+8+0);
}

void tco_draw_one_zoom(int x, int y, int type, int txt, int select)
{
    int i,taille,rouge;
    char sz[1000];
    char szTxt[10];
    int bal, bal_tr, bal_vit, bal_vit_type, bal_old, bal_res, bal_pre_res;

    if(txt<0) strcpy(sz,""); else strcpy(sz,&tco_sz[txt]);

    SetBkMode(hdc_mem_tco,TRANSPARENT);
    SetTextColor(hdc_mem_tco,RGB(0,0,255));
    SelectObject(hdc_mem_tco,bmp_fonte);

    if(tco_edit==0                  ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLEU); //grille
    if(tco_edit==1 && (tco_cpt&4)==0) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLEU); //grille
    if(tco_edit==1 && (tco_cpt&4)   ) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_ROUGE); //grille
    if(disp_grid==0)                  bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLANC); //grille
    if(tco_edit==0) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_BLANC); //fond
    if(tco_edit==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_BLANC); //fond //ou ROSE
    if(select) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_JAUNE); //fonf
    Rectangle(hdc_mem_tco,x,y,x+41,y+41);

    //bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR); //voies
    rouge=is_rouge_sz(sz);

    switch(type)
    {
        case TCO_TYPE_H  : tco_rail_zoom(RAIL_HO,x,y,sel_gros,rouge); tco_rail_zoom(RAIL_HE,x,y,sel_gros,rouge); break;

        case TCO_TYPE_V  : tco_rail_zoom(RAIL_VN,x,y,sel_gros,rouge); tco_rail_zoom(RAIL_VS,x,y,sel_gros,rouge); break;

        case TCO_TYPE_HP : tco_rail_zoom(RAIL_HO,x,y,sel_gros,rouge); tco_rail_zoom(RAIL_HE,x,y,sel_gros,rouge);
                           tco_rail_zoom(RAIL_VN,x,y,0,0);            tco_rail_zoom(RAIL_VS,x,y,0,0);            break;

        case TCO_TYPE_VP : tco_rail_zoom(RAIL_VN,x,y,sel_gros,rouge); tco_rail_zoom(RAIL_VS,x,y,sel_gros,rouge);
                           tco_rail_zoom(RAIL_HO,x,y,0,0);            tco_rail_zoom(RAIL_HE,x,y,0,0);            break;

        case TCO_TYPE_NE : tco_rail_zoom(RAIL_NE,x,y,sel_gros,rouge); break;

        case TCO_TYPE_NO : tco_rail_zoom(RAIL_NO,x,y,sel_gros,rouge); break;

        case TCO_TYPE_SE : tco_rail_zoom(RAIL_SE,x,y,sel_gros,rouge); break;

        case TCO_TYPE_SO : tco_rail_zoom(RAIL_SO,x,y,sel_gros,rouge); break;

        case TCO_TYPE_ANE: taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=sel_gros; tco_rail_zoom(RAIL_HO,x,y,taille,rouge); tco_rail_zoom(RAIL_HE,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=sel_gros; tco_rail_zoom(RAIL_NE,x,y,taille,rouge);
                           aff_voy_aig_zoom(x,y,x+18,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig_zoom(x,y,x+25,y+6 ,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas_zoom(x,y,x+10,y+10);
                           break;

        case TCO_TYPE_VANE:taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=sel_gros; tco_rail_zoom(RAIL_VN,x,y,taille,rouge); tco_rail_zoom(RAIL_VS,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=sel_gros; tco_rail_zoom(RAIL_NE,x,y,taille,rouge);
                           aff_voy_aig_zoom(x,y,x+18,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig_zoom(x,y,x+25,y+6 ,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas_zoom(x,y,x+10,y+10);
                           break;

        case TCO_TYPE_ANO: taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=sel_gros; tco_rail_zoom(RAIL_HO,x,y,taille,rouge); tco_rail_zoom(RAIL_HE,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=sel_gros; tco_rail_zoom(RAIL_NO,x,y,taille,rouge);
                           aff_voy_aig_zoom(x,y,x+14,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig_zoom(x,y,x+5 ,y+6 ,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas_zoom(x,y,x+30,y+10);
                           break;

        case TCO_TYPE_VANO:taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=sel_gros; tco_rail_zoom(RAIL_VN,x,y,taille,rouge); tco_rail_zoom(RAIL_VS,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=sel_gros; tco_rail_zoom(RAIL_NO,x,y,taille,rouge);
                           aff_voy_aig_zoom(x,y,x+14,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig_zoom(x,y,x+5 ,y+6 ,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas_zoom(x,y,x+30,y+10);
                           break;

        case TCO_TYPE_ASE: taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=sel_gros; tco_rail_zoom(RAIL_HO,x,y,taille,rouge); tco_rail_zoom(RAIL_HE,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=sel_gros; tco_rail_zoom(RAIL_SE,x,y,taille,rouge);
                           aff_voy_aig_zoom(x,y,x+18,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig_zoom(x,y,x+25,y+26,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas_zoom(x,y,x+10,y+30);
                           break;

        case TCO_TYPE_VASE:taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=sel_gros; tco_rail_zoom(RAIL_VN,x,y,taille,rouge); tco_rail_zoom(RAIL_VS,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=sel_gros; tco_rail_zoom(RAIL_SE,x,y,taille,rouge);
                           bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           aff_voy_aig_zoom(x,y,x+18,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig_zoom(x,y,x+25,y+27,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas_zoom(x,y,x+10,y+30);
                           break;

        case TCO_TYPE_ASO: taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=sel_gros; tco_rail_zoom(RAIL_HO,x,y,taille,rouge); tco_rail_zoom(RAIL_HE,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=sel_gros; tco_rail_zoom(RAIL_SO,x,y,taille,rouge);
                           aff_voy_aig_zoom(x,y,x+18,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig_zoom(x,y,x+5 ,y+26,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas_zoom(x,y,x+30,y+30);
                           break;

        case TCO_TYPE_VASO:taille=aig_aff_repos; if(get_var_sz_state(sz)==0) taille=sel_gros; tco_rail_zoom(RAIL_VN,x,y,taille,rouge); tco_rail_zoom(RAIL_VS,x,y,taille,rouge);
                           taille=aig_aff_repos; if(get_var_sz_state(sz)==1) taille=sel_gros; tco_rail_zoom(RAIL_SO,x,y,taille,rouge);
                           aff_voy_aig_zoom(x,y,x+18,y+15,get_var_sz_state(sz)==0);
                           aff_voy_aig_zoom(x,y,x+5 ,y+26,get_var_sz_state(sz)==1);
                           if(is_res_sz(sz)) cadenas_zoom(x,y,x+30,y+30);
                           break;

        case TCO_TYPE_HV : tco_rail_zoom(RAIL_HO,x,y,sel_gros,rouge); tco_rail_zoom(RAIL_HE,x,y,sel_gros,rouge);
                           bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
                           //RectangleZoom(hdc_mem_tco,x,y,x+10,y+19-5,x+40-10,y+19+5);
                           RectangleZoom(hdc_mem_tco,x,y,x+10,y+19-8,x+40-10,y+19+8);
                           break;

        case TCO_TYPE_HD : tco_rail_zoom(RAIL_HO,x,y,sel_gros,rouge); tco_rail_zoom(RAIL_HE,x,y,sel_gros,rouge);
                           bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_VERT);
                           for(i=0;i<10;i++) EasyLineZoom(hdc_mem_tco,x,y,x+20-i,y+19+i,x+20+i,y+19+i);
                           break;

        case TCO_TYPE_VV : tco_rail_zoom(RAIL_VN,x,y,sel_gros,rouge); tco_rail_zoom(RAIL_VS,x,y,sel_gros,rouge);
                           bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
                           //RectangleZoom(hdc_mem_tco,x,y,x+19-5,y+10,x+19+5,y+40-10);
                           RectangleZoom(hdc_mem_tco,x,y,x+19-8,y+10,x+19+8,y+40-10);
                           break;

        case TCO_TYPE_VD : tco_rail_zoom(RAIL_VN,x,y,sel_gros,rouge); tco_rail_zoom(RAIL_VS,x,y,sel_gros,rouge);
                           bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_VERT);
                           for(i=0;i<10;i++) EasyLineZoom(hdc_mem_tco,x,y,x+20+i,y+20-i,x+20+i,y+20+i);
                           break;

        case TCO_TYPE_VOY: bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
                           RectangleZoom(hdc_mem_tco,x,y,x+10,y+19-5,x+40-10,y+19+5);
                           break;

        case TCO_TYPE_INT: bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           EasyLineZoom(hdc_mem_tco,x,y,x+3 ,y+3 ,x+37,y+3 );
                           EasyLineZoom(hdc_mem_tco,x,y,x+3 ,y+37,x+37,y+37);
                           EasyLineZoom(hdc_mem_tco,x,y,x+3 ,y+3 ,x+3 ,y+37);
                           EasyLineZoom(hdc_mem_tco,x,y,x+37,y+3 ,x+37,y+37);
                           EasyLineZoom(hdc_mem_tco,x,y,x+3 ,y+20,x+37,y+20);
                           bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
                           RectangleZoom(hdc_mem_tco,x,y,x+7,y+6,x+17,y+16);
                           break;

        case TCO_TYPE_BP : bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           EasyLineZoom(hdc_mem_tco,x,y,x+3 ,y+3 ,x+37,y+3 );
                           EasyLineZoom(hdc_mem_tco,x,y,x+3 ,y+37,x+37,y+37);
                           EasyLineZoom(hdc_mem_tco,x,y,x+3 ,y+3 ,x+3 ,y+37);
                           EasyLineZoom(hdc_mem_tco,x,y,x+37,y+3 ,x+37,y+37);
                           bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(get_var_sz_state(sz)==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
                           RectangleZoom(hdc_mem_tco,x,y,x+7,y+6,x+17,y+16);
                           break;

        case TCO_TYPE_GO : bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           EasyLineZoom(hdc_mem_tco,x,y,x+5 ,y+10,x+30,y+10);
                           EasyLineZoom(hdc_mem_tco,x,y,x+30,y+10,x+24,y+4);
                           EasyLineZoom(hdc_mem_tco,x,y,x+30,y+10,x+24,y+16);
                           break;
        /*
        case TCO_TYPE_ITI: bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_GRISVERT);
                           bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                           if(is_iti_ok(sz)) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_BLEU);
                           Ellipse(hdc_mem_tco,x+1,y+1,x+19,y+19);
                           break;                                 */

        case TCO_TYPE_SND: bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           EasyLineZoom(hdc_mem_tco,x,y,x+10,y+10,x+10,y+30);
                           EasyLineZoom(hdc_mem_tco,x,y,x+20,y+10,x+20,y+30);
                           EasyLineZoom(hdc_mem_tco,x,y,x+10,y+10,x+20,y+10);
                           EasyLineZoom(hdc_mem_tco,x,y,x+10,y+30,x+20,y+30);
                           EasyLineZoom(hdc_mem_tco,x,y,x+20,y+20,x+30,y+10);
                           EasyLineZoom(hdc_mem_tco,x,y,x+20,y+20,x+30,y+30);
                           EasyLineZoom(hdc_mem_tco,x,y,x+30,y+10,x+30,y+30);
                           break;

        case TCO_TYPE_EXE: bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           EasyLineZoom(hdc_mem_tco,x,y,x+10,y+10,x+10,y+30);
                           EasyLineZoom(hdc_mem_tco,x,y,x+10,y+10,x+30,y+20);
                           EasyLineZoom(hdc_mem_tco,x,y,x+10,y+30,x+30,y+20);
                           break;

        case TCO_TYPE_DPL: bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           EasyRectZoom(hdc_mem_tco,x,y,x+10,y+20,x+30,y+30);
                           EasyRectZoom(hdc_mem_tco,x,y,x+20,y+10,x+30,y+20);
                           EasyRectZoom(hdc_mem_tco,x,y,x+15-2,y+30-2,x+15+2,y+30+2);
                           EasyRectZoom(hdc_mem_tco,x,y,x+25-2,y+30-2,x+25+2,y+30+2);
                           break;

        case TCO_TYPE_BALV:tco_rail_zoom(RAIL_VN,x,y,sel_gros,rouge); tco_rail_zoom(RAIL_VS,x,y,sel_gros,rouge);
                           if(disp_bal==0) break;
                           goto tco_balh;

        case TCO_TYPE_BAL: tco_rail_zoom(RAIL_HO,x,y,sel_gros,rouge); tco_rail_zoom(RAIL_HE,x,y,sel_gros,rouge);
                           if(disp_bal==0) break;
tco_balh:
                           bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                           get_bal(sz, &bal, &bal_tr, &bal_vit, &bal_vit_type, &bal_old, &bal_res, &bal_pre_res);
                           if(bal_tr==0)
                           {
                                bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
                                RectangleZoom(hdc_mem_tco,x,y,x+3,y+3,x+37,y+37);
                                if(bal==99) break;
                                if(bal_res) cadenas_zoom(x,y,x+30,y+30);
                           }
                           else
                           {
                               if(bal_vit_type==BAL_CANT_VIT_TYPE_ZERO) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
                               if(bal_vit_type==BAL_CANT_VIT_TYPE_RAL ) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_JAUNE);
                               if(bal_vit_type==BAL_CANT_VIT_TYPE_MAX ) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_VERT);
                               if(bal_old                             ) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_NOIR);
                               RectangleZoom(hdc_mem_tco,x,y,x+3,y+3,x+37,y+37);
                               sprintf(szTxt,"tr%02d",bal_tr ); TextOut(hdc_mem_tco,x+4,y+5,szTxt,strlen(szTxt));
                               if(bal_vit_type==BAL_CANT_VIT_TYPE_RAL || bal_vit_type==BAL_CANT_VIT_TYPE_MAX) if(bal_old==0)
                               { sprintf(szTxt,"v=%02d",bal_vit); TextOut(hdc_mem_tco,x+4,y+24,szTxt,strlen(szTxt)); }
                           }
                           break;
        default: break;
    }

    tco_draw_texte(type,x,y,sz);
    tco_draw_eclise(x,y,sz,1);
    tco_draw_feu(x,y,sz,1);
    simu_draw();
}

// -1 pour rien
int disp_type[4][10]={ { TCO_TYPE_FREE, TCO_TYPE_H , TCO_TYPE_V  , TCO_TYPE_DPL, TCO_TYPE_VOY, TCO_TYPE_ITI  , TCO_TYPE_HFD, TCO_TYPE_HFG , TCO_TYPE_FREE, TCO_TYPE_FREE },
                       { TCO_TYPE_SE  , TCO_TYPE_SO, TCO_TYPE_ASE, TCO_TYPE_ASO, TCO_TYPE_VASE, TCO_TYPE_VASO, TCO_TYPE_INT, TCO_TYPE_BAL , TCO_TYPE_BALV, TCO_TYPE_FREE },
                       { TCO_TYPE_NE  , TCO_TYPE_NO, TCO_TYPE_ANE, TCO_TYPE_ANO, TCO_TYPE_VANE, TCO_TYPE_VANO, TCO_TYPE_BP , TCO_TYPE_HP  , TCO_TYPE_FREE, TCO_TYPE_FREE },
                       { TCO_TYPE_HV  , TCO_TYPE_HD, TCO_TYPE_VV , TCO_TYPE_VD , TCO_TYPE_GO , TCO_TYPE_EXE  , TCO_TYPE_SND, TCO_TYPE_VP  , TCO_TYPE_FREE, TCO_TYPE_FREE } };
int tco_type_selected=2;
char sz_tco_txt[1000]="tapez le texte ici";
int xc,yc;

int vit2cmd(int vit) { int cmd; cmd=vit/2; if(vit&1) cmd|=0x10; return cmd; }

int cmd2vit(int cmd) { int vit; vit=2*(cmd&0x0f); if(cmd&0x10) vit++; return vit; }

int regu_sel=-1;
int mouse_centrale[16]={1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0};
int mouse_auto[16]    ={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

int man=0;
void tco_char_reg(char c)
{
    int vit;

    if(regu_sel==-1) return;
    if(mouse_centrale[regu_sel]) return;

    if(c=='+')
    {
        vit=cmd2vit(rs232_cmd[regu_sel]);
        if(vit<31) vit++;
        rs232_cmd[regu_sel]&=0xe0;
        rs232_cmd[regu_sel]|=vit2cmd(vit);
    }

    if(c=='-')
    {
        vit=cmd2vit(rs232_cmd[regu_sel]);
        if(vit>0) vit--;
        rs232_cmd[regu_sel]&=0xe0;
        rs232_cmd[regu_sel]|=vit2cmd(vit);
    }

    if(c=='/')
    {
        rs232_cmd[regu_sel]^=0x20;
    }

    if(c=='*')
    {
        rs232_fct[regu_sel]^=0x10;
    }

    if(c=='.' )
    {
        rs232_cmd[regu_sel]&=0xe0;
    }

    if(c=='m' || c=='M')
    {
        man=1;
        vit=vManTrain[rs232_adr[regu_sel]];
        rs232_cmd[regu_sel]&=0xe0;
        rs232_cmd[regu_sel]|=vit2cmd(vit);
    }

    if(c==-1) if(man) { rs232_cmd[regu_sel]&=0xe0; man=0; }
}

void regu_action(int regu, int xr, int yr)
{
    int xc,yc,vit;

    xc=xr/30; yc=yr/20;

    if(xc==1 && yc==2) rs232_fct[regu]^=1;   ;//F1
    if(xc==1 && yc==3) rs232_fct[regu]^=2;   ;//F2
    if(xc==1 && yc==4) rs232_fct[regu]^=4;   ;//F3
    if(xc==1 && yc==5) rs232_fct[regu]^=8;   ;//F4
    if(xc==0 && yc==5) rs232_fct[regu]^=16;  ;//F0

    if(xc==0 && yc==0) rs232_adr[regu]=nb_0_99;

    if(xc==1 && yc==0)
    {
        vit=nb_0_99; if(vit>31) vit=31;
        rs232_cmd[regu]&=0xe0;
        rs232_cmd[regu]|=vit2cmd(vit);
    }

    if(xc==0 && yc==2)
    {
        vit=cmd2vit(rs232_cmd[regu]);
        if(vit<31) vit++;
        rs232_cmd[regu]&=0xe0;
        rs232_cmd[regu]|=vit2cmd(vit);
    }

    if(xc==0 && yc==3)
    {
        vit=cmd2vit(rs232_cmd[regu]);
        if(vit>0) vit--;
        rs232_cmd[regu]&=0xe0;
        rs232_cmd[regu]|=vit2cmd(vit);
    }

    if(xc==0 && yc==4)
    {
        rs232_cmd[regu]^=0x20;
    }
}


void tco_draw_reg_panel(int y_panel)
{
    int i,j,x0,y0,dx,adr,vit,xr;
    char szTemp[100];
    char c;

    // 1. Rectangle de fond du panneau
    //bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_CYAN); //grille
    //bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_CYAN); //fonf
    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLEU); //grille
    bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_BLEU); //fonf
    Rectangle(hdc_mem_tco,0,y_panel,2000,y_panel+200);
    //bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
    bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_BLANC);

    // 2. Titre
    sprintf(szTemp,"panneau");   TextOut(hdc_mem_tco,0+3,y_panel+3,szTemp,strlen(szTemp));
    sprintf(szTemp,"des regus"); TextOut(hdc_mem_tco,0+3,y_panel+15+3,szTemp,strlen(szTemp));

    // 3. Affichage des deplacements (tco_x0, tco_y0 et tco_edit_pos)
    //bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLANC);
    x0=10;
    y0=y_panel+40;
    EasyLine(hdc_mem_tco,x0+10,y0+0 ,x0+10,y0+20); EasyLine(hdc_mem_tco,x0+10,y0+0 ,x0+20,y0+10); EasyLine(hdc_mem_tco,x0+10,y0+0 ,x0+0 ,y0+10);
    EasyLine(hdc_mem_tco,x0+30,y0+0 ,x0+30,y0+20); EasyLine(hdc_mem_tco,x0+30,y0+20,x0+20,y0+10); EasyLine(hdc_mem_tco,x0+30,y0+20,x0+40,y0+10);
    EasyLine(hdc_mem_tco,x0+40,y0+0 ,x0+60,y0+20); EasyLine(hdc_mem_tco,x0+40,y0+20,x0+60,y0+ 0);

    x0=10;
    y0=y_panel+80;
    EasyLine(hdc_mem_tco,x0+30,y0   ,x0+30,y0+20); EasyLine(hdc_mem_tco,x0+30,y0   ,x0+20,y0+10); EasyLine(hdc_mem_tco,x0+30,y0   ,x0+40,y0+10);
    EasyLine(hdc_mem_tco,x0   ,y0+30,x0+20,y0+30); EasyLine(hdc_mem_tco,x0   ,y0+30,x0+10,y0+20); EasyLine(hdc_mem_tco,x0   ,y0+30,x0+10,y0+40);
    EasyLine(hdc_mem_tco,x0+60,y0+30,x0+40,y0+30); EasyLine(hdc_mem_tco,x0+60,y0+30,x0+50,y0+20); EasyLine(hdc_mem_tco,x0+60,y0+30,x0+50,y0+40);
    EasyLine(hdc_mem_tco,x0+30,y0+60,x0+30,y0+40); EasyLine(hdc_mem_tco,x0+30,y0+60,x0+20,y0+50); EasyLine(hdc_mem_tco,x0+30,y0+60,x0+40,y0+50);
    sprintf(szTemp,"x0=%d y0=%d",tco_x0,tco_y0); TextOut(hdc_mem_tco,x0,y0+70,szTemp,strlen(szTemp));
    sprintf(szTemp,"xc=%d yc=%d",xc,yc); TextOut(hdc_mem_tco,x0,y0+85,szTemp,strlen(szTemp));
    sprintf(szTemp,"nb=%d",nb_0_99); TextOut(hdc_mem_tco,x0,y0+100,szTemp,strlen(szTemp));

    // 4. Dessin des regulateurs
    x0=100; dx=70; y0=y_panel+40;
    for(i=0;i<16;i++)
    {
        xr=x0+i*dx;

        //bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_CYAN);
        bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLEU);

        bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_NOIR);
        Rectangle(hdc_mem_tco,xr,y0,xr+60,y0+38);

        if(mouse_centrale[i])
        {
            bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS); Rectangle(hdc_mem_tco,xr,y0+40-3,xr+60,y0+120);
            bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_GRIS);
            sprintf(szTemp,"%02d",i); TextOut(hdc_mem_tco,x0+18+i*dx,y0+3,szTemp,strlen(szTemp));
            continue;
        }

        if(mouse_auto[i]==0)
        {
            bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_NOIR);
            if(i==regu_sel) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_JAUNE);
        }
        else bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
        Rectangle(hdc_mem_tco,xr,y0+40-3,xr+60,y0+120);

        adr=rs232_adr[i];
        vit=(rs232_cmd[i]<<1)&0x1F;
        if(rs232_cmd[i]&0x10) vit++;

        bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
        sprintf(szTemp,"%02d",adr); TextOut(hdc_mem_tco,x0+1+i*dx,y0+3,szTemp,strlen(szTemp));

        bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_GRIS);
        sprintf(szTemp,"%02d",i); TextOut(hdc_mem_tco,x0+18+i*dx,y0+3,szTemp,strlen(szTemp));

         if(rs232_cmd[i]&0x20) c='+'; else c='-';
        bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_VERT);
        sprintf(szTemp,"%c%02d",c,vit); TextOut(hdc_mem_tco,x0+34+i*dx,y0+3,szTemp,strlen(szTemp));

        bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_JAUNE);
        if(adr>=0 && adr<=99) { strcpy(szTemp,aszTrain[adr]); TextOut(hdc_mem_tco,x0+1+i*dx,y0+20,szTemp,strlen(szTemp)); }

        bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR); //grille
        bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_JAUNE); //fonf
        for(j=0;j<3;j++)
        {
            bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_VERT);
            Rectangle(hdc_mem_tco,xr+5 ,y0+40+20*j,xr+27,y0+40+17+20*j);
        }
            j=3; if(rs232_fct[i]&0x10) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_JAUNE); else bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
            Rectangle(hdc_mem_tco,xr+5 ,y0+40+20*j,xr+27,y0+40+17+20*j);
        for(j=0;j<4;j++)
        {
            if(rs232_fct[i]&(1<<j)) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_JAUNE); else bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_GRIS);
            Rectangle(hdc_mem_tco,xr+32,y0+40+20*j,xr+55,y0+40+17+20*j);
        }

        bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_NOIR);
        sprintf(szTemp,"+" ); TextOut(hdc_mem_tco,xr+10,y0+40+2,szTemp,strlen(szTemp));
        sprintf(szTemp,"-" ); TextOut(hdc_mem_tco,xr+10,y0+40+22,szTemp,strlen(szTemp));
        sprintf(szTemp,"<>"); TextOut(hdc_mem_tco,xr+7,y0+40+42,szTemp,strlen(szTemp));
        sprintf(szTemp,"F*"); TextOut(hdc_mem_tco,xr+7,y0+40+62,szTemp,strlen(szTemp));
        sprintf(szTemp,"F1"); TextOut(hdc_mem_tco,xr+35,y0+40+2,szTemp,strlen(szTemp));
        sprintf(szTemp,"F2"); TextOut(hdc_mem_tco,xr+35,y0+40+22,szTemp,strlen(szTemp));
        sprintf(szTemp,"F3"); TextOut(hdc_mem_tco,xr+35,y0+40+42,szTemp,strlen(szTemp));
        sprintf(szTemp,"F4"); TextOut(hdc_mem_tco,xr+35,y0+40+62,szTemp,strlen(szTemp));
    }
}


void tco_draw_panel(int y_panel)
{
    int i,j,x0,y0;
    char szTemp[100];

    // 1. Rectangle de fond du panneau
//    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_CYAN); //grille
//    bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_CYAN); //fonf
    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLEU); //grille
    bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_BLEU); //fonf
    //Rectangle(hdc_mem_tco,0,y_panel,800,y_panel+200);
    Rectangle(hdc_mem_tco,0,y_panel,2000,y_panel+200);
    //SetBkMode(hdc_mem_tco,TRANSPARENT);
    //SetTextColor(hdc_mem_tco,RGB(0,0,0));
    //SelectObject(hdc_mem_tco,bmp_fonte);
    //bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
    bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_BLANC);
    sprintf(szTemp,"panneau");   TextOut(hdc_mem_tco,0+3,y_panel+3,szTemp,strlen(szTemp));
    sprintf(szTemp,"d'dition"); TextOut(hdc_mem_tco,0+3,y_panel+15+3,szTemp,strlen(szTemp));

    // 2. Affichages des symboles
    sprintf(szTemp,"type:"); TextOut(hdc_mem_tco,100+3,y_panel+3,szTemp,strlen(szTemp));
    for(j=0;j<4;j++) for(i=0;i<10;i++) tco_draw_one(40*i+100,40*j+20+y_panel,disp_type[j][i],-1,tco_type_selected==disp_type[j][i]);

    // 3. Affichage des deplacements (tco_x0, tco_y0 et tco_edit_pos)
    //bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLANC);
    x0=10;
    y0=y_panel+40;
    EasyLine(hdc_mem_tco,x0+10,y0+0 ,x0+10,y0+20); EasyLine(hdc_mem_tco,x0+10,y0+0 ,x0+20,y0+10); EasyLine(hdc_mem_tco,x0+10,y0+0 ,x0+0 ,y0+10);
    EasyLine(hdc_mem_tco,x0+30,y0+0 ,x0+30,y0+20); EasyLine(hdc_mem_tco,x0+30,y0+20,x0+20,y0+10); EasyLine(hdc_mem_tco,x0+30,y0+20,x0+40,y0+10);
    EasyLine(hdc_mem_tco,x0+40,y0+0 ,x0+60,y0+20); EasyLine(hdc_mem_tco,x0+40,y0+20,x0+60,y0+ 0);

    x0=10;
    y0=y_panel+80;
    EasyLine(hdc_mem_tco,x0+30,y0   ,x0+30,y0+20); EasyLine(hdc_mem_tco,x0+30,y0   ,x0+20,y0+10); EasyLine(hdc_mem_tco,x0+30,y0   ,x0+40,y0+10);
    EasyLine(hdc_mem_tco,x0   ,y0+30,x0+20,y0+30); EasyLine(hdc_mem_tco,x0   ,y0+30,x0+10,y0+20); EasyLine(hdc_mem_tco,x0   ,y0+30,x0+10,y0+40);
    EasyLine(hdc_mem_tco,x0+60,y0+30,x0+40,y0+30); EasyLine(hdc_mem_tco,x0+60,y0+30,x0+50,y0+20); EasyLine(hdc_mem_tco,x0+60,y0+30,x0+50,y0+40);
    EasyLine(hdc_mem_tco,x0+30,y0+60,x0+30,y0+40); EasyLine(hdc_mem_tco,x0+30,y0+60,x0+20,y0+50); EasyLine(hdc_mem_tco,x0+30,y0+60,x0+40,y0+50);

    //bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
    bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_BLANC);
    sprintf(szTemp,"x0=%d y0=%d",tco_x0,tco_y0); TextOut(hdc_mem_tco,x0,y0+80,szTemp,strlen(szTemp));
    sprintf(szTemp,"xc=%d yc=%d",xc,yc); TextOut(hdc_mem_tco,x0,y0+100,szTemp,strlen(szTemp));

    // 4. Affichage de la zone de texte
    /*
    x0=380;
    y0=y_panel+40;
    sprintf(szTemp,"txt:"); TextOut(hdc_mem_tco,x0+3,y_panel+3,szTemp,strlen(szTemp));
    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_GRIS); //grille
    bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_BLANC); //fonf
    Rectangle(hdc_mem_tco,x0,y0,x0+460,y0+25);
    strcpy(szTemp,sz_tco_txt);
    TextOut(hdc_mem_tco,x0+13,y0+5,szTemp,strlen(szTemp));
    */

    // 5. Affichage des instructions
    x0=540;
    y0=y_panel+40;
    strcpy(szTemp,"Aide:");                                          TextOut(hdc_mem_tco,x0+3,y0+20,szTemp,strlen(szTemp));
    strcpy(szTemp,"bouton gauche souris: panneau de config -> tco"); TextOut(hdc_mem_tco,x0+3,y0+40,szTemp,strlen(szTemp));
    strcpy(szTemp,"bouton droit  souris: tco -> panneau de config"); TextOut(hdc_mem_tco,x0+3,y0+60,szTemp,strlen(szTemp));
    strcpy(szTemp,"zone de saisie en haut de l'ecran: caracteristiques de la cellule");  TextOut(hdc_mem_tco,x0+3,y0+100,szTemp,strlen(szTemp));
}

int g_y_panel=0;
int g_x_sel=0;
int g_y_sel=0;

void tco_key(int key)
{
    //if(key==VK_DELETE) sz_tco_txt[0]='\0';
    if(key==VK_HOME  ) tco_x0=tco_y0=0;
    if(key==VK_UP    ) { tco_y0--; if(tco_y0<0) tco_y0=0; }
    if(key==VK_DOWN  ) { tco_y0++; }
    if(key==VK_LEFT  ) { tco_x0--; if(tco_x0<0) tco_x0=0; }
    if(key==VK_RIGHT ) { tco_x0++; }
}

void tco_char(char c)
{
    if(c=='+' || c=='-' || c=='/' || c=='*' || c=='.' || c=='m' || c=='M' ) tco_char_reg(c);
}

void tco_key_up(void)
{
    tco_char_reg(-1);
}
/*void tco_char(int tc)
{
    char c;
    int l;

    c=(char)tc;
    l=strlen(sz_tco_txt);
    sz_tco_txt[l]=c;
    sz_tco_txt[l+1]='\0';
}*/

char bp_oldsz[1000]="";
// action: DEBUG_MOUSE / DEBUG_MOUSE_UP / DEBUG_MOUSE_RIGHT
// x_mouse / y_mouse
void tco_mouse(int action, int x, int y)
{
    int xp,yp,txt_ind,type;
    int regu,xr,yr;
    char sz[1000];

    g_x_sel=x; g_y_sel=y;

    // 1. Souris pour Panel
    if(tco_edit) if(y>g_y_panel && y<(g_y_panel+200))
    {
        xp=x; yp=y-g_y_panel;
        if(action==DEBUG_MOUSE)
        {
            if(xp>10 && xp<30 && yp>40 && yp<60) tco_edit_pos=1;
            if(xp>30 && xp<50 && yp>40 && yp<60) tco_edit_pos=0;
            if(xp>50 && xp<70 && yp>40 && yp<60) tco_edit=0;

            if(xp>30 && xp<50 && yp>80 && yp<100) { tco_y0--; if(tco_y0<0) tco_y0=0; }
            if(xp>30 && xp<50 && yp>120&& yp<140) { tco_y0++; }
            if(xp>10 && xp<30 && yp>100&& yp<120) { tco_x0--; if(tco_x0<0) tco_x0=0; }
            if(xp>50 && xp<70 && yp>100&& yp<120) { tco_x0++; }

            if(xp>100 && xp<(100+10*40) && yp>20 && yp<(20+4*40))
            {
                tco_type_selected=disp_type[(yp-20)/40][(xp-100)/40];
            }
        }
        return;
    }

    // 1. Souris pour regulateur
    if(tco_reg) if(y>g_y_panel && y<(g_y_panel+200))
    {
        xp=x; yp=y-g_y_panel;
        if(action==DEBUG_MOUSE)
        {
            if(xp>10 && xp<30 && yp>40 && yp<60) tco_edit_pos=1;
            if(xp>30 && xp<50 && yp>40 && yp<60) tco_edit_pos=0;
            if(xp>50 && xp<70 && yp>40 && yp<60) tco_edit=0;

            if(xp>30 && xp<50 && yp>80 && yp<100) { tco_y0--; if(tco_y0<0) tco_y0=0; }
            if(xp>30 && xp<50 && yp>120&& yp<140) { tco_y0++; }
            if(xp>10 && xp<30 && yp>100&& yp<120) { tco_x0--; if(tco_x0<0) tco_x0=0; }
            if(xp>50 && xp<70 && yp>100&& yp<120) { tco_x0++; }
        }

        regu=(x-100)/70;
        xr=(x-100)-70*regu;
        yr=y-(g_y_panel+40);
        regu_sel=-1;
        if(regu<0 || regu>15 || xr<0 || xr>60 || yr<0 || yr>120) return;
        regu_sel=regu;
        if(action==DEBUG_MOUSE) regu_action(regu,xr,yr);
        return;
    }

    // 2. Souris pour TCO en mode edition
    if(tco_edit)
    {
        if(screen_zoom==0) {xc=x/40+tco_x0; yc=y/40+tco_y0; }
        if(screen_zoom==1) {xc=x/20+tco_x0; yc=y/20+tco_y0; }

        if(xc>=TCO_NB_X) return;
        if(yc>=TCO_NB_Y) return;

        if(action==DEBUG_MOUSE)
        {
            tco[tco_current][xc][yc][TCO_IND_TYPE]=tco_type_selected;
            SendMessage(GetDlgItem(hwnd,800), WM_GETTEXT, 900, (LPARAM) sz_tco_txt);
            if(sz_tco_txt[0]=='\0') tco[tco_current][xc][yc][TCO_IND_SZ]=-1;
            else
            {
                tco[tco_current][xc][yc][TCO_IND_SZ]=tco_sz_free;
                strcpy(&tco_sz[tco_sz_free],sz_tco_txt);
                tco_sz_free+=strlen(sz_tco_txt)+1;
            }
        }

        if(action==DEBUG_MOUSE_RIGHT)
        {
            tco_type_selected=tco[tco_current][xc][yc][TCO_IND_TYPE];
            txt_ind=tco[tco_current][xc][yc][TCO_IND_SZ];
            if(txt_ind>=0) strcpy(sz_tco_txt,&tco_sz[txt_ind]); else strcpy(sz_tco_txt,"");
            SendMessage(GetDlgItem(hwnd,800), WM_SETTEXT, 0, (LPARAM) sz_tco_txt);
        }

        return;
    }

    // 3. Souris pour TCO en mode utilisation
    if(screen_zoom==0) {xc=x/40+tco_x0; yc=y/40+tco_y0; }
    if(screen_zoom==1) {xc=x/20+tco_x0; yc=y/20+tco_y0; }

    if(xc>=TCO_NB_X) return;
    if(yc>=TCO_NB_Y) return;

    type=tco_type_selected=tco[tco_current][xc][yc][TCO_IND_TYPE];
    txt_ind=tco[tco_current][xc][yc][TCO_IND_SZ];
    if(txt_ind<0) strcpy(sz,""); else strcpy(sz,&tco_sz[txt_ind]);

    //sprintf(gszErr,"tco_current=%d xc=%d yc=%d type=%d sz=%s",tco_current,xc,yc,type,sz);
    //MessageBox(NULL,gszErr,"debug",MB_OK);

    if(action==DEBUG_MOUSE)
    {
         if(   type==TCO_TYPE_ANE  || type==TCO_TYPE_ANO  || type==TCO_TYPE_ASE  || type==TCO_TYPE_ASO
            || type==TCO_TYPE_VANE || type==TCO_TYPE_VANO || type==TCO_TYPE_VASE || type==TCO_TYPE_VASO
            || type==TCO_TYPE_INT )
         {
             change_var_sz(sz);
         }

         if(type==TCO_TYPE_BP)
         {
             set_var_sz(sz);
             strcpy(bp_oldsz,sz);
         }

         if(type==TCO_TYPE_GO)
         {
             go_tco_sz(sz);
         }

         if(type==TCO_TYPE_SND || type==TCO_TYPE_EXE)
         {
             exe_sz(sz);
         }

         if(type==TCO_TYPE_DPL)
         {
             start_depl_sz(sz);
         }

         if(type==TCO_TYPE_ITI)
         {
             iti_set_sz(sz);
         }
    }

    if(action==DEBUG_MOUSE_UP)
    {
         //if(type==TCO_TYPE_BP)
         if(bp_oldsz[0]!='\0')
         {
             clr_var_sz(bp_oldsz); bp_oldsz[0]='\0';
         }
    }

    if(action==DEBUG_MOUSE_RIGHT)
    {
         if(type==TCO_TYPE_ITI)
         {
             iti_clr_sz(sz);
         }

         if(   type==TCO_TYPE_ANE  || type==TCO_TYPE_ANO  || type==TCO_TYPE_ASE  || type==TCO_TYPE_ASO
            || type==TCO_TYPE_VANE || type==TCO_TYPE_VANO || type==TCO_TYPE_VASE || type==TCO_TYPE_VASO )
         {
             tco_res_unres(tco_current, xc, yc, sz);
         }

         if(type==TCO_TYPE_BAL || type==TCO_TYPE_BALV)
         {
             set_clr_bal_res(sz);
         }
    }
}


void tco_draw(void)
{
    int x,y,xnb,ynb,y_panel;
    RECT rect;
    char szTemp[1000];

    tco_cpt++;
    //cells_tick++;  //pour les clignotements

    // 1. La preliere fois, creation du DC memoire afin de dessiner en memoire
    //    et copier/coller a la fin afin d'eviter les clignotements
    if(hdc_mem_tco_initialized==0)
    {
        HBITMAP hbm;

        hdc_mem_tco=CreateCompatibleDC(hdc);
        hdc_mem_tco_initialized=1;
        hbm=CreateCompatibleBitmap(hdc,2000,1500);  //oblige d'associe un hbitmap
        SelectObject(hdc_mem_tco,hbm);                       //sinon hdc mem ne fonctionne pas
        DeleteObject(hbm);                                   //
        //hbitmap=(HBITMAP)LoadImage(ghInstance,"E:\\projet\\dev_c++\\projet\\virtrain2\\gare_3.bmp",IMAGE_BITMAP,xhdc2=146,yhdc2=141,LR_LOADFROMFILE);
        //DeleteDC(hdc_mem_tco);
    }

    // 2. Divers initialisations pour dessiner et recuperation de la taille de la fenetre
    SetBkMode(hdc_mem_tco,TRANSPARENT);
    SetTextColor(hdc_mem_tco,RGB(0,0,0));
    SelectObject(hdc_mem_tco,bmp_fonte);
    SelectObject(hdc_mem_tco,bmp_pinceau_gris);
    SelectObject(hdc_mem_tco,bmp_stylo_gris);
    Rectangle(hdc_mem_tco,0,0,2000,1500);
    //SelectObject(hdc_mem_tco,bmp_stylo_rouge);
    //MoveToEx(hdc_mem_tco,0,0,NULL); LineTo(hdc_mem_tco,1280,1024);

    GetClientRect(hwnd,&rect);
    xnb=0;
    if(screen_zoom==0) xnb=(rect.right )/40;
    if(screen_zoom==1) xnb=(rect.right )/20;
    if(xnb>(TCO_NB_X-1)) xnb=TCO_NB_X-1;
    if(xnb<0) xnb=0;

    ynb=0;
    if(screen_zoom==0) ynb=(rect.bottom)/40;
    if(screen_zoom==1) ynb=(rect.bottom)/20;
    if(ynb>(TCO_NB_Y-1)) ynb=TCO_NB_Y-1;
    if(ynb<0) ynb=0;

    // 3. Addichage des cellules
    if(screen_zoom==0) for(y=0;y<=ynb;y++) for(x=0;x<=xnb;x++) //UU: ajouter origine <= pour <x+1
    {
        if((x+tco_x0)>=TCO_NB_X || (y+tco_y0)>=TCO_NB_Y)
            tco_draw_one(40*x,40*y,-1,-1,0);
        else
            tco_draw_one(40*x,40*y,tco[tco_current][x+tco_x0][y+tco_y0][TCO_IND_TYPE],tco[tco_current][x+tco_x0][y+tco_y0][TCO_IND_SZ],0);
    }
    if(screen_zoom==1) for(y=0;y<=ynb;y++) for(x=0;x<=xnb;x++) //UU: ajouter origine <= pour <x+1
    {
        if((x+tco_x0)>=TCO_NB_X || (y+tco_y0)>=TCO_NB_Y)
            tco_draw_one_zoom(20*x,20*y,-1,-1,0);
        else
            tco_draw_one_zoom(20*x,20*y,tco[tco_current][x+tco_x0][y+tco_y0][TCO_IND_TYPE],tco[tco_current][x+tco_x0][y+tco_y0][TCO_IND_SZ],0);
    }

    // 3.1
      SetTextColor(hdc_mem_tco,RGB(0,0,0));
    if(tco_edit==0) if(tco_disp_horo)
    {
        sprintf(szTemp,"%02d:%02d",horo_h,horo_m); TextOut(hdc_mem_tco,0,0,szTemp,strlen(szTemp));
    }

    // 3.2 infos de debug (a commenter avant de livrer
    tc=(int)GetTickCount();
    if(rs_tic_cpt==0) { tcstartcstart=tcstart=tc; rs_tic_cpt_start=0; }
    if((tc-tcstart)>10000) { tcstart=tc; tp10s=rs_tic_cpt-rs_tic_cpt_start; rs_tic_cpt_start=rs_tic_cpt; }
    if(rs_debug)
    {
        sprintf(szTemp,"tic=%d sec=%d tic/10s=%d delta_rx_ms=%d",rs_tic_cpt,(tc-tcstartcstart)/1000,tp10s,timettrx);
        TextOut(hdc_mem_tco,0,20,szTemp,strlen(szTemp));
    }
    rs_tic_cpt++;

    // 4. Affichage du panneau d'edition
    if(tco_edit)
    {
        y_panel=(rect.bottom)-200; if(y_panel<0) y_panel=0; //panneau en bas
        if(tco_edit_pos==1) y_panel=0;                      //panneau en haut
        g_y_panel=y_panel;
        tco_draw_panel(y_panel);
    }
    if(tco_edit==0 && tco_reg)
    {
        y_panel=(rect.bottom)-200; if(y_panel<0) y_panel=0; //panneau en bas
        if(tco_edit_pos==1) y_panel=0;                      //panneau en haut
        g_y_panel=y_panel;
        tco_draw_reg_panel(y_panel);
    }

    //Debug: position de la souris
    //SelectObject(hdc_mem_tco,bmp_stylo_vert);
    //EasyLine(hdc_mem_tco,g_x_sel,g_y_sel,g_x_sel+20,g_y_sel+20);

    // 5. Copie du contexte memoire vers l'ecran
    if(tco_edit==0) BitBlt(hdc,0,0,rect.right,rect.bottom,hdc_mem_tco,0,0,SRCCOPY);   //y compris tco_reg
    else            BitBlt(hdc,0,20,rect.right,rect.bottom,hdc_mem_tco,0,20,SRCCOPY);
}



/*****************************************************************************/
/* FIN TCO                                                                   */
/*****************************************************************************/





/*****************************************************************************/
/* SIMU                                                                      */
/*****************************************************************************/


struct
{
    int on;
    int x;
    int y;
    int vit;
    int sens;
    int cmd_sens;
    int cpt; //droite ou bas
    int tco;
    int remplace;
} simu[100];

/*
void simu_init(void)
{
    static int initialized=0;
    int i;

    if(initialized) return;
    initialized=1;

    for(i=0;i<128;i++) var_in2[i]=0;

    for(i=0;i<100;i++) { simu[i].on=0; simu[i].cmd_sens=1; }

    //simu[ 8].tco=0; simu[ 8].x=60;  simu[ 8].y=20; simu[ 8].vit=0; simu[ 8].sens=2; simu[ 8].cpt=20; simu[8 ].on=1;  //sens 0=N 1=NE 2=E ...
    //simu[ 9].tco=2; simu[ 9].x=100; simu[ 9].y=20; simu[ 9].vit=0; simu[ 9].sens=2; simu[ 9].cpt=20; simu[9 ].on=1;
    //simu[10].tco=0; simu[10].x=140; simu[10].y=20; simu[10].vit=0; simu[10].sens=2; simu[10].cpt=20; simu[10].on=1;
}
*/

void simu_char(char c)
{
/*
    if(c=='r') { simu[8].vit=0; simu[9].vit=0; simu[10].vit=0; }

    if(c=='a') simu[8].vit++;
    if(c=='q') simu[8].vit--;
    if(c=='w') simu[8].sens=(simu[8].sens+4)%8;

    if(c=='z') simu[9].vit++;
    if(c=='s') simu[9].vit--;
    if(c=='x') simu[9].sens=(simu[9].sens+4)%8;

    if(c=='e') simu[10].vit++;
    if(c=='d') simu[10].vit--;
    if(c=='c') simu[10].sens=(simu[10].sens+4)%8;
*/
}

void simu_load(char* szFile)
{
    FILE* pf;
    int i,j,adr,tco,x0,y0,sens,pos;

    for(j=0;j<4;j++) for(i=0;i<128;i++) var_in2[j][i]=0;
    for(i=0;i<100;i++) { simu[i].on=0; simu[i].cmd_sens=1; simu[i].remplace=-1; }

    pf=fopen(szFile,"rt");
    if(pf==NULL) return;

    while(fscanf(pf," %d %d %d %d %d",&adr,&tco,&x0,&y0,&sens)==5)
    {
        simu[adr].tco=tco;
        simu[adr].x=x0;
        simu[adr].y=y0;
        simu[adr].vit=0;
        simu[adr].sens=2;
        simu[adr].cpt=x0%40;
        simu[adr].on=1;
        simu[adr].cmd_sens=sens;
    }

    fclose(pf);
}

void simu_move(int loco)
{
    int xc,yc,tc,in,simu_cpt,simu_sens,simu_x,simu_y,simu_tco,simu_remplace,pos;

    simu_cpt=simu[loco].cpt;
    simu_sens=simu[loco].sens;
    simu_x=simu[loco].x;
    simu_y=simu[loco].y;
    simu_tco=simu[loco].tco;
    simu_remplace=simu[loco].remplace;

    xc=simu[loco].x/40;
    yc=simu[loco].y/40;
    tc=tco[simu_tco][xc][yc][0];  //choix du tco
    if(simu_remplace!=-1) tc=simu_remplace;

    /* 1 move */
    in=-1;
    switch(tc)
    {
        case TCO_TYPE_H:     case TCO_TYPE_HV:     case TCO_TYPE_HD:     case TCO_TYPE_BAL:   case TCO_TYPE_HP:
        case TCO_TYPE_ANE:   case TCO_TYPE_ANO:    case TCO_TYPE_ASE:    case TCO_TYPE_ASO:
        case TCO_TYPE_HFD:   case TCO_TYPE_HFG:
            if(simu_sens==2) { simu_cpt++; if(simu_cpt==40) { xc++; in=6; } }
            if(simu_sens==6) { simu_cpt--; if(simu_cpt==-1) { xc--; in=2; } }
            break;

        case TCO_TYPE_V:     case TCO_TYPE_VV:     case TCO_TYPE_VD:     case TCO_TYPE_BALV:
        case TCO_TYPE_VANE:  case TCO_TYPE_VANO:   case TCO_TYPE_VASE:   case TCO_TYPE_VASO:   case TCO_TYPE_VP:
            if(simu_sens==4) { simu_cpt++; if(simu_cpt==40) { yc++; in=0; } }
            if(simu_sens==0) { simu_cpt--; if(simu_cpt==-1) { yc--; in=4; } }
            break;

        case TCO_TYPE_NO:
            if(simu_sens==2) { simu_cpt++; if(simu_cpt==20) { yc--; in=4; } }
            if(simu_sens==6) { simu_cpt--; if(simu_cpt==-1) { xc--; in=2; } }
            break;

        case TCO_TYPE_SO:
            if(simu_sens==2) { simu_cpt++; if(simu_cpt==20) { yc++; in=0; } }
            if(simu_sens==6) { simu_cpt--; if(simu_cpt==-1) { xc--; in=2; } }
            break;

        case TCO_TYPE_NE:
            if(simu_sens==2) { simu_cpt++; if(simu_cpt==40) { xc++; in=6; } }
            if(simu_sens==6) { simu_cpt--; if(simu_cpt==20) { yc--; in=4; } }
            break;

        case TCO_TYPE_SE:
            if(simu_sens==2) { simu_cpt++; if(simu_cpt==40) { xc++; in=6; } }
            if(simu_sens==6) { simu_cpt--; if(simu_cpt==20) { yc++; in=0; } }
            break;

        default:
            break;
    }

    /* 2 compute x,y */
    if(in!=-1) { tc=tco[simu_tco][xc][yc][0]; simu_remplace=-1; }
    pos=get_var_sz_state(&tco_sz[tco[simu_tco][xc][yc][1]]);

    //  701
    //  6 2
    //  543
    switch(tc)
    {                      
        case TCO_TYPE_H:    case TCO_TYPE_HV:   case TCO_TYPE_HD:   case TCO_TYPE_BAL:
        case TCO_TYPE_HFD:  case TCO_TYPE_HFG:
        g_th:
            if(in==6) { simu_cpt=0 ; simu_sens=2; }
            if(in==2) { simu_cpt=39; simu_sens=6; }
            simu_x=40*xc+simu_cpt;
            simu_y=40*yc+20;
            break;

        case TCO_TYPE_V:    case TCO_TYPE_VV:   case TCO_TYPE_VD:   case TCO_TYPE_BALV:
            g_tv:
            if(in==4) { simu_cpt=39; simu_sens=0; }
            if(in==0) { simu_cpt=0 ; simu_sens=4; }
            simu_x=40*xc+20;
            simu_y=40*yc+simu_cpt;
            break;

        case TCO_TYPE_HP:
        case TCO_TYPE_VP:
            if(in==2 || in==6) { simu_remplace=TCO_TYPE_H ; goto g_th; }
            if(in==0 || in==4) { simu_remplace=TCO_TYPE_V ; goto g_tv; }
            break;

        case TCO_TYPE_NO:
            g_no:
            if(in==0) { simu_cpt=20; simu_sens=6; }
            if(in==6) { simu_cpt=0 ; simu_sens=2; }
            simu_x=40*xc+simu_cpt;
            simu_y=40*yc+20-simu_cpt;
            break;

        case TCO_TYPE_SO:
            g_so:
            if(in==4) { simu_cpt=20; simu_sens=6; }
            if(in==6) { simu_cpt=0 ; simu_sens=2; }
            simu_x=40*xc+simu_cpt;
            simu_y=40*yc+19+simu_cpt;
            break;

        case TCO_TYPE_NE:
            g_ne:
            if(in==0) { simu_cpt=20; simu_sens=2; }
            if(in==2) { simu_cpt=39; simu_sens=6; }
            simu_x=40*xc+simu_cpt;
            simu_y=40*yc+simu_cpt-20;
            break;

        case TCO_TYPE_SE:
            g_se:
            if(in==4) { simu_cpt=20; simu_sens=2; }
            if(in==2) { simu_cpt=39; simu_sens=6; }
            simu_x=40*xc+simu_cpt;
            simu_y=40*yc+39-(simu_cpt-20);
            break;

        case TCO_TYPE_ANO:
            if(in==2) { simu_remplace=TCO_TYPE_H ; goto g_th; }
            if(in==0) { simu_remplace=TCO_TYPE_NO; goto g_no; }
            if(in==6) { if(pos==0 || pos==-1) { simu_remplace=tc=TCO_TYPE_H ; goto g_th; } if(pos==1) { simu_remplace=tc=TCO_TYPE_NO; goto g_no; } }
            break;

        case TCO_TYPE_ASO:
            if(in==2) { simu_remplace=TCO_TYPE_H ; goto g_th; }
            if(in==4) { simu_remplace=TCO_TYPE_SO; goto g_so; }
            if(in==6) { if(pos==0 || pos==-1) { simu_remplace=tc=TCO_TYPE_H ; goto g_th; } if(pos==1) { simu_remplace=tc=TCO_TYPE_SO; goto g_so; } }
            break;

        case TCO_TYPE_ANE:
            if(in==6) { simu_remplace=TCO_TYPE_H ; goto g_th; }
            if(in==0) { simu_remplace=TCO_TYPE_NE; goto g_ne; }
            if(in==2) { if(pos==0 || pos==-1) { simu_remplace=tc=TCO_TYPE_H ; goto g_th; } if(pos==1) { simu_remplace=tc=TCO_TYPE_NE; goto g_ne; } }
            break;

        case TCO_TYPE_ASE:
            if(in==6) { simu_remplace=TCO_TYPE_H ; goto g_th; }
            if(in==4) { simu_remplace=TCO_TYPE_SE; goto g_se; }
            if(in==2) { if(pos==0 || pos==-1) { simu_remplace=tc=TCO_TYPE_H ; goto g_th; } if(pos==1) { simu_remplace=tc=TCO_TYPE_SE; goto g_se; } }
            break;

        case TCO_TYPE_VANO:
            if(in==4) { simu_remplace=TCO_TYPE_V ; goto g_tv; }
            if(in==6) { simu_remplace=TCO_TYPE_NO; goto g_no; }
            if(in==0) { if(pos==0 || pos==-1) { simu_remplace=tc=TCO_TYPE_V ; goto g_tv; } if(pos==1) { simu_remplace=tc=TCO_TYPE_NO; goto g_no; } }
            break;

        case TCO_TYPE_VASO:
            if(in==0) { simu_remplace=TCO_TYPE_V ; goto g_tv; }
            if(in==6) { simu_remplace=TCO_TYPE_SO; goto g_so; }
            if(in==4) { if(pos==0 || pos==-1) { simu_remplace=tc=TCO_TYPE_V ; goto g_tv; } if(pos==1) { simu_remplace=tc=TCO_TYPE_SO; goto g_so; } }
            break;

        case TCO_TYPE_VANE:
            if(in==4) { simu_remplace=TCO_TYPE_V ; goto g_tv; }
            if(in==2) { simu_remplace=TCO_TYPE_NE; goto g_ne; }
            if(in==0) { if(pos==0 || pos==-1) { simu_remplace=tc=TCO_TYPE_V ; goto g_tv; } if(pos==1) { simu_remplace=tc=TCO_TYPE_NE; goto g_ne; } }
            break;

        case TCO_TYPE_VASE:
            if(in==0) { simu_remplace=TCO_TYPE_V ; goto g_tv; }
            if(in==2) { simu_remplace=TCO_TYPE_SE; goto g_se; }
            if(in==4) { if(pos==0 || pos==-1) { simu_remplace=tc=TCO_TYPE_V ; goto g_tv; } if(pos==1) { simu_remplace=tc=TCO_TYPE_SE; goto g_se; } }
            break;

        default:
            break;
    }

    /* 3. mise a jour seulement si cellule de rail */
    switch(tc)
    {
        case TCO_TYPE_H:    case TCO_TYPE_HV:   case TCO_TYPE_HD:   case TCO_TYPE_BAL:  case TCO_TYPE_HP:   case TCO_TYPE_HFD:  case TCO_TYPE_HFG:
        case TCO_TYPE_ANE:  case TCO_TYPE_ANO:  case TCO_TYPE_ASE:  case TCO_TYPE_ASO:  case TCO_TYPE_VP:
        case TCO_TYPE_V:    case TCO_TYPE_VV:   case TCO_TYPE_VD:   case TCO_TYPE_BALV:
        case TCO_TYPE_VANE: case TCO_TYPE_VANO: case TCO_TYPE_VASE: case TCO_TYPE_VASO:
        case TCO_TYPE_NO:   case TCO_TYPE_SO:   case TCO_TYPE_NE:   case TCO_TYPE_SE:
            simu[loco].cpt=simu_cpt;
            simu[loco].sens=simu_sens;
            simu[loco].x=simu_x;
            simu[loco].y=simu_y;
            simu[loco].remplace=simu_remplace;
            break;
        default:
            break;
    }

}


int cmd2sens(int cmd)
{
    if(cmd&0x20) return 1;
    return 0;
}

void simu_tic(void)
{
    int i,j,nb,xc,yc,num;
    char* pc;

    //simu_init();
    for(j=0;j<4;j++) for(i=0;i<128;i++) var_in2[j][i]=0;

    for(i=1;i<=99;i++) if(simu[i].on)
    {
        nb=simu[i].vit; if(nb<0) nb=-nb;
        for(j=0;j<nb;j++) simu_move(i);

        for(j=0;j<16;j++) if(rs232_adr[j]==i)
        {
            simu[i].vit=cmd2vit(rs232_cmd[j]);
            if( cmd2sens(rs232_cmd[j]) != simu[i].cmd_sens ) { simu[i].cmd_sens^=1; simu[i].sens=(simu[i].sens+4)%8; }
        }

        xc=simu[i].x/40; yc=simu[i].y/40;
        pc=strstr(&tco_sz[ tco[simu[i].tco][xc][yc][1]],"v:i"); if(pc) { num=atoi(pc+3); if((num/1000)<4) if((num%100)<128) var_in2[num/1000][num%1000]=1; }
        pc=strstr(&tco_sz[ tco[simu[i].tco][xc][yc][1]],"r:i"); if(pc) { num=atoi(pc+3); if((num/1000)<4) if((num%100)<128) var_in2[num/1000][num%1000]=1; }
    }
}

void simu_draw(void)
{
    int i;
    char sz[100];

    bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_NOIR);
    bmp_SetTextColor(hdc_mem_tco,BMP_CST_COLOR_BLANC);

    for(i=0;i<100;i++) if(simu[i].on) if(simu[i].tco==tco_current)
    {
        if((i%5)==0) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_BLEU);
        if((i%5)==1) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE);
        if((i%5)==2) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_VERT);
        if((i%5)==3) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_NOIR);
        if((i%5)==4) bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_VIOLET);
        Ellipse(hdc_mem_tco,simu[i].x-40*tco_x0-15,simu[i].y-40*tco_y0-15,simu[i].x-40*tco_x0+15,simu[i].y-40*tco_y0+15);
        sprintf(sz,"%02d",i); TextOut(hdc_mem_tco,simu[i].x-40*tco_x0-10,simu[i].y-40*tco_y0-8,sz,strlen(sz));
    }
}


/*****************************************************************************/
/* FIN-SIMU                                                                  */
/*****************************************************************************/






/*****************************************************************************/
/* DEPLACEMENTS AUTOMATIQUES                                                 */
/*****************************************************************************/


/*
File: "fdcc_conf_seq.txt"

Syntax:
#commentaire
start

depl <numero(0-999)>
loco <adr(0-99)>                        #si loco libre (sinon bloque)
//aig /-.!.... ........ ........ ........ # -=droit /=devie .=non utilise !=reserver mais ne pas bouger (pour l'instant)
aig <num> <-//>
vit <+/-> <vit(0-31)>
fct <num(0-4)> <val(0/1)>
tempos <time_1s(0-1000)>
tempot <time_tic_0.25s(0-1000)>
wait_in <num>
sound "<chemin d'acces>"

seq
run_wait_depl 0
sound "<chemin d'acces>"
tempos <time_1s(0-1000)>

stop
end
*/

#define AUTO_LIST_NB 100000
int auto_list[AUTO_LIST_NB];  /* ORDRE puis parametre(s) */
int auto_list_next;
#define AUTO_ORDRE_FREE      0
#define AUTO_ORDRE_PROG      1
#define AUTO_ORDRE_RUNWAIT   2
#define AUTO_ORDRE_RUN       3
#define AUTO_ORDRE_ENDRUN    4

#define AUTO_ORDRE_LOCO      5
#define AUTO_ORDRE_VIT       6
#define AUTO_ORDRE_FCT       7

#define AUTO_ORDRE_AIG       8
#define AUTO_ORDRE_AIGRES    9
#define AUTO_ORDRE_AIGWAIT   10
#define AUTO_ORDRE_OUT       11
#define AUTO_ORDRE_LED       12
#define AUTO_ORDRE_CLI       13
#define AUTO_ORDRE_WAITIN    14
#define AUTO_ORDRE_WAITNOTIN 15

#define AUTO_ORDRE_TEMPOS    16
#define AUTO_ORDRE_TEMPOT    17
#define AUTO_ORDRE_WAITHM    18
#define AUTO_ORDRE_SETHM     19

#define AUTO_ORDRE_SOUND     20
#define AUTO_ORDRE_ECHO      21

#define AUTO_ORDRE_BAL_INIT  22
#define AUTO_ORDRE_BAL       23
#define AUTO_ORDRE_BAL_MAX   24
#define AUTO_ORDRE_BAL_RAL   25

//UU:rajouter itineraires, label goto et variables

#define AUTO_PROG_NB 1000
int auto_prog_index[AUTO_PROG_NB];
#define AUTO_PROG_FREE -1

#define EXE_NB 20
int exe[EXE_NB][12];
#define EXE_PROG     0    // (-1=inactif)
#define EXE_PTR      1
#define EXE_LOCO     2
#define EXE_WAIT     3
#define EXE_IN       4
#define EXE_NOTIN    5
#define EXE_BAL_MAX  6
#define EXE_BAL_RAL  7
#define EXE_BAL_STEP 8
#define EXE_CH       9
#define EXE_END_RUN 10
#define EXE_IN_FCT  11


int auto_cpt,auto_step;

// reserve et positionne les aigs pour un deplacement de canton execute par le canal d'execution e
int bal_iti_res_pos(int aig_ctrl, int num_iti)
{
    if(num_iti==-1) return 1;

    //itineraire controle en automatique, le tracer
    if(aig_ctrl==1) iti_tab[num_iti][ITI_TAB_IND_CMD_ON]=1;

    //verifier itinraire etablit
    if(iti_tab[num_iti][ITI_TAB_IND_OK]) return 1; else return 0;
}

void bal_iti_unres(int aig_ctrl,int num_iti)
{
    if(num_iti==-1) return;

    //si itineraire TP controle en automatique, le detruire
    if(aig_ctrl==1) if(iti_tab[num_iti][ITI_TAB_IND_LIB]==-1) iti_tab[num_iti][ITI_TAB_IND_CMD_OFF]=1;
}

int auto_file(char* szFilename)
{

    int i,j,data,data2,tempo,h,m,p;
    FILE* pf;
    int wait=0;
    char sz_ch[200];
    char sz_ordre[200];
    int vit,fct;
    int loco=0;
    int var,val,cmd,in,aig,delay,start_ok=0;
    char c;
    int prog_no, prog_torun;
    int section_on;
    int cant,in_fin,cant_ral,nb1,nb2;
    char sz_aig_cant[200];
    char sz_aig_cant_ral[200];
    char str[200];
    int is_old_nb;

    // 1. initialisation des structures
    for(i=0;i<AUTO_LIST_NB;i++) auto_list[i]=AUTO_ORDRE_FREE;
    auto_list_next=0;
    for(i=0;i<AUTO_PROG_NB;i++) auto_prog_index[i]=-1;
    for(i=0;i<EXE_NB;i++) for(j=0;j<12;j++) exe[i][j]=-1;
    for(i=0;i<EXE_NB;i++) exe[i][EXE_BAL_STEP]=0;
    for(i=0;i<EXE_NB;i++) exe[i][EXE_IN_FCT]=0;

    // 2. remplissage en provenance du fichier
    pf=fopen(szFilename,"rt");
    if(pf==NULL) { fprintf(p_err,"\nCannot open fdcc_conf_seq.txt\nBye\n\n"); return -1; }


    fprintf(p_err,"\n- filling stuctures");
    section_on=1;
    prog_no=-1; //mode seq
    while(1)
    {
        if(fscanf(pf," %s",sz_ordre)==EOF) break;
        //printf("\nordre=%s",sz_ordre);

        if((sz_ordre[0]=='#') || (sz_ordre[0]=='/'))
        {
        while(1)
        {
           if(fscanf(pf,"%c",&c)==EOF) break;
           if(c=='\n') break;
           if(c=='\r') break;
        }
        continue;
        }

        if(stricmp(sz_ordre,"section_on")==0) section_on=1;
        if(stricmp(sz_ordre,"section_off")==0) section_on=0;

        if(section_on==0) continue;

        fprintf(p_err,"\nordre=%s",sz_ordre);
        //if(stricmp(sz_ordre,"end")==0) break;
        //if(stricmp(sz_ordre,"stop")==0) break;

        /*---- prog ----*/

        if(stricmp(sz_ordre,"prog")==0)  // prog 0
        {
            if(fscanf(pf," %d",&prog_no)==EOF) break;
            //printf(" depl_no=%d\n",depl_no);
            auto_prog_index[prog_no]=auto_list_next;
            auto_list[auto_list_next++]=AUTO_ORDRE_PROG;
            auto_list[auto_list_next++]=prog_no;
        }

        if(stricmp(sz_ordre,"run_wait_prog")==0)  // run_wait_prog 1
        {
            if(fscanf(pf," %d",&prog_torun)==EOF) break;
            auto_list[auto_list_next++]=AUTO_ORDRE_RUNWAIT;
            auto_list[auto_list_next++]=prog_torun;
        }

        if(stricmp(sz_ordre,"run_prog")==0)  // run_prog 2
        {
            if(fscanf(pf," %d",&prog_torun)==EOF) break;
            auto_list[auto_list_next++]=AUTO_ORDRE_RUN;
            auto_list[auto_list_next++]=prog_torun;
        }

        if(stricmp(sz_ordre,"wait_end_prog")==0)  // wait_end_prog 2
        {
            if(fscanf(pf," %d",&prog_torun)==EOF) break;
            auto_list[auto_list_next++]=AUTO_ORDRE_ENDRUN;
            auto_list[auto_list_next++]=prog_torun;
        }

        /*---- loco ----*/

        if(stricmp(sz_ordre,"loco")==0)  // loco 0
        {
            if(fscanf(pf," %d",&loco)==EOF) break;
            //printf(" loco=%d\n",loco);
            auto_list[auto_list_next++]=AUTO_ORDRE_LOCO;
            auto_list[auto_list_next++]=loco;
        }

        if(stricmp(sz_ordre,"vit")==0)  // vit + 20
        {
            if(fscanf(pf," %c",&c)==EOF) break;
            if(fscanf(pf," %d",&vit)==EOF) break;
            //printf(" vit= %c %d\n",c,vit);
            auto_list[auto_list_next++]=AUTO_ORDRE_VIT;
            auto_list[auto_list_next++]=c;
            auto_list[auto_list_next++]=vit;
        }

        if(stricmp(sz_ordre,"fct")==0)  // fct 0 1
        {
            if(fscanf(pf," %d",&fct)==EOF) break;
            if(fscanf(pf," %d",&val)==EOF) break;
            //printf(" fct(%d)=%d\n",fct,val);
            auto_list[auto_list_next++]=AUTO_ORDRE_FCT;
            auto_list[auto_list_next++]=fct;
            auto_list[auto_list_next++]=val;
        }

        /*---- aig/iti ----*/

        p=0;
        if(stricmp(sz_ordre,"aig"      ) == 0 ) { p=1; auto_list[auto_list_next++] = AUTO_ORDRE_AIG;     } // aig      "--4/..."    attend aig non reserves,                   ordre position, attend position ok
        if(stricmp(sz_ordre,"aig_res"  ) == 0 ) { p=1; auto_list[auto_list_next++] = AUTO_ORDRE_AIGRES;  } // aig_res  "--4/.RL..*" attend aig non reserves par ext, lib, res, ordre position, attend position ok
        if(stricmp(sz_ordre,"aig_wait" ) == 0 ) { p=1; auto_list[auto_list_next++] = AUTO_ORDRE_AIGWAIT; } // aig_wait "--4/..."    attend aig                                                        position ok
        if(p)
        {
            aig=0; is_old_nb=0;
            if(fscanf(pf," %c",&c)==EOF) break; //remove "
            while(fscanf(pf," %c",&c)!=EOF)
            {
                if(c=='\"') break;
                if(c>='0' && c<='9') { if(is_old_nb==0) aig=0; aig=10*aig+c-'0'; is_old_nb=1; } else is_old_nb=0;
                if(c=='.') aig++;
                if(c=='r') c='R'; if(c=='l') c='L';
                if(c=='-' || c=='/' || (c=='R') || c=='L') { auto_list[auto_list_next++]=aig; auto_list[auto_list_next++]=c; aig++; }
                if(c=='*') auto_list[auto_list_next++]=-2;
            }
            auto_list[auto_list_next++]=-1;
        }

       /*---- entees/sorties ----*/

        if(stricmp(sz_ordre,"wait_in")==0)  // wait_in 8
        {
            if(fscanf(pf," %d",&in)==EOF) break;
            //printf(" wait_in=%d\n",in);
            auto_list[auto_list_next++]=AUTO_ORDRE_WAITIN;
            auto_list[auto_list_next++]=in;
        }

        if(stricmp(sz_ordre,"wait_not_in")==0)  // wait_in 8
        {
            if(fscanf(pf," %d",&in)==EOF) break;
            //printf(" wait_not_in=%d\n",in);
            auto_list[auto_list_next++]=AUTO_ORDRE_WAITNOTIN;
            auto_list[auto_list_next++]=in;
        }

        if(stricmp(sz_ordre,"out")==0)  // out <var> <val>
        {
            if(fscanf(pf," %d",&var)==EOF) break;
            if(fscanf(pf," %d",&val)==EOF) break;
            //printf(" out %d = %d\n",var,val);
            auto_list[auto_list_next++]=AUTO_ORDRE_OUT;
            auto_list[auto_list_next++]=var;
            auto_list[auto_list_next++]=val;
        }

        if(stricmp(sz_ordre,"led")==0)  // led <var> <val>
        {
            if(fscanf(pf," %d",&var)==EOF) break;
            if(fscanf(pf," %d",&val)==EOF) break;
            //printf(" out %d = %d\n",var,val);
            auto_list[auto_list_next++]=AUTO_ORDRE_LED;
            auto_list[auto_list_next++]=var;
            auto_list[auto_list_next++]=val;
        }

        if(stricmp(sz_ordre,"cli")==0)  // led <var> <val>
        {
            if(fscanf(pf," %d",&var)==EOF) break;
            if(fscanf(pf," %d",&val)==EOF) break;
            //printf(" out %d = %d\n",var,val);
            auto_list[auto_list_next++]=AUTO_ORDRE_CLI;
            auto_list[auto_list_next++]=var;
            auto_list[auto_list_next++]=val;
        }

        /*---- temps ----*/

        if(stricmp(sz_ordre,"tempot")==0)  // tempot 40  (10s)
        {
            if(fscanf(pf," %d",&delay)==EOF) break;
            //printf(" tempot=%d\n",delay);
            auto_list[auto_list_next++]=AUTO_ORDRE_TEMPOT;
            auto_list[auto_list_next++]=delay;
        }

        if(stricmp(sz_ordre,"tempos")==0)  // tempos 10  (10s)
        {
            if(fscanf(pf," %d",&delay)==EOF) break;
            //printf(" tempos=%d\n",delay);
            auto_list[auto_list_next++]=AUTO_ORDRE_TEMPOS;
            auto_list[auto_list_next++]=delay;
        }

        if(stricmp(sz_ordre,"sethm")==0)  // sethm <h> <m>
        {
            if(fscanf(pf," %d",&h)==EOF) break;
            if(fscanf(pf," %d",&m)==EOF) break;
            auto_list[auto_list_next++]=AUTO_ORDRE_SETHM;
            auto_list[auto_list_next++]=h;
            auto_list[auto_list_next++]=m;
        }

        if(stricmp(sz_ordre,"waithm")==0)  // sethm <h> <m>
        {
            if(fscanf(pf," %d",&h)==EOF) break;
            if(fscanf(pf," %d",&m)==EOF) break;
            auto_list[auto_list_next++]=AUTO_ORDRE_WAITHM;
            auto_list[auto_list_next++]=h;
            auto_list[auto_list_next++]=m;
        }

        /*---- bal ----*/

        if(stricmp(sz_ordre,"bal_init")==0)  // bal_init <loco> <cant>    liberation si loco = -1 //UU: ajouter bal_lib + serieux
        {
            if(fscanf(pf," %d",&loco)==EOF) break;
            if(fscanf(pf," %d",&cant)==EOF) break;
            auto_list[auto_list_next++]=AUTO_ORDRE_BAL_INIT;
            auto_list[auto_list_next++]=loco;
            auto_list[auto_list_next++]=cant;
        }

        // bal[v][a] { iti<0-999|-1|X> c<canton> in<no_in> [+] } fin
        //
        // DEPL_ORDRE_BAL
        // 000000.V.A
        //    iti (-1 pas d'iti)
        //    canton
        //    in
        //    0000000.res_next
        // -2
        if(stricmp(sz_ordre,"bal")==0 || stricmp(sz_ordre,"balv")==0 || stricmp(sz_ordre,"bala")==0 ||stricmp(sz_ordre,"balva")==0)
        {
            auto_list[auto_list_next++]=AUTO_ORDRE_BAL;
            auto_list[auto_list_next]=0;
            if(stricmp(sz_ordre,"balv")==0) auto_list[auto_list_next]|=2;
            if(stricmp(sz_ordre,"bala")==0) auto_list[auto_list_next]|=1;
            if(stricmp(sz_ordre,"balva")==0) auto_list[auto_list_next]|=3;
            auto_list_next++;

            while(1)
            {
                if(fscanf(pf," %s",str)==EOF) break;

                if(stricmp(str,"fin")==0) break;
                if(stricmp(str,".")==0) break;
                if(stricmp(str,"x")==0) break;

                if(strnicmp(str,"iti",3)==0)  //itineraire
                {
                    if(str[3]>='0' && str[3]<='9') val=atoi(&str[3]); else val=-1;
                    auto_list[auto_list_next]=val;  //iti
                    auto_list[auto_list_next]=-1;   //pas de canton
                    auto_list[auto_list_next]=-1;   //pas de in
                    auto_list[auto_list_next]=0;    //pas de res suivant
                }

                if(strnicmp(str,"c",1)==0)  //canton
                {
                    if(str[1]>='0' && str[1]<='9') val=atoi(&str[1]); else val=-1;
                    auto_list[auto_list_next-3]=val;
                }

                if(strnicmp(str,"in",2)==0) //za in
                {
                    if(str[2]>='0' && str[2]<='9') val=atoi(&str[2]); else val=-1;
                    auto_list[auto_list_next-2]=val;
                }
                if(strnicmp(str,"led",3)==0) //za led
                {
                    if(str[3]>='0' && str[3]<='9') val=atoi(&str[3]); else val=-1;
                    auto_list[auto_list_next-2]=val;
                }

                if(strnicmp(str,"+",1)==0) //res
                {
                    auto_list[auto_list_next-1]=1;
                }
            }

            auto_list[auto_list_next++]=-2; //pas de in
        }

        if(stricmp(sz_ordre,"bal_max")==0)  // max <vit_absolue>
        {
            if(fscanf(pf," %d",&vit)==EOF) break;
            if(vit<0) vit=0-vit; if(vit>31) vit=31;
            auto_list[auto_list_next++]=AUTO_ORDRE_BAL_MAX;
            auto_list[auto_list_next++]=vit;
        }

        if(stricmp(sz_ordre,"bal_ral")==0)  // max <vit_absolue>
        {
            if(fscanf(pf," %d",&vit)==EOF) break;
            if(vit<0) vit=0-vit; if(vit>31) vit=31;
            auto_list[auto_list_next++]=AUTO_ORDRE_BAL_RAL;
            auto_list[auto_list_next++]=vit;
        }

        /*---- communication utilisateur ----*/

        if(stricmp(sz_ordre,"echo")==0)  // echo "blabla...."
        {
            auto_list[auto_list_next++]=AUTO_ORDRE_ECHO;
            fscanf(pf," %c",&c); // remove first \"
            while(1)
            {
                if(fscanf(pf,"%c",&c)==EOF) break;
                //printf("%c",c);
                if(c=='\"') c='\0';
                auto_list[auto_list_next++]=c;
                if(c=='\0') break;
            }
        }

        if(stricmp(sz_ordre,"sound")==0)  // sound "c:\...."
        {
            auto_list[auto_list_next++]=AUTO_ORDRE_SOUND;
            fscanf(pf," %c",&c); // remove first \"
            while(1)
            {
                if(fscanf(pf,"%c",&c)==EOF) break;
                //printf("%c",c);
                if(c=='\"') c='\0';
                auto_list[auto_list_next++]=c;
                if(c=='\0') break;
            }
            //ShellExecute(NULL,"open",sz_sound, NULL, NULL, SW_SHOWNA);
        }

    }

    fclose(pf);

    // 3. verification des structures
    pf=fopen("fdcc_conf_seq_verif.txt","wt");
    if(pf==NULL) { fprintf(pf,"\nCannot open fdcc_conf_seq.txt\nBye\n\n"); exit(1); }
    fprintf(pf,"\n- AUTO_LIST (nb=%d)",auto_list_next);  for(i=0;i<AUTO_LIST_NB;i++) fprintf(pf,"\n%d %d %c",i,auto_list[i],auto_list[i]);
    fprintf(pf,"\n- PROG_INDEX"); for(i=0;i<AUTO_PROG_NB;i++) fprintf(pf,"\n%d %d",i,auto_prog_index[i]);
    fprintf(pf,"\n- EXE"); for(i=0;i<EXE_NB;i++) { fprintf(pf,"\n%d: ",i); for(j=0;j<10;j++) fprintf(pf,"%d ",exe[i][j]); }

    return 0;
}


/* buffers d'affichage */

#define AUTO_DISP_NB_LINE 50
char auto_disp[AUTO_DISP_NB_LINE][200];
int  auto_disp_next_line;

void auto_disp_clr(void)
{
    int i;

    for(i=0;i<AUTO_DISP_NB_LINE;i++) auto_disp[i][0]='\0';
    auto_disp_next_line=0;
}

void auto_disp_print(int e, char* sz)
{
    char sz2[1000];

    sprintf(sz2,"%05d PG%d(CH%d): %s",auto_cpt,exe[e][EXE_PROG],e,sz);
    strcpy(auto_disp[auto_disp_next_line],sz2);
    auto_disp_next_line=(auto_disp_next_line+1)%AUTO_DISP_NB_LINE;

    fprintf(p_err,"\n%s",sz2);
}

char* auto_disp_get_str_line(int e, int line)
{
    return auto_disp[(line+auto_disp_next_line)%AUTO_DISP_NB_LINE];
}


/* init (lancement d'un script) */

int auto_on=0;
int auto_en_cours=0;

int start_depl(int prog);

int auto_init(void)
{
    int i;

    // 5. init
    reset_rs232_adr_cmd_fct();
    auto_cpt=0;

    auto_disp_clr();

    for(i=0;i<BAL_CANT_NB;i++)
    {
        bal_cant[i][BAL_CANT_TR]=0;
        bal_cant[i][BAL_CANT_VIT]=0;
        bal_cant[i][BAL_CANT_VIT_TYPE]=BAL_CANT_VIT_TYPE_ZERO;
        bal_cant[i][BAL_CANT_OLD]=0;
    }
    for(i=0;i<EXE_NB;i++) { exe[i][EXE_BAL_MAX]=20; exe[i][EXE_BAL_RAL]=10; exe[i][EXE_IN_FCT]=0; }

    start_depl(0); //demarrer le programme 0 automatiquement

    auto_on=1;
    auto_en_cours=1;
}

/* tick (execution d'un script a appeller toutes les 250ms) */

void auto_tick(void)
{
    int ordre, i, j, e, vit, aig, cmd, fct, var, val, msk, loco=0, ok, ch, board, on_nb, ec, ret, br;
    int bal_step, num_iti, cant, in, num_iti_next, cant_next, ral, vmax, vral, za, vit_ctrl, aig_ctrl, cant_pre_res;
    char sz_sound[1000]; char szTemp[1000]; char sz[100];
    char c;
    static int att=0;
    FILE* pf;


    if(auto_on==0) return;

    auto_cpt++;
    fprintf(p_err,"\nauto_cpt=%d",auto_cpt);

    on_nb=0; for(e=0;e<EXE_NB;e++) if(exe[e][EXE_PROG]!=-1) on_nb++;
    if(on_nb==0) { /*auto_on=0;*/ auto_en_cours=0; return; }

    #define EPTR exe[e][EXE_PTR]
    for(e=0;e<EXE_NB;e++) if(exe[e][EXE_PROG]!=-1) //pour tous les executeurs actifs
    {
        if(exe[e][EXE_WAIT]!=-1) exe[e][EXE_WAIT]--;

        while(1)
        {
            ordre=auto_list[EPTR];

            fprintf(p_err,"\nCH%d ordre=%d +1=%d +2=%d",e,auto_list[EPTR],auto_list[EPTR+1],auto_list[EPTR+2]);

            /*---- prog ----*/

            if(ordre==AUTO_ORDRE_PROG || ordre==AUTO_ORDRE_FREE)
            {
                if(exe[e][EXE_WAIT]==-1)
                {
                    exe[e][EXE_WAIT]=8; // 2sec
                    if(exe[e][EXE_CH]!=-1)
                    {
                        rs232_cmd[exe[e][EXE_CH]]=0x60; //loco stop
                        rs232_fct[exe[e][EXE_CH]]=0x90; //fct FL
                    }
                }
                if(exe[e][EXE_WAIT]==4)
                {
                    if(exe[e][EXE_CH]!=-1) rs232_adr[exe[e][EXE_CH]]=0; //liberation de la locomotive
                }
                if(exe[e][EXE_WAIT]==0)
                {
                    if(exe[e][EXE_CH]!=-1)
                    {
                        mouse_auto[exe[e][EXE_CH]]=0;
                        exe[e][EXE_CH]=-1;
                    }
                    exe[e][EXE_LOCO]=-1;
                    sprintf(szTemp,"END SCRIPT"); auto_disp_print(e,szTemp);
                    exe[e][EXE_PROG]=-1;
                }
                break;
            }

            if(ordre==AUTO_ORDRE_RUN)
            {
                sprintf(szTemp,"RUN PROG %d",auto_list[EPTR+1]); auto_disp_print(e,szTemp);
                if(start_depl(auto_list[EPTR+1])>=0) EPTR+=2;
                break;
            }

            if(ordre==AUTO_ORDRE_ENDRUN)
            {
                ec=0; for(e=0;e<EXE_NB;e++) if(exe[e][EXE_PROG]==auto_list[EPTR+1]) ec=1;
                if(ec==0)
                {
                    sprintf(szTemp,  "ENDRUN PROG%d ok",auto_list[EPTR+1]); auto_disp_print(e,szTemp);
                    EPTR+=2;
                }
                break;
            }

            if(ordre==AUTO_ORDRE_RUNWAIT)
            {
                if(exe[e][EXE_END_RUN]==-1)
                {
                    sprintf(szTemp,"RUNWAIT PROG %d",auto_list[EPTR+1]); auto_disp_print(e,szTemp);
                    ret=start_depl(auto_list[EPTR+1]);
                    if(ret>=0) exe[e][EXE_END_RUN]=ret;
                    break;
                }
                else
                {
                    ec=0; for(e=0;e<EXE_NB;e++) if(exe[e][EXE_PROG]==auto_list[EPTR+1]) ec=1;
                    if(ec==0)
                    {
                        sprintf(szTemp,  "ENDWAITRUN PROG%d ok",auto_list[EPTR+1]);
                        auto_disp_print(e,szTemp);
                        EPTR+=2;
                        exe[e][EXE_END_RUN]=-1;
                    }
                }
                break;
            }

            /*---- loco ----*/

            if(ordre==AUTO_ORDRE_LOCO)
            {
                loco=auto_list[EPTR+1];
                for(i=0;i<EXE_NB;i++) if(i!=e) if(exe[i][EXE_LOCO]==loco) break;       //loco deja utilisee par un deplacement
                for(i=0;i<EXE_NB;i++) if(i!=e) if(rs232_adr[i]    ==loco) break;       //loco deja utilisee par un regulateur
                // si on est ici, la locomotive n'est pas utilisee ailleur.
                exe[e][EXE_LOCO]=loco;
                sprintf(szTemp, "loco=%d",loco);  auto_disp_print(e,szTemp);

                // trouver un canal libre
                if(exe[e][EXE_CH]==-1)
                for(ch=15;ch>=0;ch--) if(mouse_centrale[ch]==0) if(mouse_auto[ch]==0) if(rs232_adr[ch]==0)
                {
                    exe[e][EXE_CH]=ch;
                    mouse_auto[ch]=1;     //UU   =e
                    break;
                }
                if(exe[e][EXE_CH]==-1) break;

                rs232_cmd[exe[e][EXE_CH]]=0x60;  //initialisation loco stop
                rs232_fct[exe[e][EXE_CH]]=0x90;  //initialisation fct FL
                rs232_adr[exe[e][EXE_CH]]=loco;  //prise de control de la locomotive
                EPTR+=2;
                continue;
            }

            if(ordre==AUTO_ORDRE_VIT)
            {
                vit=auto_list[EPTR+2];
                c=(char)auto_list[EPTR+1];
                sprintf(szTemp, "vit= %c %d",c,vit); auto_disp_print(e,szTemp);
                cmd=(vit>>1)&0x0f;
                if(vit&1) cmd|=0x10;
                if(c=='+') cmd|=0x20;
                cmd|=0x40;
                rs232_cmd[exe[e][EXE_CH]]=cmd;
                EPTR+=3;
                continue;
            }

            if(ordre==AUTO_ORDRE_FCT)
            {
                fct=auto_list[EPTR+1];
                val=auto_list[EPTR+2];
                sprintf(szTemp, "fct(%d)=%d",fct,val); auto_disp_print(e,szTemp);
                msk=(1<<fct); if(msk&1) msk|=0x20; msk>>1;   //F0-F4.3.2.1
                rs232_fct[exe[e][EXE_CH]]&=(0xff^msk);
                if(val) rs232_fct[exe[e][EXE_CH]]|=msk;
                EPTR+=3;
                continue;
            }

            /*---- aig/iti ----*/

            if(ordre==AUTO_ORDRE_AIG)
            {
                if(exe[e][EXE_IN_FCT]==0)
                {
                    sprintf(szTemp,"aig ");
                    i=0; while((aig=auto_list[EPTR+1+2*i]%1000)!=-1)
                    {
                        board =auto_list[EPTR+1+2*i]/1000;
                        c=(char)auto_list[EPTR+2+2*i];
                        sprintf(szTemp,"%s %d%c",szTemp,1000*board+aig,c);
                        i++;
                    }
                    auto_disp_print(e,szTemp);
                    exe[e][EXE_IN_FCT]=1;
                }

                //1. wait not res by ext
                br=0; i=0; while((aig=auto_list[EPTR+1+2*i]%1000)!=-1)
                {
                    board =auto_list[EPTR+1+2*i]/1000;
                    c=(char)auto_list[EPTR+2+2*i];
                    if(ivar_res[board][aig]!=0 && ivar_res[board][aig]!=(200000+exe[e][EXE_PROG])) { br=1; break; }
                    i++;
                }
                if(br) break;

                //2. pos
                i=0; while((aig=auto_list[EPTR+1+2*i]%1000)!=-1)
                {
                    board =auto_list[EPTR+1+2*i]/1000;
                    c=(char)auto_list[EPTR+2+2*i];
                    if(c=='-') var_aigcmd[board][aig]=0;
                    if(c=='/') var_aigcmd[board][aig]=1;
                    i++;
                }

                //3. check pos      var_pos
                br=0; i=0; while((aig=auto_list[EPTR+1+2*i]%1000)!=-1)
                {
                    board =auto_list[EPTR+1+2*i]/1000;
                    c=(char)auto_list[EPTR+2+2*i];
                    if(c=='-') if(var_pos0[board][aig]==0) { br=1; break; }
                    if(c=='/') if(var_pos1[board][aig]==0) { br=1; break; }
                    i++;
                }
                if(br) break;

                sprintf(szTemp, "aig ok"); auto_disp_print(e,szTemp);
                EPTR+=2+2*i;
                exe[e][EXE_IN_FCT]=0;
                continue;
            }

            if(ordre==AUTO_ORDRE_AIGRES)
            {
                if((aig=auto_list[EPTR+1]%1000)==-2) //lib all aigs
                {
                    for(board=0;board<4;board++) for(aig=0;aig<40;aig++) if(ivar_res[board][aig]==(200000+exe[e][EXE_PROG])) ivar_res[board][aig]=0;
                    sprintf(szTemp, "aig lib * ok"); auto_disp_print(e,szTemp);
                    EPTR+=3;  //order -2 -1
                    continue;
                }

                if(exe[e][EXE_IN_FCT]==0)
                {
                    sprintf(szTemp,"aig res");
                    i=0; while((aig=auto_list[EPTR+1+2*i]%1000)!=-1)
                    {
                        board =auto_list[EPTR+1+2*i]/1000;
                        c=(char)auto_list[EPTR+2+2*i];
                        sprintf(szTemp,"%s %d%c",szTemp,1000*board+aig,c);
                        i++;
                    }
                    auto_disp_print(e,szTemp);
                    exe[e][EXE_IN_FCT]=1;
                }

                //1. wait not res by ext
                br=0; i=0; while((aig=auto_list[EPTR+1+2*i]%1000)!=-1)
                {
                    board =auto_list[EPTR+1+2*i]/1000;
                    c=(char)auto_list[EPTR+2+2*i];
                    if(ivar_res[board][aig]!=0 && ivar_res[board][aig]!=(200000+exe[e][EXE_PROG])) { br=1; break; }
                    i++;
                }
                if(br) break;

                //2. res or lib
                i=0; while((aig=auto_list[EPTR+1+2*i]%1000)!=-1)
                {
                    board =auto_list[EPTR+1+2*i]/1000;
                    c=(char)auto_list[EPTR+2+2*i];
                    if(c=='-' || c=='/' ||c=='R' ) ivar_res[board][aig]=200000+exe[e][EXE_PROG];
                    if(c=='L'                    ) if(ivar_res[board][aig]==(200000+exe[e][EXE_PROG])) ivar_res[board][aig]=0;
                    i++;
                }

                //2. pos
                i=0; while((aig=auto_list[EPTR+1+2*i]%1000)!=-1)
                {
                    board =auto_list[EPTR+1+2*i]/1000;
                    c=(char)auto_list[EPTR+2+2*i];
                    if(c=='-') var_aigcmd[board][aig]=0;
                    if(c=='/') var_aigcmd[board][aig]=1;
                    i++;
                }

                //3. check pos      var_pos
                br=0; i=0; while((aig=auto_list[EPTR+1+2*i]%1000)!=-1)
                {
                    board =auto_list[EPTR+1+2*i]/1000;
                    c=(char)auto_list[EPTR+2+2*i];
                    if(c=='-') if(var_pos0[board][aig]==0) { br=1; break; }
                    if(c=='/') if(var_pos1[board][aig]==0) { br=1; break; }
                    i++;
                }
                if(br) break;

                sprintf(szTemp, "aig res ok"); auto_disp_print(e,szTemp);
                EPTR+=2+2*i;
                exe[e][EXE_IN_FCT]=0;
                continue;
            }

            if(ordre==AUTO_ORDRE_AIGWAIT)
            {
                if(exe[e][EXE_IN_FCT]==0)
                {
                    sprintf(szTemp,"aig wait");
                    i=0; while((aig=auto_list[EPTR+1+2*i]%1000)!=-1)
                    {
                        board =auto_list[EPTR+1+2*i]/1000;
                        c=(char)auto_list[EPTR+2+2*i];
                        sprintf(szTemp,"%s %d%c",szTemp,1000*board+aig,c);
                        i++;
                    }
                    auto_disp_print(e,szTemp);
                    exe[e][EXE_IN_FCT]=1;
                }

                br=0; i=0; while((aig=auto_list[EPTR+1+2*i]%1000)!=-1)
                {
                    board =auto_list[EPTR+1+2*i]/1000;
                    c=(char)auto_list[EPTR+2+2*i];
                    if(c=='-') if(var_pos0[board][aig]==0) { br=1; break; }
                    if(c=='/') if(var_pos1[board][aig]==0) { br=1; break; }
                    i++;
                }
                if(br) break;

                sprintf(szTemp, "aig wait ok"); auto_disp_print(e,szTemp);
                EPTR+=2+2*i;
                exe[e][EXE_IN_FCT]=0;
                continue;
            }

            /*---- entees/sorties ----*/

            if(ordre==AUTO_ORDRE_OUT)
            {
                //var_out[auto_list[EPTR+1]&31]=auto_list[EPTR+2]&1;
                sprintf(sz,"o%d",auto_list[EPTR+1]); set_var_str(sz,auto_list[EPTR+2]&1);
                sprintf(szTemp, "OUT%d=%d",auto_list[EPTR+1],auto_list[EPTR+2]); auto_disp_print(e,szTemp);
                EPTR+=3;
                continue;
            }

            if(ordre==AUTO_ORDRE_LED)
            {
                //var_led[auto_list[EPTR+1]&63]=auto_list[EPTR+2]&1;
                sprintf(sz,"l%d",auto_list[EPTR+1]); set_var_str(sz,auto_list[EPTR+2]&1);
                sprintf(szTemp, "LED%d=%d",e,auto_list[EPTR+1],auto_list[EPTR+2]); auto_disp_print(e,szTemp);
                EPTR+=3;
                continue;
            }

            if(ordre==AUTO_ORDRE_CLI)
            {
                //var_cli[auto_list[EPTR+1]&63]=auto_list[EPTR+2]&1;
                sprintf(sz,"c%d",auto_list[EPTR+1]); set_var_str(sz,auto_list[EPTR+2]&1);
                sprintf(szTemp, "CLI%d=%d",auto_list[EPTR+1],auto_list[EPTR+2]); auto_disp_print(e,szTemp);
                EPTR+=3;
                continue;
            }

            if(ordre==AUTO_ORDRE_WAITIN)
            {
                in=auto_list[EPTR+1];
                if(exe[e][EXE_IN]==-1)
                {
                    exe[e][EXE_IN]=in;
                    sprintf(szTemp, "wait_in=%d",in);
                    auto_disp_print(e,szTemp);
                }
                //if(var_in[in])
                sprintf(sz,"i%d",in);
                if(get_var_str(sz)==1);
                {
                    exe[e][EXE_IN]=-1;
                    sprintf(szTemp, "wait_in=%d ok",in); auto_disp_print(e,szTemp);
                    EPTR+=2;
                    //continue;
                    break; // si plusieurs tests, 1 test chaque tic (pratique en capteur de courant en refoulement sur les voies de garage
                }
                break;
            }

            if(ordre==AUTO_ORDRE_WAITNOTIN)
            {
                in=auto_list[EPTR+1];
                if(exe[e][EXE_NOTIN]==-1)
                {
                    exe[e][EXE_NOTIN]=in;
                    sprintf(szTemp, "wait_not_in=%d",auto_cpt,exe[e][EXE_PROG],e,in); auto_disp_print(e,szTemp);
                }
                //if(var_in[in]==0)
                sprintf(sz,"i%d",in);
                if(get_var_str(sz)==0);
                {
                    exe[e][EXE_NOTIN]=-1;
                    sprintf(szTemp, "wait_not_in=%d ok",in); auto_disp_print(e,szTemp);
                    EPTR+=2;
                    //continue;
                    break;
                }
                break;
            }

            /*---- temps ----*/

            if(ordre==AUTO_ORDRE_TEMPOS)
            {
                if(exe[e][EXE_WAIT]==-1)
                {
                    exe[e][EXE_WAIT]=4*auto_list[EPTR+1];
                    sprintf(szTemp, "TEMPO=%d",exe[e][EXE_WAIT]); auto_disp_print(e,szTemp);
                }
                if(exe[e][EXE_WAIT]==0)  EPTR+=2;
                break;
            }

            if(ordre==AUTO_ORDRE_TEMPOT)
            {
                if(exe[e][EXE_WAIT]==-1)
                {
                    exe[e][EXE_WAIT]=auto_list[EPTR+1];
                    sprintf(szTemp, "tempo=%d",exe[e][EXE_WAIT]); auto_disp_print(e,szTemp);
                }
                if(exe[e][EXE_WAIT]==0)  EPTR+=2;
                break;
            }

            if(ordre==AUTO_ORDRE_SETHM)
            {
                horo_h=auto_list[EPTR+1];
                horo_m=auto_list[EPTR+2];
                sprintf(szTemp, "SEQ SETHM %d %d", auto_list[EPTR+1], auto_list[EPTR+2]); auto_disp_print(e,szTemp);
                EPTR+=3;
                continue;
            }

            if(ordre==AUTO_ORDRE_WAITHM)
            {
                if(att==0) // pour afficher seulement une fois
                {
                    sprintf(szTemp, "SEQ WAITHM %d %d", auto_list[EPTR+1], auto_list[EPTR+2]); auto_disp_print(e,szTemp);
                }
                if((horo_h==auto_list[EPTR+1]) && (horo_m==auto_list[EPTR+2]))
                {
                    att=0;
                    EPTR+=3;
                    continue;
                }
                att=1;
                break;
            }

            /*---- bal ----*/

            if(ordre==AUTO_ORDRE_BAL_INIT)
            {
                sprintf(szTemp, "BAL INIT ..."); auto_disp_print(e,szTemp);
                if(bal_cant[auto_list[EPTR+2]][BAL_CANT_TR]!=0) break;
                if(bal_cant[auto_list[EPTR+2]][BAL_CANT_VER_MANU]!=0) break;
                bal_cant[auto_list[EPTR+2]][BAL_CANT_TR]=auto_list[EPTR+1];
                bal_cant[auto_list[EPTR+2]][BAL_CANT_VIT]=0;
                bal_cant[auto_list[EPTR+2]][BAL_CANT_VIT_TYPE]=BAL_CANT_VIT_TYPE_ZERO;

                sprintf(szTemp, "BAL INIT loco=%d cant=%d",auto_list[EPTR+1],auto_list[EPTR+2]); auto_disp_print(e,szTemp);
                EPTR+=3;
                continue;
            }

            if(ordre==AUTO_ORDRE_BAL_MAX)
            {
                exe[e][EXE_BAL_MAX]=auto_list[EPTR+1];
                sprintf(szTemp, "CH%d BAL_MAX=%d",e,auto_list[EPTR+1]); auto_disp_print(e,szTemp);
                EPTR+=2;
                continue;
            }

            if(ordre==AUTO_ORDRE_BAL_RAL)
            {
                exe[i][EXE_BAL_RAL]=auto_list[EPTR+1];
                sprintf(szTemp, "CH%d BAL_RAL=%d",e,auto_list[EPTR+1]); auto_disp_print(e,szTemp);
                EPTR+=2;
                continue;
            }

            /*
                ALGO

                init:
                    - si canton pas libre (ou pas reserver pour notre loco) -> fin
                    - si canton verouille en manuel -> fin
                    - si aiguillages d'acces au canton pas libres (ou pas reserves pour notre canton) -> fin

                    - mettre les autres cantons possedant la locomotive en OLD
                    - reserver le canton
                    - reserver les aiguillages
                    - demander de positionner les aiguillages
                    - si aiguillages pas positionnes -> fin

                prise en charge:
                    - ral = 0
                    - si canton suivant pas libre -> ral = 1
                    - si canton suivant en manuel -> ral = 1
                    - si aiguillages d'acces au canton suivants pas libres (ou pas reserves pour notre canton) -> ral = 1
                    - sinon les reserver et demander de les poitionner
                    - si aiguillages d'acces au canton suivants pas en position -> ral = 1
                    - si ral == 1 vit=RAL sinon vit=MAX

                    - si zone d'arret
                        - si ral == 1 vit=0
                        - dereserver les cantons OLD de cette locomotive
                        - dereserver les aiguillages d'acces au canton (pas ceux d'acces au canton suivant)
                        - fin de l'instruction
            */
            if(ordre==AUTO_ORDRE_BAL)  // UU: penser a implementer ma res des autres cantons
            {
                bal_step=exe[e][EXE_BAL_STEP];

                num_iti = auto_list[EPTR+2+4*bal_step];
                cant    = auto_list[EPTR+2+4*bal_step+1];
                in      = auto_list[EPTR+2+4*bal_step+2];
                num_iti_next=cant_next=-1;
                if(auto_list[EPTR+2+4*(bal_step+1)]!=-2)
                {
                    num_iti_next = auto_list[EPTR+2+4*(bal_step+1)];
                    cant_next    = auto_list[EPTR+2+4*(bal_step+1)+1];
                }
                loco=exe[e][EXE_LOCO];
                vmax=exe[e][EXE_BAL_MAX];
                vral=exe[e][EXE_BAL_RAL];
                if(auto_list[EPTR+1]&2) vit_ctrl=1; else vit_ctrl=0;
                if(auto_list[EPTR+1]&1) aig_ctrl=1; else aig_ctrl=0;

                sprintf(szTemp, "CH%d EPTR=%d step=%d bal%d%d iti=%d cant_depl=%d in_fin=%d iti_num_next=%d cant_next=%d",e,EPTR,bal_step,vit_ctrl,aig_ctrl,num_iti,cant,in,num_iti_next,cant_next);
                auto_disp_print(e,szTemp);

                /* 1. Le train n'est pas encore pris en charge sur le canton */
                if(bal_cant[cant][BAL_CANT_TR]!=loco) //pas notre loco donc init
                {
                    //arret de la locomotive
                    rs232_cmd[15-e]&=0xe0;
                    //verif canton libre
                    if(bal_cant[cant][BAL_CANT_TR]!=0)  break; // canton pas libre;
                    if(bal_cant[cant][BAL_CANT_VER_MANU]!=0) break; // canton en manuel
                    if(bal_cant[cant][BAL_CANT_PRE_RES]!=0) if(bal_cant[cant][BAL_CANT_PRE_RES]!=loco) break;  //cantons reserve par un autre train
                    j=0; while(auto_list[EPTR+2+4*(bal_step+j)+3])
                    {
                        cant_pre_res=auto_list[EPTR+2+4*(bal_step+j+1)+1];
                        if(bal_cant[cant_pre_res][BAL_CANT_PRE_RES]!=0) if(bal_cant[cant_pre_res][BAL_CANT_PRE_RES]!=loco) break;  //cantons suivants reserve par un autre train
                        j++;
                    }

                    //etablissement de l'itineraire et attendte etablissement
                    if(bal_iti_res_pos(aig_ctrl,num_iti)==0) break;

                    //on y va
                    bal_cant[cant][BAL_CANT_TR]=loco;
                    bal_cant[cant][BAL_CANT_OLD]=0;
                    bal_cant[cant][BAL_CANT_PRE_RES]=0;
                    for(i=0;i<BAL_CANT_NB;i++) if(i!=cant) if(bal_cant[i][BAL_CANT_TR]==loco) bal_cant[i][BAL_CANT_OLD]=1; //ancien canton courant devient vieux
                    j=0; while(auto_list[EPTR+2+4*(bal_step+j)+3])
                    {
                        cant_pre_res=auto_list[EPTR+2+4*(bal_step+j+1)+1];
                        bal_cant[cant_pre_res][BAL_CANT_PRE_RES]=loco;
                        j++;
                    }
                    sprintf(szTemp, "CH%d bal%d%d GO iti=%d cant_depl=%d in_fin=%d iti_num_next=%d cant_next=%d",e,vit_ctrl,aig_ctrl,num_iti,cant,in,num_iti_next,cant_next);
                    auto_disp_print(e,szTemp);
                }

                /* 2. Le train est pris en charge sur le canton */
                ral=0;
                if(cant_next==-1) ral=1;
                else
                {
                    if(bal_cant[cant_next][BAL_CANT_TR ]!=0) ral=1;
                    if(bal_cant[cant_next][BAL_CANT_VER_MANU]!=0) ral=1;
                    if(bal_iti_res_pos(aig_ctrl,num_iti_next)==0) ral=1; //essaye de positionner les aiguillages pour aller sur le canton suivant
                }

                if(ral==0) { vit=vmax; bal_cant[cant][BAL_CANT_VIT_TYPE]=BAL_CANT_VIT_TYPE_MAX; }
                else       { vit=vral; bal_cant[cant][BAL_CANT_VIT_TYPE]=BAL_CANT_VIT_TYPE_RAL; }

                za=0; if(in==-1) za=1; else if(var_in[in/1000][in%1000]) za=1; //si sur section d'arret
                //fprintf(p_err,"\nza=%d rs232_in[0]=0x%02x,rs232_in[1]=0x%02x,in[12]=%d",za,rs232_in[0],rs232_in[1],var_in[12]);
                if(za)
                {
                    if(ral) { vit=0; bal_cant[cant][BAL_CANT_VIT_TYPE]=BAL_CANT_VIT_TYPE_ZERO; }

                    for(i=0;i<BAL_CANT_NB;i++) if(i!=cant) if(bal_cant[i][BAL_CANT_TR]==loco) //lib canton precedent
                    { bal_cant[i][BAL_CANT_TR]=0;  bal_cant[i][BAL_CANT_VIT]=0;  bal_cant[i][BAL_CANT_VIT_TYPE]=BAL_CANT_VIT_TYPE_ZERO; bal_cant[i][BAL_CANT_OLD]=0;}

                    bal_iti_unres(aig_ctrl,num_iti); //lib des aiguillages
                    bal_iti_res_pos(aig_ctrl,num_iti_next); //re-reservation des aiguillages communs (cas peu probable)

                    bal_step++; exe[e][EXE_BAL_STEP]++;
                    if(auto_list[EPTR+2+4*bal_step]==-2) { exe[e][EXE_BAL_STEP]=0; EPTR+=2+4*bal_step+1; za=2; }
                }

                bal_cant[cant][BAL_CANT_VIT]=vit;

                rs232_cmd[exe[e][EXE_CH]]&=0xe0;
                rs232_cmd[exe[e][EXE_CH]]|=vit2cmd(vit);

                sprintf(szTemp,"\nCH%d loco=%d vit=%d",e,loco,vit); auto_disp_print(e,szTemp);

                if(za==2) continue;
                break;

            }

            /*---- communication utilisateur ----*/

            if(ordre==AUTO_ORDRE_SOUND)
            {
                i=0;
                while(auto_list[EPTR+1+i]) { sz_sound[i]=(auto_list[EPTR+1+i]); i++; }
                sz_sound[i]='\0';
                EPTR+=(i+1+1);
                sprintf(szTemp, "SOUND:%s",sz_sound); auto_disp_print(e,szTemp);
                ShellExecute(NULL,"open",sz_sound, NULL, NULL, SW_SHOWNA);
                continue;
            }

            if(ordre==AUTO_ORDRE_ECHO)
            {
                i=0;
                while(auto_list[EPTR+1+i]) { sz_sound[i]=(auto_list[EPTR+1+i]); i++; }
                sz_sound[i]='\0';
                EPTR+=(i+1+1);
                sprintf(szTemp, "ECHO:%s",e,sz_sound); auto_disp_print(e,szTemp);
                continue;
            }

            /*---- unknown ordre ----*/

            break;

        }  // fin d'execution d'un canal d'execution (while 1)

    } // fin d'execution de tous les canaux auto (for e)

}





//retourne canal d'execution si ok. -1 si ko
int start_depl(int prog)
{
   int e;

   if(auto_prog_index[prog]==-1) return -2; //pas de programme existant

   for(e=0;e<EXE_NB;e++) if(exe[e][EXE_PROG]==prog) return -3; //programme deja en cours d'execution

   for(e=0;e<EXE_NB;e++) if(exe[e][EXE_PROG]==-1)
   {
       // si on est ici, au moins un canal d'execution est libre
       exe[e][EXE_PROG]=prog;
       exe[e][EXE_PTR]=auto_prog_index[prog]+2; //saute instruction de reperage deplacement;
       //exe[e][EXE_LOCO]; // sera fait et verifie plus loin
       exe[e][EXE_WAIT]=-1;

       return e;
   }
   return -1;
}

void start_depl_sz(char* sz)
{
   char* pt;
   int prog_no;
   int e;
   char szTemp[1000];

   if(auto_on==0) return;

   if((pt=strstr(sz,"prog:" ))==NULL) return;
   sscanf(pt+5," %d",&prog_no);

   if((e=start_depl(prog_no))==-1) return;

   fprintf(p_err,"\nTCO LAUNCH PROG%d on CH%d and WAIT",exe[e][EXE_PROG],e);
   sprintf(szTemp, "TCO LAUNCH PROG%d on CH%d and WAIT",exe[e][EXE_PROG],e);
   auto_disp_print(e,szTemp);
}

void auto_draw(void)
{
    int i,x0,y0;
    RECT rect;
    char szTemp[1000];

    SetBkMode(hdc_mem_tco,TRANSPARENT);
    //SetTextColor(hdc_mem_tco,RGB(0,0,255));
    SetTextColor(hdc_mem_tco,RGB(255,255,255));
    SelectObject(hdc_mem_tco,bmp_fonte);

    if(auto_en_cours) { bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_BLEU ); bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_BLEU ); } //fond
    else              { bmp_select_pen(hdc_mem_tco,BMP_CST_COLOR_ROUGE); bmp_select_brush(hdc_mem_tco,BMP_CST_COLOR_ROUGE); } //fond
    Rectangle(hdc_mem_tco,0,0,2000,1500);

    x0=20; y0=50;
    //sprintf(szTemp,"Sequenceur"); TextOut(hdc_mem_tco,x0,y0-20,szTemp,strlen(szTemp));
    sprintf(szTemp,"Horodateur J=%d %02d:%02d",horo_j,horo_h,horo_m); TextOut(hdc_mem_tco,x0+400,y0-20,szTemp,strlen(szTemp));

    x0=20; y0=50;
    for(i=0;i<AUTO_DISP_NB_LINE;i++)
    {
        sprintf(szTemp,"- %s ",auto_disp_get_str_line(0,i)); TextOut(hdc_mem_tco,x0,y0+15*i,szTemp,strlen(szTemp));
    }


/*for(i=0;i<AUTO_DISP_SEQ_NB;i++)     //UU: reactiver affichage
    {
        sprintf(szTemp,"- %s ",auto_disp_get_str_line(i)); TextOut(hdc_mem_tco,x0,y0+15*i,szTemp,strlen(szTemp));
    }

    //EasyLine(hdc_mem_tco,x0+30,y0+60,x0+30,y0+40); EasyLine(hdc_mem_tco,x0+30,y0+60,x0+20,y0+50); EasyLine(hdc_mem_tco,x0+30,y0+60,x0+40,y0+50);
    x0=20; y0=250;
    sprintf(szTemp,"Deplacements"); TextOut(hdc_mem_tco,x0,y0-20,szTemp,strlen(szTemp));
    for(i=0;i<EXE_NB;i++)
    {
        sprintf(szTemp,"auto:%d ch:%2d ",i,15-i); TextOut(hdc_mem_tco,x0,y0+15*i,szTemp,strlen(szTemp));
        if(exe[i][EXE_DEPL]!=-1)
        {
            sprintf(szTemp,"depl=%-3d loco=%-2d wait=%-2d wait_in=%-2d wait_not_in=%-2d"
                    ,exe[i][EXE_DEPL],exe[i][EXE_LOCO],exe[i][EXE_WAIT],exe[i][EXE_IN],exe[i][EXE_NOTIN]);

            TextOut(hdc_mem_tco,x0+120,y0+15*i,szTemp,strlen(szTemp));
        }
    }

    x0=600; y0=250;
    for(i=0;i<6;i++) {sprintf(szTemp,"c[%d]=loco_%d",i,bal_cant[i][BAL_CANT_TR]); TextOut(hdc_mem_tco,x0,y0+15*i,szTemp,strlen(szTemp));}

    x0=700; y0=250;
//    for(i=0;i<6;i++) {sprintf(szTemp,"%d",2*(rs232_cmd[15-i]&15)+((rs232_cmd[15-i]&16)>>4)); TextOut(hdc_mem_tco,x0,y0+15*i,szTemp,strlen(szTemp));}

    x0=20; y0=350;
    for(i=0;i<AUTO_DISP_DEPL_NB;i++)
    {
        sprintf(szTemp,"- %s ",auto_disp_depl_get_str_line(i)); TextOut(hdc_mem_tco,x0,y0+15*i,szTemp,strlen(szTemp));
    }
*/
    GetClientRect(hwnd,&rect);
    BitBlt(hdc,0,0,rect.right,rect.bottom,hdc_mem_tco,0,0,SRCCOPY);
}



/*****************************************************************************/
/* FIN DEPLACEMENTS AUTOMATIQUES                                             */
/*****************************************************************************/





/*****************************************************************************/
/* CONFIG GENERAL                                                            */
/*****************************************************************************/


char szLaunchDir[1000]="";
char szTcoConfigFile[1000]="";
char szTrainConfigFile[1000]="";
char szHelpFile[1000]="";
char szAutoFile[1000]="";
char szSimuConfigFile[1000]="";
char szItiConfigFile[1000]="";
#define SZ_TCO_FILE "tco_config.txt"
#define SZ_TDV_FILE "tdv_config.txt"
#define SZ_VAR_FILE "cfg_config.txt"
#define SZ_HLP_FILE "aide.doc"
#define SZ_TRAIN_FILE "train_config.txt"

char szReguSel[100];


BOOL SelectAutoFileOpen(void)
{
    OPENFILENAME ofn;
    BOOL status;

    ZeroMemory(&ofn, sizeof(ofn));
    szAutoFile[0] = '\0';  //UU:verifier sans

    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = hwnd;
    ofn.lpstrFilter = "Auto Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0";
    ofn.lpstrFile = szAutoFile;
    ofn.nMaxFile = MAX_PATH;
    ofn.lpstrDefExt = "txt";
    ofn.Flags = OFN_EXPLORER /*| OFN_FILEMUSTEXIST| OFN_HIDEREADONLY*/;

    status=GetOpenFileName(&ofn);

    SetCurrentDirectory(szLaunchDir); // pour ne pas modifier le repertoire courant

    return status;
}


int init_globvar(char szFilename[])
{
    FILE* pf;
    char c;
    int  comment,in,i,ok,phase;
    char sz[1000];
    char szVar[1000];
    char szVal[1000];
    char szTemp[1000];

    /* 2. Chargement */

    pf=fopen(szFilename,"rt");
    if(pf==NULL) return -1;

    in=comment=i=phase=0;sz[0]='\0';

    strcpy(sz_com0, "\\\\.\\COM0"); //COM0=non utilise
    strcpy(sz_com1, "\\\\.\\COM0");
    strcpy(sz_com2, "\\\\.\\COM0");
    strcpy(sz_com3, "\\\\.\\COM0");

    while( fscanf(pf,"%c",&c)!=EOF)
    {
        if(c=='#') comment=1;
        if(c=='\n' ||c=='\r') comment=0;
        if(comment) continue;

        if(c=='[')
        {
            fscanf(pf,"%s",sz);
            if(!stricmp(sz,"cfg]")) in=1; else in=0;
        }
        if(in==0) continue;

        sz[i]='\0';

        if(phase==0) if(c=='=') // commande complete
        {
            phase=1;
            strcpy(szVar,sz);
            i=0; sz[0]='\0';
        }
        if(phase==1) if(c=='\n' ||c=='\r') // data complete
        {
            phase=0;
            strcpy(szVal,sz);
            i=0; sz[0]='\0';

            ok=0;
            if(!stricmp(szVar,"rs232_0")) {ok=1; strcpy(&sz_com0[4],szVal); fprintf(p_err,"\ncfg port 0 = %s",sz_com0); }
            if(!stricmp(szVar,"rs232_1")) {ok=1; strcpy(&sz_com1[4],szVal); fprintf(p_err,"\ncfg port 1 = %s",sz_com1); }
            if(!stricmp(szVar,"rs232_2")) {ok=1; strcpy(&sz_com2[4],szVal); fprintf(p_err,"\ncfg port 2 = %s",sz_com2); }
            if(!stricmp(szVar,"rs232_3")) {ok=1; strcpy(&sz_com3[4],szVal); fprintf(p_err,"\ncfg port 3 = %s",sz_com3); }

            if(!stricmp(szVar,"horo_j_dep"  )) {ok=1; horo_j_dep=atoi(szVal);   fprintf(p_err,"\nj_dep = %d",horo_j_dep);  }
            if(!stricmp(szVar,"horo_h_dep"  )) {ok=1; horo_h_dep=atoi(szVal);   fprintf(p_err,"\nh_dep = %d",horo_h_dep);  }
            if(!stricmp(szVar,"horo_m_dep"  )) {ok=1; horo_m_dep=atoi(szVal);   fprintf(p_err,"\nm_dep = %d",horo_m_dep);  }
            if(!stricmp(szVar,"horo_tic_min")) {ok=1; horo_tic_min=atoi(szVal); fprintf(p_err,"\ntic_min = %d",horo_tic_min);}
            if(!stricmp(szVar,"horo_tic_on" )) {ok=1; horo_tic_on=atoi(szVal);  fprintf(p_err,"\ntic_on = %d",horo_tic_on); }

            if(!stricmp(szVar,"ch" ))
            {
                ok=1; strcpy(szReguSel,szVal);  fprintf(p_err,"\nch = %s",szReguSel);
                for(i=0;i<16;i++) if(szReguSel[i]=='c' || szReguSel[i]=='C') mouse_centrale[i]=1; else mouse_centrale[i]=0;
                for(i=0;i<16;i++) mouse_auto[i]=0;
            }

            if(!stricmp(szVar,"aff_regu"  )) {ok=1; tco_reg      =atoi(szVal);   fprintf(p_err, "\naff_regu = %d", tco_reg      ); }
            if(!stricmp(szVar,"aff_edit"  )) {ok=1; tco_edit     =atoi(szVal);   fprintf(p_err, "\naff_edit = %d", tco_edit     ); }
            if(!stricmp(szVar,"aff_horo"  )) {ok=1; tco_disp_horo=atoi(szVal);   fprintf(p_err, "\naff_horo = %d", tco_disp_horo); }
            if(!stricmp(szVar,"aff_grid"  )) {ok=1; disp_grid    =atoi(szVal);   fprintf(p_err, "\naff_grid = %d", disp_grid    ); }
            if(!stricmp(szVar,"aff_bal"   )) {ok=1; disp_bal     =atoi(szVal);   fprintf(p_err, "\naff_bal  = %d", disp_bal     ); }
            if(!stricmp(szVar,"aff_gros"  )) {ok=1; sel_gros     =atoi(szVal);   fprintf(p_err, "\naff_gros = %d", sel_gros     ); }
            if(!stricmp(szVar,"aff_vars"  )) {ok=1; disp_vars    =atoi(szVal);   fprintf(p_err, "\naff_vars = %d", disp_vars    ); }

            if(!stricmp(szVar,"zoom"  )) {ok=1; screen_zoom=atoi(szVal);   fprintf(p_err,"\nzoom = %d",screen_zoom);  }

            if(szVar[0]!='\0')
            if(ok==0) { sprintf(szTemp,"Erreur CFG Unknown var >%s< ><",szVar); MessageBox(NULL,szTemp,STR_FDCC_MSGBOX_TITLE,MB_OK); }
        }

        if( (c>='a' && c<='z') || (c>='A' && c<='Z') || (c>='0' && c<='9') || c=='_')
        {
            sz[i]=c; sz[i+1]='\0'; i++;
        }
    }

    fclose(pf);
}


/*------------------------------------------------------------------------------
NAME  : config_general_exit_if_no_file

DESCR : exit if the configuration file ne peut pas etre trouve

ARG   : char filename[]: nom du fichier de configuration

RETURN: void

NOTES :
------------------------------------------------------------------------------*/
void  config_general_exit_if_no_file(char filename[])
{
    FILE* pf;

    if((pf=fopen(filename,"rt"))==NULL)
    {
        MessageBox(NULL,STR_NO_CONFIG_FILE,STR_FDCC_MSGBOX_TITLE,MB_OK|MB_ICONERROR);
        exit(1);
    }
    fclose(pf);

}



/*****************************************************************************/
/* fin de CONFIG GENERAL                                                     */
/*****************************************************************************/


void horo_maj(void)
{
    //gestion de l'horloge
    if(horo_tic_on) // && blocked==0)
    {
        if(horo_tic_dec==0)
        {
             horo_tic_dec=horo_tic_min;
             horo_m++;
             if(horo_m>=60) {horo_m=0;  horo_h++;}
             if(horo_h>=24) {horo_h=0;  horo_j++;}
             if(horo_j>=7)  horo_j=0;
        }
        horo_tic_dec--;
    }
}

void horo_init(void)
{
    horo_j=horo_j_dep;
    horo_h=horo_h_dep;
    horo_m=horo_m_dep;
}



/*****************************************************************************/
/* WINDOWS                                                                   */
/*****************************************************************************/


#ifdef oldserial
cSerial   serial_card0;
cSerial   serial_card1;
cSerial   serial_card2;
cSerial   serial_card3;
#endif oldserial


cTdv      tdv;


/* Declare Windows procedure */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);


int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil)
{
    //HWND hwnd;               /* This is the handle for our window */  //now in gmobal
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    ghinstance=hThisInstance;

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "UTS_Train_Class";
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof(WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    //wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wincl.lpszMenuName = "MAINMENU"; /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use light-gray as the background of the window */
    wincl.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);

    /* Register the window class, if fail quit the program */
    if(!RegisterClassEx(&wincl)) return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx(
           0,                   /* Extended possibilites for variation */
           "UTS_Train_Class",   /* Classname */
           TITRE,               /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           800,                 /* The programs width */
           600,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow(hwnd, nFunsterStil);

    /* Run the message loop. It will run until GetMessage( ) returns 0 */
    while(GetMessage(&messages, NULL, 0, 0))
    {
           /* Translate virtual-key messages into character messages */
           TranslateMessage(&messages);
           /* Send message to WindowProcedure */
           DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage( ) gave */
    return messages.wParam;
}


LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    static int en_cours=0;
    char ch[100];
    char szAff[200];
    char szXY[20];
    char szDeconnectee[100];

    int i;
    int ret;
    int ok;
    static int first=1;

    hdc=GetDC(hwnd);
    switch (message)                  /* handle the messages */
    {
           case WM_CREATE :
                debug_file_open("debug.txt");
                font_pinceau_stylo_init();
                init_fonte_pen_brush();
                SetTimer(hwnd,1,250,NULL);
                screen_mode=MD_SCREEN_TCO0;
                GetCurrentDirectory(999,szLaunchDir);
                config_general_exit_if_no_file(SZ_VAR_FILE);
                sprintf(szHelpFile       ,"%s\\%s",szLaunchDir,SZ_HLP_FILE      );
                sprintf(szTcoConfigFile  ,"%s\\%s",szLaunchDir,SZ_TCO_FILE      ); tco_init(szTcoConfigFile);
                sprintf(szTrainConfigFile,"%s\\%s",szLaunchDir,SZ_TRAIN_FILE    ); tr_init(szTrainConfigFile);
                sprintf(szSimuConfigFile ,"%s\\%s",szLaunchDir,"simu_config.txt"); simu_load(szSimuConfigFile);
                sprintf(szItiConfigFile  ,"%s\\%s",szLaunchDir,"iti_config.txt" );  iti_init(szItiConfigFile);
                init_globvar(SZ_VAR_FILE); // a appeller avant rs232_init (car definit le port)
                tdv.init(SZ_TDV_FILE); //tdv.save_conf();
                rs232_init();
                horo_init();
                CreateWindow("EDIT", "",WS_BORDER | WS_CHILD | WS_VISIBLE | ES_WANTRETURN, 0, 0, 2000, 20, hwnd, (HMENU) 800 /*ID_MAIN_TEXT*/ , ghinstance, NULL);
                SendMessage(GetDlgItem(hwnd,800), WM_SETTEXT, 0, (LPARAM) "Tapez le texte ici");
                break;

           case WM_TIMER:

                if(wParam!=1)   break;
                if(en_cours==1) break;
                en_cours=1;

                tic_cpt++;

                rs232_tic();
                simu_tic();

                if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7) tco_draw();
                if(screen_mode==MD_SCREEN_AUTO) auto_draw();
                if(tco_edit==1) ShowWindow(GetDlgItem(hwnd,800 ),SW_SHOWNORMAL); else ShowWindow(GetDlgItem(hwnd,800 ), SW_HIDE);
                //EnableWindow(GetDlgItem(hwnd, 800), 1 );
                //SendMessage(GetDlgItem(hwnd,800), WM_GETTEXT, 500, (LPARAM) szText);
                //SendMessage(GetDlgItem(hwnd,800), WM_SETTEXT, 0, (LPARAM) szText);
                //SendMessage(GetDlgItem(hwnd,800), WM_PAINT, 0, 0);

                tdv.tick();
                iti_tic();
                if(auto_on) auto_tick();
                horo_maj();

                //if(rs232_initialized==1) sprintf(szDeconnectee,"(connecte-%s)",sz_com); else strcpy(szDeconnectee,"(mode deconnecte)");
                //sprintf(szAff,"%s - %s - %s -%s %d%d:%d%d j%d",TITRE,szDeconnectee,TabSzScreenMode[screen_mode],szXY,horo_h/10,horo_h%10,horo_m/10,horo_m%10,horo_j/*,horo_tic_dec*/);
                ////if(horo_blocked) strcat(szAff," b");
                ////if(horo_tic_on==0) strcat(szAff," off");
                ////if(horo_tic_dec&1) strcat(szAff," .");
 	    	    //SendMessage(hwnd , WM_SETTEXT, 0, (LPARAM) szAff);  //UU 31mar2004 : posait un pb de rafraichissement !
                //PostMessage(hwnd , WM_SETTEXT, 0, (LPARAM) szAff);  //marche pas
                en_cours=0;

                break;

           case WM_PAINT:
                // if(screen_mode==MD_SCREEN_CANTON)   canton.debug(DEBUG_TOTAL_PAINT);
                // if(screen_mode==MD_SCREEN_SERIAL)   serial_debug(DEBUG_TOTAL_PAINT);
                break;

           case WM_RBUTTONUP:
                x_mouse=LOWORD(lParam);
                y_mouse=HIWORD(lParam);
                break;

           case WM_RBUTTONDOWN:
                x_mouse=LOWORD(lParam);
                y_mouse=HIWORD(lParam);
                if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7) tco_mouse(DEBUG_MOUSE_RIGHT,x_mouse,y_mouse);
                break;

           case WM_LBUTTONUP:
                x_mouse=LOWORD(lParam);
                y_mouse=HIWORD(lParam);
                if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7) tco_mouse(DEBUG_MOUSE_UP,x_mouse,y_mouse);
                break;

           case WM_LBUTTONDOWN:
                x_mouse=LOWORD(lParam);
                y_mouse=HIWORD(lParam);
                if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7) tco_mouse(DEBUG_MOUSE,x_mouse,y_mouse);
                break;

           case WM_MOUSEMOVE:
                x_mouse_move=LOWORD(lParam);
                y_mouse_move=HIWORD(lParam);
                sprintf(szXY,"(x=%d,y=%d)",x_mouse_move,y_mouse_move);
                break;

           case WM_KEYDOWN:
                touche_no=wParam;
                if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7) tco_key(touche_no);
                break;

           case WM_KEYUP:
                tco_key_up();
                break;

           case WM_CHAR:
                touche_char=LOWORD(wParam);
                //if(screen_mode>=MD_SCREEN_TCO0 && screen_mode<=MD_SCREEN_TCO7) tco_char(touche_char);
                //if(screen_mode==MD_SCREEN_SERIAL)    serial_debug(DEBUG_KEY);
                //if( touche_char=='q' || touche_char=='Q') vio_srv_cmd[0][0]=32;
                if( touche_char=='d' || touche_char=='D') rs_debug^=1;
                if( touche_char>='0' || touche_char<='9') nb_0_99=(10*nb_0_99+touche_char-'0')%100;
                tco_char(touche_char); // + - / * .   //UU:re-activer
                simu_char(touche_char);
                break;

           case WM_DESTROY:
                tco_save(szTcoConfigFile);
                debug_file_close();
                PostQuitMessage(0);
                break;

           case WM_COMMAND:
                switch(LOWORD(wParam))
                {
                    case CM_EXIT            : PostQuitMessage(0); break;
                    case CM_SCREEN_TCO0     : screen_mode=MD_SCREEN_TCO0; tco_current=0; break;
                    case CM_SCREEN_TCO1     : screen_mode=MD_SCREEN_TCO1; tco_current=1; break;
                    case CM_SCREEN_TCO2     : screen_mode=MD_SCREEN_TCO2; tco_current=2; break;
                    case CM_SCREEN_TCO3     : screen_mode=MD_SCREEN_TCO3; tco_current=3; break;
                    case CM_SCREEN_TCO4     : screen_mode=MD_SCREEN_TCO4; tco_current=4; break;
                    case CM_SCREEN_TCO5     : screen_mode=MD_SCREEN_TCO5; tco_current=5; break;
                    case CM_SCREEN_TCO6     : screen_mode=MD_SCREEN_TCO6; tco_current=6; break;
                    case CM_SCREEN_TCO7     : screen_mode=MD_SCREEN_TCO7; tco_current=7; break;
                    case CM_SCREEN_REGU     : tco_reg^=1;                                break;
                    case CM_SCREEN_TCOEDIT  : tco_edit^=1;                               break;
                    case CM_SCREEN_HORO     : tco_disp_horo^=1;                          break;
                    case CM_SCREEN_ZOOM     : screen_zoom^=1;                            break;
                    case CM_SCREEN_GRID     : disp_grid^=1;                              break;
                    case CM_SCREEN_BAL      : disp_bal^=1;                               break;
                    case CM_SCREEN_BOLD     : sel_gros^=1;                               break;
                    case CM_SCREEN_VARS     : disp_vars^=1;                              break;
                    case CM_SCREEN_TCOSAVE  : tco_save(szTcoConfigFile);                 break;
                    case CM_SCREEN_AUTO     : screen_mode=MD_SCREEN_AUTO;                break;
                    case CM_CONFIG_EXEAUTO  : strcpy(szAutoFile,"auto_config.txt"); if(SelectAutoFileOpen()==FALSE) break;
                                              auto_file(szAutoFile); auto_init(); break;
                    case CM_CONFIG_STOPAUTO : auto_on=0; reset_rs232_adr_cmd_fct(); /*pour stopper locos */ break;
                    case CM_ABOUT           : MessageBox(NULL,STR_ABOUT,"About",MB_OK|MB_ICONINFORMATION);     break;
                    case CM_HELP            : ShellExecute(NULL,"open",szHelpFile, NULL, NULL, SW_SHOWNORMAL); break;
                    default                 : break;
                }
                PostMessage(hwnd,WM_PAINT,0,0);
                break;

           default:
                break;
    }
    ReleaseDC(hwnd,hdc);
    return DefWindowProc(hwnd, message, wParam, lParam);
}













